2023-07-08  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Version 1.14.1 (#813)

2023-06-22  Dimitry Andric  <dimitry@andric.com>

	Only use GNU specific strerror_r() API when __GLIBC__ is defined. (#791)

2023-06-12  Bao  <qubidt@gmail.com>

	TOML: support trailing commas (#809)
	* TOML: support trailing commas
	
	* TOML: trailing commas w/ comments

2023-05-10  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Fix bug from PR#691 where the nodes of a newly created file are lost upon a subsequent load operation (#810)

2023-03-24  Pino Toscano  <ptoscano@redhat.com>

	Tmpfiles: allow '=', '~', '^' for letter types, allow ":" as prefix for the mode
	* Tmpfiles: allow '=', '~', '^' for letter types
	
	Allow an equal sign, a tilde character and/or a caret for the type
	specification:
	- equal: strict file type enforcing
	- tilde: base64-encoded content in the argument
	- caret: credential name in the argument
	
	Fixes: #795
	
	* Tmpfiles: allow ":" as prefix for the mode
	
	Represents a mode to be set only for new inodes.

2023-03-13  Dave Re  <109117084+dave-re-imprivata@users.noreply.github.com>

	Update sshd lens for additional list (#806)

2023-03-09  Laszlo Ersek  <lersek@users.noreply.github.com>

	HACKING.md: describe testing (#796)
	The top-level HACKING document is inexplicably silent on how bugs can be
	reproduced/triggered and how fixes/features can be verified. That's an
	unnecessary difficulty for anyone new trying to contribute to augeas.
	
	Document "make check", and highlight the difference between "test-get.sh"
	and the individual lens tests under "lenses/tests/".
	
	Bugzilla: https://bugzilla.redhat.com/show_bug.cgi?id=2155147

2023-03-05  rwmjones  <rjones@redhat.com>

	lenses: Allow whitespace at the end of kernel commnd line (#798)
	Reported-by: Yongkui Guo
	Fixes: https://bugzilla.redhat.com/show_bug.cgi?id=2159282

2023-01-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	GitHub Actions (#714)

2022-12-21  Ruoyu Zhong  <zhongruoyu@outlook.com>

	Remove `#include <malloc.h>` , add `#include <libgen.h>` (#792)
	* src/augprint.c: Remove `#include <malloc.h>`
	
	`<malloc.h>` is not present on all platforms (e.g. macOS). `<stdlib.h>`
	should be the place to look for `malloc`, and it has already been
	`#include`d.
	
	Signed-off-by: Ruoyu Zhong <zhongruoyu@outlook.com>
	
	* src/augprint.c: Add `#include <libgen.h>`
	
	This fixes a segfault with `augprint -h` on some non-GNU platforms. See:
	https://manpages.ubuntu.com/manpages/bionic/en/man3/basename.3.html
	
	Signed-off-by: Ruoyu Zhong <zhongruoyu@outlook.com>

2022-12-07  George Hansper  <george-github@hansper.id.au>

	Fix date in %changelog in augeas.spec.in (#790)

	Fix installation destination filenames for bash completions (#789)

	Version 1.14.0 - addenda: add augprint to augeas.spec.in, fix distcheck (#788)

2022-12-06  George Hansper  <george-github@hansper.id.au>

	Version 1.14.0 (#780)

2022-12-05  George Hansper  <george-github@hansper.id.au>

	Update gnulib to 2f7479a16a3395f1429c7795f10c5d19b9b4453e (2022-12-02) (#781)

	Fix: tests/test-augtool/quoted-strings.sh change triple-backslash to quadruple-backslash, use bash (#787)

2022-12-04  Pat Riehecky  <3534830+jcpunk@users.noreply.github.com>

	Add additional unit tests for yum lense (#677)

2022-12-03  Pat Riehecky  <3534830+jcpunk@users.noreply.github.com>

	lense: /etc/cockpit/cockpit.conf (#675)

2022-12-03  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Update lens Resolv: add option trust-ad (#784)

	Add bash-completion for augtool, augmatch, augprint (#783)

	Allow unmatched square-brackets in values (#782)

2022-12-03  George Hansper  <george-github@hansper.id.au>

	Add augprint tool for creating idempotent augtool scripts (#752)
	* Add augprint tool for creating idempotent augtool scripts

2022-12-03  Sergey Nizovtsev  <snizovtsev@gmail.com>

	README.md: Add oss-fuzz status badge (#702)

2022-11-19  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	New lens Sos for /etc/sos/sos.conf (based on IniFile) (#779)

	Pg_Hba: unquoted auth-method may contain hyphens (#777)

	Add package bash to build stage in Dockerfile (#776)

2022-11-19  Adam Bambuch  <adam.bambuch2@gmail.com>
	    Adam Bambuch  <bambuch@vshosting.cz>

	keepalived lens add parameters notify_stop and notify_deleted  (#749)
	* keepalived lense add notify_stop and notify_deleted parameters
	
	* keepalived lense notify_stop and notify_deleted tests

2022-11-19  Edward  <tedgarb2@gmail.com>
	    Edward Garbade  <egarbade@andrew.cmu.edu>

	Update sshd lens to split additional list keys (#721)
	Several configuration values used for setting crypto policy were being
	incorrectly parsed as raw strings when they are in fact lists. Treat
	them as such
	
	Specifically:
	- GSSAPIKexAlgorithms
	- PubkeyAcceptedKeyTypes
	- CASignatureAlgorithms
	
	* Add support for sshd_config.d per @georgehansper request

2022-10-24  mchf  <mfilka@suse.com>

	Sysctl keys can contain some more non-alphanumeric characters (#755)
	* Sysctl keys can contain some more non-alphanumeric characters like net.ipv4.conf.*.rp_filter = 2
	* Support / in sysctl key, updated testsuite

2022-10-06  rwmjones  <rjones@redhat.com>

	semanage: Fix parsing of ignoredirs (#758)
	From /etc/selinux/semanage.conf from a RHEL 9.1 system, this line
	caused problems:
	
	  ignoredirs=/root;/bin;/boot;/dev;/etc [...]
	
	Parse this as a list of modified Rx.fspath, generating a tree like:
	
	  /files/etc/selinux/semanage.conf/ignoredirs/1 = /root
	  /files/etc/selinux/semanage.conf/ignoredirs/2 = /bin
	  /files/etc/selinux/semanage.conf/ignoredirs/3 = /dev
	  /files/etc/selinux/semanage.conf/ignoredirs/4 = /etc
	  [...]
	
	Also this adds the RHEL 9 file as another test case and adjusts the
	output of the existing test case.
	
	Fixes: https://bugzilla.redhat.com/show_bug.cgi?id=2077120
	Signed-off-by: Richard W.M. Jones <rjones@redhat.com>

2022-09-20  Michal Vasko  <mvasko@cesnet.cz>

	Systemd lens fixes (#757)
	* Systemd: allow empty quoted environment variable values
	* Systemd: allow values starting with whitespaces for Exec* and Environment service entries.

2022-09-20  Leo-Schmit  <63145459+Leo-Schmit@users.noreply.github.com>

	Replace deprecated 'security_context_t' with 'char *' (#747)

2022-08-31  rwmjones  <rjones@redhat.com>

	src/syntax.c: Fix whitespace which confuses static checkers (#725)

2022-08-29  oleksandriegorov  <alex.yegorov@gmail.com>

	Package augmatch, too (#688)

2022-06-21  Hilko Bengen  <bengen@hilluzination.de>

	Add Github workflow to create releases with complete source tarballs (#744)

2022-05-07  Richard  <g0hl1n@users.noreply.github.com>
	    George Hansper  <george-github@hansper.id.au>

	fix(lens): toml: write support (#742)
	* fix(lens): toml: add write support
	
	The toml lens fails to save simple toml files due to problems with multi
	dimensional (>2) arrays.
	Therefore disable arrays with more than 2 dimensions for now to enable
	basic usage again.
	
	This commit fixes issue #715 by applying the suggested workaround. If
	anyone can come up with a better solution please feel free to do so.
	
	Fixes: 5e1cd313 (TOML lens (#91), 2018-11-29)
	Signed-off-by: Richard Leitner <richard.leitner@skidata.com>
	
	* fix(lens): toml: update reference link
	
	toml.io now provides a versioned reference URL, therefore use this
	instead of the old GitHub repo link.
	
	Signed-off-by: Richard Leitner <richard.leitner@skidata.com>
	
	* fix(lens): toml: typo in About: License
	
	Signed-off-by: Richard Leitner <richard.leitner@skidata.com>
	
	* test(lens): toml: add basic write
	
	This test covers the bug described in issue #715.
	
	Signed-off-by: Richard Leitner <richard.leitner@skidata.com>
	
	* test(lens): toml: fix "array of arrays"
	
	The "Test: Toml.array_norec; Array of arrays" tested a 3 dimensional
	array. This commit fixes the test to actually test a 2 dimensional
	array.
	
	More than 2 dimensional arrays are currently not supported due to
	issue #715.
	
	Signed-off-by: Richard Leitner <richard.leitner@skidata.com>

2022-04-20  Laszlo Ersek  <lersek@users.noreply.github.com>

	Kdump: parse "auto_reset_crashkernel" (#754)
	The "auto_reset_crashkernel" keyword was introduced in the following
	kexec-tools patch set:
	
	  [PATCH v5 00/13] crashkernel=auto: support fadump and remove
	                   crashkernel.default
	  https://lists.fedoraproject.org/archives/list/kexec@lists.fedoraproject.org/thread/V5WPTRAPJR65QXSTNW6W6E7ZBAUCQNUH/#V5WPTRAPJR65QXSTNW6W6E7ZBAUCQNUH
	
	Related upstream commit:
	
	  https://src.fedoraproject.org/rpms/kexec-tools/c/73ced7f451a72
	
	Recognize "auto_reset_crashkernel" in "kdump.aug". Update the test case.
	Also copy "kdump.conf" from kexec-tools @ 73ced7f451a72 to
	"tests/root/etc/kdump.conf".
	
	Bugzilla: https://bugzilla.redhat.com/show_bug.cgi?id=2042772

2022-03-03  Miroslav Lichvar  <mlichvar@redhat.com>
	    Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Chrony: add new directives and options (#745)
	Support new configuration added in chrony 4.1 and 4.2.

2022-03-03  Mitch Hagstrand  <mhagstrand@gmail.com>

	Allow redis lens to set 'SAVE ""' as a valid option (#738)

2022-02-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Remove FUNDING

2022-02-11  Guillaume Ross  <guillaume@binaryfactory.ca>

	Add path for Ubuntu (#748)
	ClamAV on Ubuntu uses a slightly different path.

2021-12-06  Heston Snodgrass  <hsnodgrass@users.noreply.github.com>

	Add authselect_pam.aug to lenses (#743)

2021-10-24  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Version 1.13.0 (#735)
	* Version 1.13.0
	
	* Update .travis-ci.yml - use focal (Ubuntu 20.04) instead of xenial (Ubuntu 16.04)

2021-10-15  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	fix(lens): sshd_config match groups accept quoted strings with opt spaces (#739)
	* fix(lens): sshd_config match groups accept quoted strings with opt spaces
	
	Signed-off-by: Raphaël Pinson <raphael.pinson@camptocamp.com>
	
	* fix(lens): ssh_config match groups accept quoted strings with opt spaces

2021-10-02  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Add "else" operator to augeas path-filter expressions (priority selector) (#692)
	* Add "else" operator to augeas path-filter expressions (priority selector)
	
	* Add "else" operator to augeas path-filter expressions (priority selector) - expanded to include nodeset expressions

2021-10-02  George Hansper  <george-github@hansper.id.au>
	    George Hansper  <george@hansper.id.au>

	Add new axis 'seq' to allow /path/seq::*[expr] to match and create numeric nodes, as idempotent alternative to /path/*[expr] (#706)

2021-07-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	feat(lens): fix sentinel support in Redis.conf (#728)

	feat(lens): Support replicaof stanza in Redis.lns (#727)

2021-07-08  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	feat(lenses): add /etc/redis.conf to Redis.lns (#726)

2021-06-26  Ando David Roots  <42958320+anroots-tw@users.noreply.github.com>

	Support negative integers in sudoers lens (#724)
	* Support negative integers in sudoers lens
	
	[timestamp_timeout](https://help.ubuntu.com/community/RootSudoTimeout) in `/etc/sudoers`
	can have a negative value, but current augeas lens definition doesn't support this.
	
	Modify lens regex to also match negative integers.
	Issue is similar to https://libvir-list.redhat.narkive.com/gFPonY7Z/libvirt-patch-adapt-augeas-profile-to-handle-negative-int-values
	
	* Add test case for sudoers / negative timestamp_timeout
	
	Ref #724

2021-05-31  mchf  <mfilka@suse.com>

	Modified NetworkManager lense (#723)
	* Write test
	
	* Updated testsuite
	
	* Modified NetworkManager lense
	
	The lense will not encapsulate value of a newly created entry by quotes.
	Values containing # are accepted (allowed character e.g. for WPA-PSK)
	
	* Commented the testsuite

2021-03-18  chruetli  <chruetli@gmx.net>
	    Mario Rütti  <mario.ruetti@kraemerag.ch>
	    Raphaël Pinson  <raphael.pinson@camptocamp.com>

	adding network configuration paths according to 'systemd.network(5)' (#683)

2021-03-17  Thomas Weißschuh  <thomas.weissschuh@amadeus.com>

	add tinc lens (#718)

2021-03-03  Pino Toscano  <ptoscano@redhat.com>

	Mke2fs: support quoted values (#661)
	mke2fs.conf(5) says that both tag names and values can be quoted using
	double quotes, in case they contain spaces. Sadly, the current Mke2fs
	lens does not support that.
	
	In order to support this, introduce an helper 'fspath' value to replace
	Rx.fspath, as the latter allows " as possible character (which we do not
	want in quoted strings).
	
	Then change the helper list_sto and entry_sto functions to allow
	optionally double quoted values, with no changes in how the tree looks
	like.
	
	Moreover, try to support also empty values, although only for non-lists
	at the moment.

2021-01-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Crypttab: support UUID in device and / in opt (#713)
	* Crypttab: allow / in opt value
	
	Signed-off-by: Raphaël Pinson <raphael.pinson@camptocamp.com>
	
	* Crypttab: support UUID as device
	
	Fix #712

2020-12-02  Luchi  <39198766+luchihoratiu@users.noreply.github.com>
	    Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Allow AD groups in '/etc/sudoers' (#696)
	Before this commit, `/etc/sudoers` files containing AD users or groups
	could not be parsed with the sudoers lens because it was containing `\\`
	in said users/groups name. Running `visudo -c` shows that a sudoers file
	containing these is valid so this case was added in the affected regex.

2020-12-01  Trevor Vaughan  <peiriannydd@gmail.com>

	Update the resolv lens (#708)
	Closes: #707

2020-11-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Toml: support arrays (norec) in inline tables (#703)

2020-10-23  Marcin Barczyński  <mba.ogolny@gmail.com>
	    Raphaël Pinson  <raphael.pinson@camptocamp.com>

	postgresql.aug: Allow hyphen '-' in values that don't require quotes (#700) (#701)
	Since PostgreSQL 10 password_encryption is enum.
	If the value is set to scram-sha-256 (which contains hyphens),
	saving postgresql.conf with augeas fails with:
	
	saving failed (run 'errors' for details)
	Error in /var/lib/pgsql/13/data/postgresql.conf:782.0 (parse_skel_failed)
	  Iterated lens matched less than it should
	  Lens: /usr/share/augeas/lenses/dist/postgresql.aug:69.10-.46:
	    Last matched: /usr/share/augeas/lenses/dist/postgresql.aug:30.10-.46:
	    Next (no match): /usr/share/augeas/lenses/dist/quote.aug:117.2-.35:
	
	This is because hyphen wasn't included in the definition of string
	that doesn't require quoting.

2020-10-23  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: add new options (#698)
	Add new directives and options supported in chrony since 3.3 up to 4.0,
	with the exception of the ntsport options, which conflicts with the nts
	option.

2020-10-07  granquet  <ranquet.guillaume@gmail.com>

	Ssh: add Match keyword support (#695)

2020-09-17  Pino Toscano  <ptoscano@redhat.com>

	Tmpfiles: few improvements to the types specification (#694)
	* Tmpfiles: add more type letters
	
	According to the current tmpfiles.d(5):
	https://www.freedesktop.org/software/systemd/man/tmpfiles.d.html
	
	The test for an invalid letter was changed, as 'e' is a valid letter
	now.
	
	* Tmpfiles: allow minus sign for letter types
	
	Allow the minus sign at the end of a type specification, indicating that
	a failure in executing that line is ignored.

2020-09-17  Pino Toscano  <ptoscano@redhat.com>

	Sudoers: support new @include/@includedir directives (#693)
	Make sure to not confuse them with NIS groups.
	
	These new directives were added in sudo 1.9.1.

2020-09-03  George Hansper  <george@hansper.id.au>

	Add CLI command 'preview' and API 'aug_preview' to preview file contents (fixes)

	Add CLI command 'preview' and API 'aug_preview' to preview file contents

2020-08-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

	Update NEWS

2020-08-31  Pino Toscano  <ptoscano@redhat.com>

	Krb5: handle [plugins] subsection (#663)

2020-08-31  George Hansper  <george@hansper.id.au>

	Add function modified() to select nodes which are marked as dirty

2020-08-31  David Lutterkort  <lutter@watzmann.net>

	* src/fa.c: Fix grammar rule for char_class in comment

2020-08-31  Askar Safin  <safinaskar@mail.ru>

	src/fa.c: fixed error in regexp grammar in comment

2020-06-16  Pino Toscano  <ptoscano@redhat.com>

	lib: remove extra @LIBS@ from pkg-config file
	At the moment it is empty, so probably it does not exist. Remove it to
	avoid adding spurious content to the pkg-config file in case that
	variable will get a value in the future.

2020-06-12  felixdoerre  <felixdoerre@users.noreply.github.com>

	properties: support "/" in property names (#680)

2020-06-12  David Lutterkort  <lutter@watzmann.net>

	* src/lens.c: Do not require that keys and labels not match '/'
	The '/' is only important in translating a string containing a path
	expression to the internal data structure we use to match it against a
	tree. It has no special meaning in the lens language

	See https://github.com/hercules-team/augeas/issues/668 for more detail

2020-06-12  Anton Baranov  <abaranov@linuxfoundation.org>

	Allow underscore in postfix_transport (#678)

2020-06-08  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add sponsor badge

2020-06-02  Pat Riehecky  <3534830+jcpunk@users.noreply.github.com>

	lense: add RFC3986 URL regex (#676)

2020-04-28  Ja (Thanakul) Wattanawong  <ja@jwattanawong.com>

	README.md: fix minor typo (#669)

2020-02-13  Pino Toscano  <ptoscano@redhat.com>

	Mke2fs: add old_bitmaps option in [options] (#662)
	Seen it used by mke2fs(8), so it must be handled as well.

2020-02-05  Pino Toscano  <ptoscano@redhat.com>

	Systemd: fix parsing of envvars with spaces (#659)
	Allow spaces inside of values quoted with single or double quotes.
	
	This amends commit f64d8bc7a7670f3af2549fdcefb64c2b5f22cd0d that added
	support for quoted values.

2020-02-05  Pino Toscano  <ptoscano@redhat.com>

	Krb5: improve [dbmodules] and includes (#630)
	* Krb5: fix/revamp parsing of [dbmodules] subsection
	
	The [dbmodules] subsection so far was parsed much like the [dbdefaults]
	one, and thus it did not handle realms.
	
	Revamp it a bit to handle realms, and specify the only keyword not in
	realm subsections.
	
	* Krb5: allow include/includedir directives everywhere
	
	MIT Kerberos allows this, so do not restrict them only before any other
	section.

2020-02-02  David Lutterkort  <lutter@watzmann.net>

	Update NEWS

2020-02-02  Thomas Weißschuh  <thomas.weissschuh@de.amadeus.com>

	add Cmdline lens

2020-02-02  Pino Toscano  <ptoscano@redhat.com>

	* src/put.c (split_concat): initialize regs earlier
	Recent changes (commit 4702d306fe01391af82dc1c7e2e1d50f571fda86) in this
	helper function cause the code after the 'error' label to be used
	earlier than when regs is initialized; since the code in 'error' frees a
	couple of the fields of the regs variable, then initialize regs earlier
	to avoid potential freeing uninitialized memory.

	Found by Coverity.

2020-01-29  Pino Toscano  <ptoscano@redhat.com>

	* src/augtool.c: hopefully fix readline quoting issues
	Configure the quoting (also using a detector) and word break characters,
	so it is possible to autocomplete paths with special characters (like
	spaces, which are already quoted by augeas).

	* src/augrun.c (nexttoken): add more escape characters
	Synchonize the list of "pass-through" characters with the set in the
	'name_follow' variable in pathx.c: as pathx_escape_name() escapes them,
	make sure that aug_srun() accepts them as arguments.

	* src/augrun.c (nexttoken): print unknown escape sequences
	This makes it easier to debug this error.

2019-11-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS [skip-ci]

2019-11-18  Jason A. Smith  <smithj4@bnl.gov>

	Add hourly schedule to logrotate lens. (#655)
	Hourly is a valid logrotate schedule value.

2019-11-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip-ci]

	Rsyslog: support multiple actions in filters and selectors (#653)

2019-11-06  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip-ci]

2019-11-06  Nicolas Gif  <nicolas.gif@free.fr>

	Add fail2ban lens (#651)

2019-10-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS [skip-ci]

2019-10-31  Nicolas Gif  <nicolas.gif@free.fr>

	Add lens Authinfo2 (#649)

	Add Dockerfile (#650)

2019-10-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS [skip-ci]

2019-10-31  Xavier Mol  <xavier.mol@kit.edu>

	Limits: Support colons in the domain pattern (#645)
	Support colons (:) in domain pattern

2019-10-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip-ci]

2019-10-23  Pino Toscano  <ptoscano@redhat.com>

	Grub: support '+' in kernel command line option names (#647)
	This way it is possible to parse files that pass options with '+' in the
	name to the kernel.

2019-08-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-08-23  doc75  <github@virlet.org>

	Fix #643 - Update of opendkim lens to match current opendkim.conf file format (#644)
	* Fix #643 - Update of opendkim lens to match current opendkim.conf file format
	
	* add test for opendkim lens update

2019-08-20  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-08-20  Pino Toscano  <ptoscano@redhat.com>

	Few improvements to the Mke2fs lens (#642)
	* Mke2fs: fix handling of booleans
	
	Add a proper regexp to represent them, according to the mke2fs.conf(5)
	documentation.  Fix the lazy_itable_init, and auto_64-bit_support keys
	of fs_types to use this regexp, as they are parsed as boolean.
	
	* Mke2fs: refactor fs_entry options
	
	According to the mke2fs.conf(5) documentation, all the entries that
	appear in the various tags in the [fs_types] stanza may be used also in
	the [default] section; hence:
	- fold fs_types_entry into common_entry
	- move almost all the options (except fs_type, and undo_dir) from
	  defaults_entry to common_entry
	so the options apply to both cases.
	
	Also, in an attempt to make the list of options slightly maintainable,
	add few lists with names of options with common types (list, int, bool).
	
	* Mke2fs: add more defaults/fs_types entries
	
	Add more common entries for the [defaults] stanza, or inside a
	[fs_types] tag, fixing the types to match documentation/code.
	
	This does not cover all the possible entries available though.
	
	* Mke2fs: handle the [options] stanza
	
	Handle the two documented tags of it.

2019-08-15  Pino Toscano  <ptoscano@redhat.com>

	* .travis.yml: install libtool-bin (#639)
	This was already used to build, and apparently it is not automatically
	available anymore.

2019-07-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2019-07-26  Pat Riehecky  <3534830+jcpunk@users.noreply.github.com>

	Add ocsinventory-agent.cfg to SimpleVars (#637)

2019-06-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Postfix_Master: Allow unix-dgram as type (fix #365) (#636)

2019-05-07  Pino Toscano  <ptoscano@redhat.com>

	vim: recognize also 'excl' as statements (#628)

2019-05-07  Pino Toscano  <ptoscano@redhat.com>

	Shellvars: exclude more tcsh profile scripts (#627)
	Found tcsh profile scripts also with the .tcsh extension, so exclude
	them too.
	
	Followup of commit b78bbb61282208288f0182ec1a9b3045c1f61e2a.

2019-04-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add failing test for issue #626

2019-04-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Remove extra * in NEWS [skip-ci]

2019-04-14  David Lutterkort  <lutter@watzmann.net>

	Version 1.12.0

	NEWS: mention Strongswan breaking change

2019-04-14  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Strongswan: parse lists

2019-04-14  Pino Toscano  <ptoscano@redhat.com>

	* examples/fadot.c: stop including getopt.h
	getopt.h is a GNU extension, and it is not even needed for this example
	(plain getopt() is used).

	* examples/dump.c: stop building with _GNU_SOURCE
	This might not be available on all the platforms, and it should not be
	needed anyway.

2019-04-14  Pino Toscano  <ptoscano@redhat.com>

	examples: turn them as standalone
	Examples are supposed to be small test applications (examples, indeed)
	that help users to know how the library works.  Hence, it is a good
	thing that users can pick them out of the sources, and build them
	standalone on their own, using the system augeas library.

	Make this situation possible:
	- do not rely on gnulib: they are test applications of augeas, not
	  supposed to be the most perfect C examples; besides, gnulib is not
	  available out of the augeas build tree
	- stop including config.h: the content of the examples is not supposed
	  to change depending on the augeas build configuration
	- include the augeas headers as system headers, not as local ones; the
	  build system takes care that the local augeas headers are used when
	  building the examples as part of the sources

2019-04-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-04-12  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Rsyslog: support dynamic file paths (#622)
	As per https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/7/html/system_administrators_guide/s1-basic_configuration_of_rsyslog#s2-Actions

2019-04-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-04-10  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Support unix sockets as server address (fix #617) (#618)

2019-04-08  David Lutterkort  <lutter@watzmann.net>

	* gnulib: update to latest master

	* configure.ac: remove explicit automake-1.11 dependency

2019-04-06  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-04-06  Michael Wodniok  <wodniok@wor.net>

	Fixes missing recognition of double quoted filenames. (#611)
	Fixes missing recognition of double quoted filenames.
	
	Logrotate is able use quote filenames. This by itself is fixed there. Some
	distributions files are using that. Logrotate would also be able to use files
	with spaces (when quoted), fixing is too complicated for a quick fix and this
	should be also uncommon in real life.

2019-04-05  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-04-05  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Puppetfile: allow comments in entries (#620)

2019-04-05  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS [skip ci]

2019-04-05  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Puppetfile: allow symbols as (optional) values (fix #427) (#619)

2019-03-19  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add missing lens docs

2019-02-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2019-02-27  frh  <frh+github@frh.no>

	nsswitch: Add action merge (#609)

2019-02-27  David Lutterkort  <github@watzmann.net>

	Ssh: accept RekeyLimit (#607)

2019-02-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Shellvars: accept variable as command

	Update NEWS and AUTHORS

2019-02-25  Nathan Ward  <nward@braintrust.co.nz>

	Add test for dovecot permitting ! in block names

	Permit ! in block titles, which is permitted in modern versions of Dovecot m Please enter the commit message for your changes. Lines starting

2019-02-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2019-02-25  David Farrell  <davidpfarrell+github@gmail.com>

	Allow Creation of Hostname When File is Missing
	Within augtool, the current `hostname` lens does not allow you to create a hostname entry under the following circumstances:
	* /etc/hostname file is empty
	* /etc/hostname file does not exist
	
	:: /etc/hostname file is empty
	
	There is no augtool command(s) that will allow you to add a hostname entry to an existing, but empty, file.  Example:
	```
	$ sudo rm /etc/hostname
	$ sudo touch /etc/hostname
	$ sudo augtool
	
	augtool> set /files/etc/hostname/hostname myhostname
	augtool> save
	error: Failed to execute command
	saving failed (run 'errors' for details)
	
	augtool> errors
	
	Error in /etc/hostname:1.0 (parse_skel_failed)
	  Input string does not match at all
	  Lens: /usr/share/augeas/lenses/dist/hostname.aug:16.10-.57:
	```
	
	Additionally, you cannot remove the empty file using augtool:
	```
	$ sudo rm /etc/hostname
	$ sudo touch /etc/hostname
	$ sudo augtool rm /files/etc/hostname
	$ ls -l /etc/hostname
	-rw-r--r-- 1 root root 0 Feb 19 12:39 /etc/hostname
	```
	
	:: /etc/hostname does not exist
	
	Similar to the empty file case, you cannot create a hostname entry if the file does not already exist.
	
	You can, however, create an empty file:
	```
	$ sudo rm /etc/hostname
	# You can create an empty file with clear or touch
	$ sudo augtool touch /files/etc/hostname
	$ ls -l /etc/hostname
	-rw-r--r-- 1 root root 0 Feb 19 12:34 /etc/hostname
	```
	
	Of course, now that you have an empty file, you cannot create a hostname entry for it :( 
	
	This proposed change will allow you to at least create a hostname entry when the file does not already exist.
	
	It also enables you to remove file, allowing for a deterministic approach:
	```
	$ sudo rm /etc/hostname
	$ sudo touch /etc/hostname
	$ sudo augtool rm /files/etc/hostname
	$ ls -l /etc/hostname
	ls: cannot access '/etc/hostname': No such file or directory
	$ sudo augtool set /files/etc/hostname/hostname myhostname
	$ ls -l /etc/hostname
	-rw-r--r-- 1 root root 11 Feb 19 12:44 /etc/hostname
	$ cat /etc/hostname
	myhostname
	```
	
	NOTE: Its probably very possible to fix the lens to deal more of the edge cases, but this quick fix at least gives deterministic behavior if a rm/set each time I want to configure the hostname.
	
	Thank you for your consideration.
	
	-David Farrell

2019-01-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2019-01-31  Jason A. Smith  <smithj4@bnl.gov>

	Added more pkinit_* options.

2019-01-08  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Organize NEWS alphabetically

2019-01-08  Pino Toscano  <ptoscano@redhat.com>

	Shellvars: fix parsing of commands with dashes
	Move the dash as first element in the regexp, so it is not handled as
	range separator.

	Shellvars: do not handle csh/tcsh profile scripts
	They are specific scripts for csh/tcsh, which are not POSIX compliant.
	As Shellvars cannot handle them (it is de-facto for POSIX compliant
	shells), exclude them directly.

	Shellvars: support variables with dash
	E.g. 'alias foo-bar=value'.

	Shellvars: support (...) for the body of functions
	Support (...) for the body of functions, so other than
	  foo() {...}
	now Shellvars can parse also
	  foo() (...)

2018-12-12  Pino Toscano  <ptoscano@redhat.com>

	New lens: Anaconda (#597)
	Introduce a new lens to parse the INI-like `/etc/sysconfig/anaconda` instead of using `Shellvars`.

2018-12-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	DevfsRules: Add lens for FreeBSD devfs.rules files

2018-12-01  Axel Arnold  <arnolda747@gmail.com>

	Xorg: Accept empty values for options

	Rsyslog: In rsyslog, bsd-like #!/+/- are just comments without special meaning

2018-11-30  Emil Dragu  <emil.dragu@gmail.com>

	Allow parsing of options with equal sign (#587)
	Ssh: Options in sshd_config can be specified using space, tab or equal sign.
	They all have the same effect.

2018-11-30  David Lutterkort  <github@watzmann.net>

	Pam: accept continuation lines (#592)
	Make it possible to use '\<LF>' as a whitespace character between tokens
	
	Fixes https://github.com/hercules-team/augeas/issues/590

2018-11-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Toml: support dos newlines

	Toml: time_re can start with one digit only

2018-11-29  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	TOML lens (#91)
	Toml: New lens to parse the TOML format

2018-11-29  Pino Toscano  <ptoscano@redhat.com>

	New lens: Semanage (#594)
	Introduce a new lens to parse /etc/selinux/semanage.conf instead of
	using Simplevars: the latter cannot handle the more complex syntax of
	groups introduced in newer versions of libsemanage.

2018-11-02  David Lutterkort  <lutter@watzmann.net>

	* src/augtool.c (get_home_dir): try harder to get the user's home dir
	At least on musl systems, sysconf(_SC_GETPW_R_SIZE_MAX) returns -1, which
	caused us to not try and find the user's home dir, which meant that we did
	not save history.

	We now try harder by (1) getting the user's pw entry into a 16k buffer, and
	if that still fails, by (2) getting the home dir from $HOME.

2018-11-02  David Lutterkort  <lutter@watzmann.net>

	* src/augeas.h: improve docs for aug_init

2018-11-01  Steve Traylen  <steve.traylen@cern.ch>

	Fix sudoers lens: "always_query_group_plugin" (#588)
	The option is now enabled by default in the default sudoers of
	RHEL 7.6 (and probably soon CentOS 7).

2018-10-16  David Lutterkort  <lutter@watzmann.net>

	Syslog: accept include directive
	Add syslog.conf from
	https://svnweb.freebsd.org/base?view=revision&revision=308160 to test root,
	too

	Fixes https://github.com/hercules-team/augeas/issues/486

2018-10-09  Pino Toscano  <ptoscano@redhat.com>

	* src/lexer.l: disable 'input' and 'yyunput' functions
	flex by default generates the 'input', and 'yyunput' functions; OTOH,
	augeas does not use them, so add the right options to suppress their
	generation.

2018-09-25  David Lutterkort  <lutter@watzmann.net>

	Multipath: accept values enclosed in quotes
	Multipath is happy with values enclosed in quotes, like 'path_checker
	"tur"' in addition to the unquoted values. This change accepts such values
	and strips the enclosing quotes.

	Fixes https://github.com/hercules-team/augeas/issues/583

2018-09-03  Raphaël Pinson  <github+aem1eeshi1@raphink.net>

	Shellvars: allow and/or in @if conditions (#582)

2018-08-25  David Lutterkort  <lutter@watzmann.net>

	Version 1.11.0

2018-08-23  David Lutterkort  <lutter@watzmann.net>

	Replace pure function invocations in path expressions with their result
	In path expressions, we generally need to evaluate functions against every
	node that we consider for the result set. For example, in the path
	expression /files/etc/hosts/*[ipaddr =~ regexp('127\\.')], the regexp
	function was evaluated against every entry in /etc/hosts. Evaluating that
	function requires the construction and compilation of a new regexp. Because
	of how memory is managed during evaluation of path expressions, the memory
	used by all these copies of the same regexp is only freed after we are done
	evaluating the path expression. This causes unacceptable memory usage in
	large files (see https://github.com/hercules-team/augeas/issues/569)

	To avoid these issues, we now distinguish between pure and impure functions
	in the path expression interpreter. When we encounter a pure function, we
	change the AST for the path expression so that the function invocation is
	replaced with the result of invoking the function. With the example above,
	that means we only construct and compile the regexp '127\\.' once,
	regardless of how many nodes it gets checked against. That leads to a
	dramatic reduction in the memory required to evaluate path expressions with
	such constructs against large files.

	Fixes https://github.com/hercules-team/augeas/issues/569

2018-08-23  Yann Hamon  <yann.hamon@9cookies.com>

	Redis: accept bind command
	Fixes https://github.com/hercules-team/augeas/issues/194

2018-08-10  David Lutterkort  <lutter@watzmann.net>

	Httpd: accept whitespace comment after tag opening a section
	We used to only deal with completely empty comments after a tag opening a
	section, for example '<If cond>#\n', but not with a comment that consisted
	only of whitespace like '<If cond># \n'. We now accept both cases,
	resulting in the same tree.

	Fixes https://github.com/hercules-team/augeas/issues/577

2018-08-10  Pino Toscano  <ptoscano@redhat.com>

	* tests/Makefile.am: use right make for valgrind target
	Use $(MAKE), and $(MAKEFLAGS) when invoking the check target in valgrind
	mode, this way the right make, with the right parameters, is used.

	* src/augparse.c (main): call aug_close even on failure
	Even if the resources will be freed at the exit, manually call aug_close
	to make sure that analyzers/checkers see only the real issues.

	* src/transform.c (transform_save): fix leaks on fchmod fail
	If fchmod fails, the early return prevents any cleanup of the function
	resources, e.g. the open FILEs.  Use the common error handling instead.

	* src/syntax.c (interpreter_init): fix memleak on load_module fail
	If load_module fails, then name is not freed.  Instead, store the
	return value of load_module separately, cleanup name, and then check
	that value.

	* src/pathx.c (parse_location_path): fix memleak on error
	If parse_relative_location_path fails, then the early return will leak
	locpath.  Use the common error handling to cleanup all the resources.

	* src/jmt.c (add_lens): fix memory leak w/ debugging
	format_lens returns a new string every time, so save its result, and
	free it properly after use.

2018-07-20  Pino Toscano  <ptoscano@redhat.com>

	* src/fa.c (fa_dot_debug): check result of fopen
	Return earlier if fopen fails, otherwise fa_dot will dereference a null
	pointer.

2018-07-19  Pino Toscano  <ptoscano@redhat.com>

	* src/augtool.c: fix access to invalid memory
	When stripping the context from the result, readline_path_generator used
	to realloc the string to a shorter size, copying only the content after
	the prefix.  This resulted in reading with strcpy  from the previous
	memory, which is freed already.  Avoid the issue, and simplify the code
	by using strdup, freeing the old string.

	This issue could be reproduced in augtool, trying to autocomplete files
	without the /files prefix, e.g.:
	  augtool> ls <TAB><TAB>

2018-06-27  David Lutterkort  <lutter@watzmann.net>

	Nginx: improved parsing of simple directives
	The 'argument' to a simple directive can now be made up of any number of
	bare words (not containing quotes) and quoted strings. Semicolons are
	allowed within quoted strings.

	Also, allow simple directives without arguments (like 'internal' for
	location)

	Fixes https://github.com/hercules-team/augeas/issues/566

2018-06-27  John Morrissey  <jwm@horde.net>

	Dhclient: fix parsing of append / prepend / default / supersede statements

2018-06-14  David Lutterkort  <lutter@watzmann.net>

	Rsyslog: support include() directive

2018-06-12  David Lutterkort  <lutter@watzmann.net>

	* tests/test-api.c: add a check for aug_source

	* src/augeas.c (aug_source): actually return the source for the node

	Multipath: fix syntax error in test
	Error was introduced in commit ade45812

2018-06-10  David Lutterkort  <lutter@watzmann.net>

	* .travis.yml: run 'make check' in verbose mode

	* NEWS: mention augmatch changes

	* man/augmatch.pod: explain possible exit statuses

	augmatch: add a --quiet option
	The --quiet option mimics grep's option: suppress output and only set the
	status code according to whether there was a match or not

	augmatch: exit with code 2, not 1, on error

2018-06-08  David Lutterkort  <lutter@watzmann.net>

	Multipath: allow regexps for devnode, wwid, and property in blacklist section
	Fixes https://github.com/hercules-team/augeas/issues/564

2018-06-07  David Lutterkort  <lutter@watzmann.net>

	Regenerate docs

	Use a safer calling convention for native functions
	The native functions in the lens interpreter used a calling convention that
	required unsafe casting of function pointers. We now use a calling
	convention that does not cause any function pointer casts.

2018-06-07  David Lutterkort  <lutter@watzmann.net>

	Remove CALLOC and MEMCPY macros
	MEMCPY was unsued.

	Replace uses of CALLOC with the safer ALLOC and ALLOC_N macros

2018-06-05  David Lutterkort  <lutter@watzmann.net>

	Grub: tolerate some invalid entries
	Refusing to parse an entire file because of invalid entries is too
	harsh. Try to make the behavior a little friendlier by simply mapping invalid
	entries to '#error' nodes but still parsing the rest of the file.

	Also remove del_to_eol, that would delete anything up to eol; it was only
	used in kw_pres, but should have never been used there. kw_pres should only
	match the keyword and eol. A line like 'quiet foo bar baz' should not be
	accepted by (kw_pres "quiet").

2018-05-31  David Lutterkort  <lutter@watzmann.net>

	* NEWS: mention Nginx change

2018-05-29  plumbeo  <plumbeo@users.noreply.github.com>

	Parse nginx sites-enabled
	On Debian/Ubuntu the active sites are configured in /etc/nginx/sites-enabled, either as files or as symlinks to files in /etc/nginx/sites-available/, so parse that path too.

2018-05-25  David Lutterkort  <lutter@watzmann.net>

	Json: allow escaped slashes in strings
	According to https://www.json.org/, a string like "\/" is legal in Json.

	Fixes https://github.com/hercules-team/augeas/issues/557

2018-04-26  Han Han  <hhan@redhat.com>

	Fix several memory leak in augmatch

2018-04-24  David Lutterkort  <lutter@watzmann.net>

	src/augmatch.c: include libgen.h
	Fixes: https://github.com/hercules-team/augeas/issues/556

2018-03-14  David Lutterkort  <lutter@watzmann.net>

	Systemd: explicitly exclude *.d and *.wants directories
	We used to get confused when writing back systemd changes and tried to
	write a whole *.d or *.wants directory as one file, which would fail. By
	explicitly not matching them, we make sure that we write to the files in
	those directories, not the directories themselves.

	Fixes https://github.com/hercules-team/augeas/issues/548

2018-03-14  David Lutterkort  <lutter@watzmann.net>

	Update gnulib

	NEWS: add note about Chrony changes

2018-03-13  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: add new options
	Add new options supported in chrony 3.2 and 3.3.

2018-02-13  Pino Toscano  <ptoscano@redhat.com>

	Fstab: allow leading whitespace in lines with spec (#544)
	The documentation does not explicitly mention this possibility, but
	tooling that parses fstab actually supports this: hence, allow leading
	whitespace in lines with filesystem specification.

2018-02-10  Pat Riehecky  <riehecky@fnal.gov>

	More specific message as to why this errors out

2018-02-08  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	new lens: Strongswan

2018-01-29  David Lutterkort  <lutter@watzmann.net>

	Version 1.10.1

	* src/fa_sym.version: fix symbol versioning mistake

2018-01-26  David Lutterkort  <lutter@watzmann.net>

	Version 1.10.0

2018-01-12  David Lutterkort  <lutter@watzmann.net>

	NEWS: add note about previous commit

2018-01-12  Pat Riehecky  <riehecky@fnal.gov>

	Add logind.conf to systemd lense

2018-01-06  David Lutterkort  <lutter@watzmann.net>

	* examples/Makefile.am: do not force static linking of dump
	Forcing static linking of 'dump' was accidentally left in from some
	testing; there is no reason to force that specifically for dump.

	Thanks to Jörg Krause for reporting the issue and verifying the fix.

	Fixes https://github.com/hercules-team/augeas/issues/535

2018-01-06  David Lutterkort  <lutter@watzmann.net>

	NEWS: mention addition from commit 94e636df

	Add a few more files to the test root

2018-01-05  Tomas Meszaros  <exo@tty.sk>

	httpd: include  /etc/httpd/conf.modules.d
	Fedora/RHEL uses this directory for modules config.

2018-01-03  David Lutterkort  <lutter@watzmann.net>

	New command augmatch to query the tree more easily from the command line

	Add more aug_ns_ functions to query nodesets in variables
	These new functions make it possible to efficiently count the number of
	nodes in a nodeset, retrieve their label and index, retrieve their value,
	and get a full path to them

	* src/lens.c (typecheck_prim): new function
	Factor typechecking primitive lenses into a separate function, and only
	call that if typechecking is actually turned on.

	* src/lens.c (lns_make_prim): avoid unnecessarily checking key lenses
	When typechecking is turned off, we do not need to typecheck key lenses.

	* src/info.h: add a helper to see if we should be typechecking

	* src/pathx.c (pathx_symtab_count): return size of a nodeset
	Add a utility function to retrieve the size of the nodest stored in a
	variable

	* src/internal.c (tree_sibling_index): utility to compute index of a node
	Make the logic to determine the index of a node amongst its siblings (as in
	label[2]) available as a utility function.

	Path expressions allow abbreviating '[. = "foo"]'
	It's now possible to write 'label["value"]' instead of 'label[. = "value"]'
	in path expressions.

2017-12-13  omgold  <ybyt4t@gmail.com>

	created lense for /boot/grub/grubenv (grub2) (#291)

2017-12-13  Hilko Bengen  <bengen--github@hilluzination.de>

	Correct some spelling mistakes (#523)

2017-12-12  David Lutterkort  <lutter@watzmann.net>

	* tests/fatest.c (testEnumerate): ignore result of asprintf on purpose
	Wea re already trying to handle an error; if the asprintf fails we just give up

2017-12-12  Jörg Krause  <joerg.krause@embedded.rocks>

	Update Makefile.am
	Add missing trailing backslash for `dump_LDADD`.

2017-11-21  David Lutterkort  <lutter@watzmann.net>

	New command 'count' in augtool

	* src/pathx.c (func_not): new function to add 'not(...)' operator

	Remove flags field from struct info
	The flags field in struct info was only used to pass whether spans are
	enabled to lns_get. Instead of having this field in every struct info, we
	just pass it into lns_get explicitly shich puts it into its struct
	state. That saves a small amount of memory as it makes struct info, of
	which we have a lot, 4 bytes smaller.

	* put.c: move whether spans are enabled into a flag in struct state

	* get.c: move whether spans are enabled into a flag in struct state

2017-11-11  David Lutterkort  <lutter@watzmann.net>

	Make sure we don't load a module but then later can't find it
	If a module name contains a '/', it can happen that we find the
	module (like 'dist/Fstab.lns'), load it and then later can't find it under
	the invalid module name containing the slash, leading to an endless loop of
	loding the same module over and over again.

	We avoid this by making sure there is no '/' in the module name before
	looking for the module file. Other forms of invalid module names should not
	cause similar problems as we will simply fail to find the corresponding
	file.

	Fixes https://github.com/hercules-team/augeas/issues/522

2017-11-11  klemens  <ka7@github.com>

	spelling fixes

2017-11-04  John Vandenberg  <jayvdb@gmail.com>

	Support YAML sequence documents
	This only adds support for a document which
	consists of a sequence.

2017-11-04  David Lutterkort  <lutter@watzmann.net>

	* README.md: add Travis badge for build status

	* src/fa.c (fa_ambig_example): short-circuit the computation in some cases

	Update gnulib to 180a0d70d

	* src/fa.h: add some more comments for the fa_state_* functions

	* src/fa.h (fa_json): small improvements
	- make it return an int so we can indicate errors
	- store the hashes in an array of hash_val_t to ensure we do not
	  accidentally truncate hash values
	- small code formatting/clarification changes

	Mention fa_json and fa_state_* in NEWS and AUTHORS

2017-11-04  Pedro  <pedro.valero.mejia@gmail.com>

	Implemented function fa_json to export the FA in json format.
	Implemented functions fa_state_* that allow the user to go through states and transitions of the FA.

	These changes are discussed in #513

2017-11-01  David Lutterkort  <lutter@watzmann.net>

	* examples/Makefile.am: do not install dump

2017-10-28  David Lutterkort  <lutter@watzmann.net>

	Resolv: accept empty comments with DOS line endings
	Fixes https://github.com/hercules-team/augeas/issues/161

	Properties: accept empty comments with DOS line endings
	Fixes https://github.com/hercules-team/augeas/issues/161

	Resolv: no functional change, whitespace cleanup

	* NEWS: mention Nsswitch and Ntp fixes

2017-10-28  David Lutterkort  <lutter@watzmann.net>

	Ntp: accept 'ntpsigndsocket' statement
	Patch by Philipp Hahn

	Fixes https://github.com/hercules-team/augeas/issues/516

2017-10-28  David Lutterkort  <lutter@watzmann.net>

	Nsswitch: allow comments at end of line
	Patch by Philipp Hahn

	Fixes https://github.com/hercules-team/augeas/issues/517

2017-10-18  Matt Dainty  <matt@bodgit-n-scarper.com>

	RANCiD lens

2017-10-10  Hilko Bengen  <bengen@hilluzination.de>

	* tests/Makefile.am (lens_tests): explicitly remove target
	Debian's debhelper will, by default, run autoreconf, which leads to
	problems as released tarballs contain copies of the various lens-*.sh
	tests. autoreconf triggers an attempt to recreate the symbolic links to
	those tests via 'ln -s', which fails because there are already ordinary
	files for that in place.

	To work aroun that, explicitly remove the 'lens-*.sh' scripts before
	creating a symbolic link to them.

	For background on Debian's rationale for running autoreconf, see
	https://wiki.debian.org/Autoreconf

	Fixes https://github.com/hercules-team/augeas/issues/511

2017-10-06  David Lutterkort  <lutter@watzmann.net>

	Version 1.9.0

2017-10-05  Matt Dainty  <matt@bodgit-n-scarper.com>

	Add lenses for reading termcap-style databases

2017-09-30  David Lutterkort  <lutter@watzmann.net>

	Ssh: accept '=' to separate keyword from arguments

	Add Ceph contribution to NEWS and AUTHORS

2017-09-30  Pavel Chechetin  <pchechetin@mirantis.com>

	Add Ceph module

2017-09-30  David Lutterkort  <lutter@watzmann.net>

	Sshd: recognize quoted group names with spaces in them
	Fixes: https://github.com/hercules-team/augeas/issues/477

2017-09-30  David Lutterkort  <lutter@watzmann.net>

	Properties: accept DOS line endings
	We now allow /\r?\n/ in line endings. The regular expressions preceding eol
	and hard_eol are a little tighter than they really need to be to avoid
	ambiguous concatenations as they generally result from removing \r from
	allowable values. If that turns out to be a problem, we need to refine them
	further.

	Fixes https://github.com/hercules-team/augeas/issues/468

2017-09-29  David Lutterkort  <lutter@watzmann.net>

	* src/put.c (create_del): do not unescape the string before writing it out
	We already unescape the default for a del when we read the lens file. Doing
	it during put will cause two rounds of unescaping to happen, which is
	wrong.

	Fixes: https://github.com/hercules-team/augeas/issues/507

2017-09-29  David Lutterkort  <lutter@watzmann.net>

	Httpd: improve handling of arguments in directives
	* handle '>""' properly
	* make space between quoted args optional
	* do not get confused by quoted strings in bare arguments

	Fixes https://github.com/hercules-team/augeas/issues/429
	Fixes https://github.com/hercules-team/augeas/issues/435
	Fixes https://github.com/hercules-team/augeas/issues/470

2017-09-29  David Lutterkort  <lutter@watzmann.net>

	Httpd: handle empty comments with a continuation line in them
	Fixes https://github.com/hercules-team/augeas/issues/423

	* examples/cont.aug: an example for handling continuation lines

	Regenerate docs to include Oz lens

	Exports: allow paths in quotes
	We used to insist that paths start with a /, but things like
	"/path/in/quotes" is legal, too. The lens now accepts pretty much anything
	for the path now.

	Rsyslog: allow comments inside config objects like 'module'
	At least in Fedora 26, that is used in the default rsyslog.conf

	Syslog: allow spaces before the # starting a comment

2017-09-29  Pat Riehecky  <riehecky@fnal.gov>

	New lense for OZ

2017-09-27  Pino Toscano  <ptoscano@redhat.com>

	* .gitignore: ignore examples/dump

2017-09-27  Denys Stroebel  <stroebs@users.noreply.github.com>

	Add seccomp_sandbox to vsftpd.aug lens
	Required for Docker containers. Enabled by default on amd64
	https://wiki.gentoo.org/wiki/Vsftpd
	seccomp filter sanboxing with vsftpd 3.0.x

2017-09-20  David Lutterkort  <lutter@watzmann.net>

	* tests/test-api.c (testAugNs): deallocate memory used in the test
	Without this, address sanitizer will complain about lots of leaks.

	* src/transform.c (xfm_lens): initialize *lens_name to NULL
	Otherwise, we might deal with an uninitialized lens_name in callers,
	something that gcc 7.1 spots under -O3.

2017-09-20  Han Han  <hhan@redhat.com>

	Fix memory leak when checking version of augparse
	Add aug_close() before exit to fix memory leak when printing
	version information of augparse.

2017-09-20  Romain Tartière  <romain@blogreen.org>

	Fix shell location / finding
	POSIX says a bourne shell is available in `/bin/sh`.  For any other
	command, `/usr/bin/env` can be used to locate the binary in $PATH.

	Fix all scripts to use `/bin/sh` when applicable, and rely on
	`/usr/bin/env` to locate `bash` when necessary.

2017-09-19  Romain Tartière  <romain@blogreen.org>

	Use a portable pattern substitution
	Bash has a non-standard substitution `${parameter/pattern/string}` but
	since the autotools produce a shell whose interpreted is `/bin/sh`,
	there is no warranty for this pattern to be supported.

2017-09-17  David Lutterkort  <lutter@watzmann.net>

	* src/fa.c (fa_make_empty): do not mark fa as minimal or deterministic
	Even though the empty fa is both minimal and deterministic, this function
	is also used to allocate new fa's which may be modified further,
	invalidating their being marked as minimal or deterministic. For example,
	the fa constructed by fa_intersect was erroneously marked as minimal
	because of this, making it impossible to actually minimize that fa.

	Not marking the empty fa as minimal and deterministic will not cause any
	problems, and may only cause us to unnecessarily try to determinize or
	minimize the fa, which, given the size of the empty fa will be very fast
	operations.

2017-09-16  David Lutterkort  <lutter@watzmann.net>

	* src/lexer.l: properly handle backslash escaping in strings and regex
	We used to look at a string literal like "\\" as not ending, and instead
	mistook \" as escaping the ending quotes. This (longstanding, embarrassing)
	bug would lead to weird syntax errors in lenses when encountered.

	Fixes https://github.com/hercules-team/augeas/issues/495

2017-09-16  David Lutterkort  <lutter@watzmann.net>

	When saving to nonwritable file fails, make sure we remove the tempfile
	When the file we are trying to save to is not writable, we left the
	temporary file we wriote to behind. Now, we make sure we remove it.

	Fixes https://github.com/hercules-team/augeas/issues/479

2017-09-16  David Lutterkort  <lutter@watzmann.net>

	Test that putting text with a lens updates spans
	Fixes https://github.com/hercules-team/augeas/issues/467

	* transform.c (lens_put): factor out bookkeeping around calling lns_put
	Both transform_save and text_retrieve need to update the span info for
	their root nodes. The lens_put function does that.

	* transform.c (lens_get): common logic around calling lns_get
	To make sure we correctly handle setting the span for the toplevel node for
	a file, factor the setup around calling lns_get into the lens_get method
	(yes, naming is hard) and use it from load_file and text_store

	* put.c: recalculate span information when writing a file

	Pass struct info into lns_put
	This makes the AUG_ENABLE_SPAN flag available so that we can later update
	spans when we put.

	* transform.c (make_lns_info): new function to create struct info for lns_get
	We had that in two different places with slightly different ways of doing
	this. Turning this into a function makes sure we do the same thing for
	load_file and text_store.

	* transform.c (text_store): pass aug->flags to lns_get
	This ensures that we calculate spans when they are turned on

2017-09-12  Pino Toscano  <ptoscano@redhat.com>

	Grub: handle top-level "boot" directive (#494)
	Grub 1 effectively ignores commands in the configuration which work only
	in the command line.  The generated configuration by anaconda included
	also a commented "boot=device" entry at the beginning: uncommenting that
	does not make the configuration invalid, but makes the Grub lens not
	able to parse it.
	
	Since there is no harm in representing a configuration key that will be
	effectively ignored, accept top-level "boot" entries as well.

2017-09-09  Omer Katz  <omer.drow@gmail.com>

	Added branch prediction macros and marked allocation errors as unlikely.

2017-09-09  Pino Toscano  <ptoscano@redhat.com>

	Cgconfig: allow fperm & dperm in admin & task
	These keys are used to control the permissions for files and
	directories.

2017-08-29  David Lutterkort  <lutter@watzmann.net>

	* examples/dump.c: example of using aug_ns_* functions

	* augeas.c (aug_ns_attr): new function to iterate through a nodeset
	This function makes it possible to quickly iterate through a nodeset and
	retrieve various bits of information about the nodes in it.

	* pathx.c (pathx_symtab_get_tree): new function

	Remove lots of duplicate 'const' declarations
	GCC 7 warns about those, and they are completely unnecessary.

	Mark fallthroughs in switch statements as intentional
	WIth GCC 7.0, gcc will warn about these fallthroughs. In the one place
	where we do that, we need to keep them to avoid rewriting the entire
	logic. We therefore just mark them as intentional.

2017-08-29  Shawn Ferry  <sferry@gmail.com>

	Solaris needs gnu-version-script-compat

2017-08-26  Dominic Cleal  <dominic@cleal.org>

	Sshd: split HostKeyAlgorithms values into list
	Matches Ssh lens behaviour.

2017-08-26  Roy Hubbard  <rhubbard@integralads.com>

	Add FreeBSD path for rc.conf.d

	Add FreeBSD paths to dovecot

	Add FreeBSD paths for postfix

2017-08-26  David Lutterkort  <lutter@watzmann.net>

	* NEWS: fix encoding back to UTF-8

2017-08-26  Luigi Toscano  <ltoscano@redhat.com>

	Fix sudoers lens: recognize "match_group_by_gid"
	The option is now enabled by default in the default sudoers of
	RHEL 7.4 (and probably soon CentOS 7).

	Closes #482

2017-08-26  David Lutterkort  <lutter@watzmann.net>

	* augeas.pc.in: make -lfa a private lib

	Fix the pkg-config file augeas.pc
	The file previously was unusable because it did not include linking to
	libfa, and did not list libselinux as a dependency if it was built with
	support for it. This should now all work

2017-08-18  David Lutterkort  <lutter@watzmann.net>

	NEWS: include news for 1.8.1

2017-08-18  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (parse_name): correctly handle trailing whitespace in names
	When a name ended in whitespace, we incorrectly assumed it was always ok to
	trim that whitespace. That is not true if that whitespace is escaped,
	i.e. if the path expression is something like '/x\ '. In that case, the
	name really needs to be literally 'x ', i.e., we can not trim that
	whitespace.

	The incorrect behavior led to turning '/x\ ' first into 'x\' and then,
	because we assume that '\' is always followed by a character inside the
	string, when we removed the escaping '\', we would read beyond the end of
	the intermediate string result; if we were lucky, that would lead to a
	crash, otherwise we'd continue with junk.

	We now make sure that escaped whitespace at the end of a string does not
	get stripped, avoiding all these headaches.

	Fixes RHBZ https://bugzilla.redhat.com/show_bug.cgi?id=1475621

2017-06-30  Doug Wilson  <dallendoug@users.noreply.github.com>

	update rsyslog lens to includ files in rsyslog.d dir (#475)

2017-06-11  David Lutterkort  <lutter@watzmann.net>

	put.c: improve the error when putting l* fails
	We now include both the tree that we failed to match and the tree pattern
	that we wanted to match in the error.

	put.c: track the fully qualified path of our position in the tree
	Previously, we only tracked a path like /a/b/c and printed that in errors
	to indicate where in the tree the error occurred. That was ambiguous when
	there were multiple /a/b's for example. We now include the more precise
	path /a[2]/b[3]/c in error messages to clarify that.

	put.c (regexp_match_error): add newlines to error to increase readability

	regexp_escape: suppress some internal changes to regexps
	We make sure regexps for atypes do not ever match characters
	\001-\004. When we print them, we want to keep that from the user to make
	the regexps closer to what the user typed, and to remove unnecessary
	clutter.

2017-06-11  David Lutterkort  <lutter@watzmann.net>

	tests/test-api.c: include libgen.h
	Missing that include leads to segfaults on OS X Sierra.

	Thanks to yan12125 for the fix

	Fixes https://github.com/hercules-team/augeas/issues/461

2017-06-11  David Lutterkort  <lutter@watzmann.net>

	doc/naturaldocs/conf/lenses/Menu.txt: fix broken syntax
	This fixes a syntax error introduced in c2dd3ac8 that made building fail

2017-06-10  Omer Katz  <omer.drow@gmail.com>

	Parse available sites for nginx (#471)
	Some of the configuration for nginx at least for Debian & Ubuntu can be found at `/etc/nginx/sites-available/`. These files are specific to each server nginx is going to proxy.

2017-05-22  JSP-GIHS  <JSP-GIHS@users.noreply.github.com>

	Added the group-sorted keyword in line with group-compress, and a (#462)
	suitable test to the test_xymon.aug
	
	Confirmed operational on a FreeBSD 10-RELEASE server.

2017-05-17  Jose Plana  <jplana@gmail.com>

	Add new nslcd.conf lenses to parse nss-pam-ldapd configuration file

2017-03-22  Dominic Cleal  <dominic@cleal.org>

	Update gnulib to 7b8cbb9

2017-03-21  David Lutterkort  <lutter@watzmann.net>

	Version 1.8.0

2017-03-18  David Lutterkort  <lutter@watzmann.net>

	augeas.spec.in: sync with latest from Fedora; add -static subpackage

	Reorganize how help lists all commands

	Add an 'info' command to print important runtime information

	Make changing context node more discoverable with a 'context' command

2017-03-17  Craig Miskell  <craig@catalyst.net.nz>

	Fix for rsyslog rainerscript module loading, with options

2017-03-15  David Lutterkort  <lutter@watzmann.net>

	Update NEWS and AUTHORS with information about Radicale lens

2017-03-15  James Valleroy  <jvalleroy@mailbox.org>

	Add radicale lens test to list

	Add test for radicale lens

	Add lens for radicale config file

2017-03-15  David Lutterkort  <lutter@watzmann.net>

	Reduce the total amount of memory used by Augeas
	The pattern buffers for compiled regular expressions take up a large amount
	of space. Previously, we had placed calls to lens_release strategically so
	that that memory gets released when we are done with a lens for a while
	(for example, after loading all files described by a transform)

	That overlooked that the interpreter compiles regular expressions when it
	loads lenses. We now also release lens storage after loading an entire
	module. That requires that regular expressions are compiled again when we
	start actually loading files, but the additional regex compilation does not
	seem to affect the overall runtime. It does dramatically reduce maximum
	memory needed by an 'augtool -L quit'. On my machine, it drops from about
	90MB to about 20MB.

2017-03-14  David Lutterkort  <lutter@watzmann.net>

	Ssh: only look for *.conf files in /etc/ssh/ssh_config.d
	The previous commit would have slurped in all files in that directory, but
	only *.conf files are important.

	Patch by Ian Mortimer

2017-03-09  David Lutterkort  <lutter@watzmann.net>

	Ssh: also look for files in /etc/ssh/ssh_config.d
	Patch by Ian Mortimer

2017-03-01  David Lutterkort  <lutter@watzmann.net>

	Split aug_to_xml into its own source file
	This makes it possible to statically link against libaugeas without pulling
	libxml in (assuming the code does not call aug_to_xml)

2017-02-24  David Lutterkort  <lutter@watzmann.net>

	Add a new aug_source API call and 'source' command in augtool
	Fixes https://github.com/hercules-team/augeas/issues/384

2017-02-23  Jörg Krause  <joerg.krause@embedded.rocks>

	src/augtool: fix multiple definition of xasprintf
	`xasprintf` is defined both in *internal.c* and *augtool.c*. This
	breaks building augeas statically:

	```
	./.libs/libaugeas.a(internal.o): In function `xasprintf':
	internal.c:(.text+0x934): multiple definition of `xasprintf'
	augtool.o:augtool.c:(.text+0x8a4): first defined here
	collect2: error: ld returned 1 exit status
	```

	Mark the definition of xasprintf in *augtool.c* as a private copy by
	prefixing the function name with an underscore and making the function
	static.

2017-02-20  Jason Lingohr  <lingfish@users.noreply.github.com>

	Postfix_Virtual: Allow underscores in e-mail addresses
	Fixes #439

2017-02-17  Jörg Krause  <joerg.krause@embedded.rocks>

	Interfaces: fix documentation typos

2017-02-17  Xavier Mol  <xavier.mol@kit.edu>

	Multipath: updated for multipath-0.4.9-99.el7

2017-02-07  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: add new directives and options
	Add support for new directives and options from chrony 3.0 and 3.1.

	Chrony: allow floating-point numbers

2017-02-07  Dustin Wheeler  <mdwheele@ncsu.edu>

	[krb5.aug] Support realms that start with numbers (#437)
	Currently, the default kerberos configuration that ships with
	Ubuntu has a realm that starts with a number (1TS.ORG). This
	causes the parser to fail and prevents krb5.conf from being
	available via augtool.
	
	This patch allows numbers 0-9 as the first character of a
	realm.

2017-01-10  Pat Riehecky  <jcpunk@gmail.com>

	yum.aug: Yum lenses work on DNF, add them to import list (#434)

2017-01-03  Daniel Dico  <ddico@oerp.ca>

	php.aug  - Fix php7 FPM support
	Update path to reflect the transition from:
	/etc/php5/ to /etc/php/7.0/

2016-12-23  Jason A. Smith  <smithj4@bnl.gov>

	Fix #430 - support Krb5 include(dir)?
	Updated the Krb5 lens to support the include(dir)? directives,
	with test case.

2016-12-23  Iavael  <iavael@users.noreply.github.com>

	Removed trailing space in token in slapd.lens

2016-11-24  David Lutterkort  <lutter@watzmann.net>

	Xml: process external entities in DOCTYPE declaration
	See http://www.w3.org/TR/2006/REC-xml11-20060816/#sec-external-ent for the
	required syntax.

	Based on initial patch by Adam Bottchen.

	Fixes https://github.com/hercules-team/augeas/issues/142

2016-11-11  Dominic Cleal  <dominic@cleal.org>

	Tmpfiles: parse three digit file modes

	Tmpfiles: parse two character argument fields

	Tmpfiles: permit 'q'/'Q' entry types

2016-11-09  David Lutterkort  <lutter@watzmann.net>

	Version 1.7.0

2016-11-05  David Lutterkort  <lutter@watzmann.net>

	Refine handling of multiple transforms handling the same file
	We used to blindly flag an error when there were multiple transforms that
	handled the same file. That is now ok as long as these transforms all use
	the exact same lens.

2016-11-03  Richard W.M. Jones  <rjones@redhat.com>

	Grub: add alternate locations for UEFI grub 1 config file.
	The path looks like "/boot/efi/EFI/redhat/grub.conf", with "redhat"
	substituted for other vendors.

2016-11-02  David Lutterkort  <lutter@watzmann.net>

	Cron_User: new lens for user crontab files
	The user crontab files in /var/spool/cron have a slightly different format
	from /etc/crontab in that they do not have a 'user' field as that's implied
	by the filename. Unfortunately, it is not possible to use Cron.lns, since
	defining Cron.entry as

	  let entry       = [ label "entry" . indent
	                    . prefix?
	                    . ( time | schedule )
	                    . (sep_spc . user)?
	                    . sep_spc . store Rx.space_in . eol ]

	(i.e., with a ( .. )? around the user name) leads to typecheck errors.

	This lens is a minor variation on Cron.lns and just removes the bits about
	the user field.

2016-11-02  Richard W.M. Jones  <rjones@redhat.com>

	gnulib: Allow tests to be disabled with ./configure --disable-gnulib-tests
	gnulib tests sometimes fail for reasons which are everything to do
	with gnulib and nothing to do with Augeas.  Allow them to be skipped.

2016-10-28  David Lutterkort  <lutter@watzmann.net>

	Properly check composite regular expressions for syntax errors
	We used to not properly check the syntax of regular expressions that are
	constructed. For example, in the construct

	    let rx = /a/ | /b)/

	we would not check whether /b)/ is syntactically correct, which would later
	lead to Augeas crashing. The reason for this was that literals had types
	assigned to them before we actually checked them, i.e., the assumption was
	that values didn't need any checking beyond setting their type, which is
	not true for regular expressions.

2016-10-28  David Lutterkort  <lutter@watzmann.net>

	* src/get.c (recursive parsing): simplify logic around get/parse_combine
	Instead of having explicit if statements to decide whether to call
	get_combine or parse_combine at various places, store a pointer to the
	appropriate one in struct rec_state and call that instead.

	* src/get.c (visit_exit): address possible leak of TREE

	* src/get.c: properly propagate errors from the various frame handling helpers

2016-10-28  David Lutterkort  <lutter@watzmann.net>

	* src/errcode.h (ensure, ensure0): do not compile out when NDEBUG is set
	The two macros ensure and ensure0 have an important sideeffect in that they
	set Augeas' internal error code and their failure can therefore be used to
	detect errors and return early for error handling.

	It is therefore a bad idea to make it possible to compile them out by
	setting NDEBUG as that will change the overall control flow
	considerably. Leaving htem always on also will have minimal performance
	impact, especially in the non-error case.

2016-10-28  David Lutterkort  <lutter@watzmann.net>

	* src/get.c: properly propagate errors from push_frame

	* src/get.c: comment better how traversing a recursive parse tree works

	* src/get.c: simplify recursive lens handling by fixing frame stack
	The stack for frames on which we remember results from traversing the parse
	tree with visit_enter/visit_exit was implemented very oddly: pop_frame
	removed a frame and returned the new top. It now returns the top of the
	stack that we just popped, i.e., the old top, which makes it possible to
	get rid of some odd ways in which we got intermediate results off the
	stack.

2016-10-27  Craig Miskell  <craig@stroppykitten.com>

	Opendkim: new lens for /etc/opendkim.conf

2016-10-05  Jason Antman  <jason@jasonantman.com>

	Splunk: support Splunk Universal Forwarder and underscore-prefixed keys for 6.x
	Fixes https://github.com/hercules-team/augeas/issues/407

2016-10-05  David Lutterkort  <lutter@watzmann.net>

	* tests/cutest.c: fix indentation by removing tabs
	This file used tabs for indentation which causes errors about misleading
	indentation with GCC 6. Replacing tabs with spaces fixes that.

	* tests/cutest.h: remove misleading const decls from struct CuTest

2016-10-03  David Lutterkort  <lutter@watzmann.net>

	* NEWS: add note about coverity/ASAN fixes

2016-10-03  David Lutterkort  <lutter@watzmann.net>

	* src/augeas.c (aug_load): make detection of file metadata safer
	When we went to clean up files that are not managed by a lens anymore, we
	just assumed that anything with a 'path' child held metadata for a file and
	removed that metadata and the actual contents.

	That could lead to a situation where creating a node /augeas/files/path
	would lead to a crash. We now use an explicit flag in the tree node that
	holds file metadata to indicate the fact rather than just inferring it from
	the presence of a 'path' child, so that we will never inadvertently free
	everything under /augeas/files.

2016-10-02  David Lutterkort  <lutter@watzmann.net>

	* examples/fadot.c: free the result from FA_AS_REGEXP
	This avoids false positives with address sanitizer

	* src/get.c (visit_exit): do not leak SKEL when we fail to allocate DICT

	* src/get.c (parse_combine): do not leak SKEL or DICT on error
	If we encountered an (internal) error in ENSURE, it was possible that we
	leaked SKEL and DICT. We now make sure they get set to NULL when we have
	saved them, and free them if they are not NULL yet.

	* src/augrun.c (aug_srun): make sure we always initialize CMD
	Otherwise, we might try to free cmd.opt before it has been set to NULL.

	* src/put.c (lns_put): do not leak various things when parse fails
	When parse failed, and we needed to skip the actual put, we used to return
	straight away, even though we were holding on to a number of intermediate
	data structures. Now we properly clean them up.

	* src/builtin.c (pathx_parse_glue): do not ref INFO passed to make_pathx_exn
	make_pathx_exn already increases the reference count appropriately. The
	additional reference caused INFO to be leaked.

	* src/augrun.c (cmd_errors): do not leak filename

	* src/pathx.c (parse_location_path): do not leak STEP on error

	* src/pathx.c (axis_sep): remove unused constant

	* tests: fix various memory leaks caused by the tests

2016-10-01  David Lutterkort  <lutter@watzmann.net>

	* src/get.c (rec_process): do not leak span on error

	* src/get.c (visit_exit): do not deref TREE until after we checked it for NULL

	* src/get.c (visit_enter): do not allocate a new span for L_MAYBE
	There was no good reason why we allocated a span here; in fact, it would
	only get leaked as there was nothing in visit_exit that would move the span
	into the tree.

	* src/get.c (get_subtree): make sure we do not leak a span on error

	* src/internal.h (move): new macro to move ownership of pointers

	* src/augrun.c (aug_srun): do not leak command_opt when 'quit' is issued

	* src/transform.c (transform_file_error): do not leak EP

	* tests/fatest.c: free memory allocated by tests
	Without this cleanup, it's too hard to spot genuine leaks from address
	sanitizer

	* cutest.h (CuSuiteFree): new function to free memory held by a suite

	* src/builtin.c (make_pathx_exn): avoid unnecessary alllocation and leak
	We used to call STRDUP for no good reason on the constant error message
	returned by PATHX_ERROR and promptly leaked it.

	* src/augeas.c (dump_tree): do not leak P when we can't compile pathx "/*"

2016-10-01  David Lutterkort  <lutter@watzmann.net>

	* src/syntax.c (define_native_intl): fix memory leak on allocation error
	When we tried to allocate BODY and allocation failed, we still had
	allocated memory in PARAMS that was not freed in the error label. We now
	free that list on error.

	To make sure we do not try and free PARAMS when it has been linked into
	FUNC, we set it to NULL after the call to BUILD_FUNC.

	The call to BUILD_FUNC also erroneously checked the return value for NULL,
	even though this function can never return NULL. This check was removed.

2016-10-01  David Lutterkort  <lutter@watzmann.net>

	* src/fa.c (determinize): do not leak INI in an error case
	If we succeed in allocating INI ourselves, but then fail to push the
	initial state into it, we would leak INI. Fix that by explicitly freeing
	it.

	* src/get.c (print_frames): do not leak the result of format_lens
	Fixing this to make coverity happy - it's unused code in a debugging routine

	* src/internal.c (path_expand): remove unnecessary NULL check
	The TREE argument must not be NULL, so there's no need to check for that
	later on

	* src/info.c, src/lens.c: shore up some error formatting routines
	These routines are now more resilient to being passed NULL arguments

	* src/pathx.c (ns_from_locpath): insist that arg LP is not NULL
	This allows us to remove some confused checking

	* src/lexer.l (regexp_literal): avoid knockon error on allocation failure

2016-09-30  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (parse_relative_location_path): avoid leak on ENOMEM
	When we ran out of memory, we did not properly free the previously
	allocated LOCPATH.

	* src/pathx.c (clone_vlaue): remove incorrect call to free
	We were calling free on a pointer into the interior of an array

	* src/augeas.c (unlink_removed_files): avoid leaking PX on pathx parse error

	* src/lens.c (typecheck_n): make clearer why we return early

	* src/augeas.c (aug_load_file): check xasprintf call for alloc error

	* src/transform.c (text_retrieve): remove unused variable

	* src/transform.c (remove_file): remove some unreachable code

2016-09-30  David Lutterkort  <lutter@watzmann.net>

	* src/get.c: move saving/restoring match state into macros
	The main reason to make these macros is that it makes sure we set
	state->regs to NULL when we save registers so that any error path does not
	inadvertently free the caller's registers.

	Before we inconsistently set state->regs to NULL manually, and there were
	cases where we could have freed the caller's registers when encountering
	certain errors.

2016-09-30  David Lutterkort  <lutter@watzmann.net>

	* src/transform.c (text_store): remove dead code

	* src/augeas.c (aug_to_xml): do not leak P on syntax error in PATHIN

	* src/augeas.c (aug_defnode): do not leak p on syntax error in expr

	* src/augeas.c (aug_rm): do not leak p on syntax error in path

	* src/augeas.c (aug_text_store): fix leak of p on syntax error in path

	* transform.c (xfm_error): do not leak v or l if allocation of one of them fails

	* augeas.c (aug_setm): fix leaking of bx and sx

	* augeas.c (aug_set, aug_print): do not leak p when path expr has syntax error

	* transform.c (load_file, text_store): do not leak info on some error paths

	* transform.c (load_file): avoid leaking span on parse errors

	Update gnulib to 5f7358cc

2016-09-29  David Lutterkort  <lutter@watzmann.net>

	* NEWS: update with details for Issue #398

	* src/put.c (skel_instance_of): simplify convoluted logic for L_STAR
	We know that l->tag is L_STAR, but hte code was written as if it could be
	something else, too.

	* src/lens.h (struct skel): add comment that skels in union is used for L_SQUARE

2016-09-29  David Lutterkort  <lutter@watzmann.net>

	* src/put.c (skel_instance_of): fix illegal memory access
	We used to always access skel->skels; but that is only valid if the tag for
	skel->skels is L_CONCAT or L_STAR. Because of this, we could, for example
	access skel->skels for a skel tagged as L_DEL, which is illegal.

	This patch adds a fix to the L_CONCAT case so that we only look at
	skel->skels if the skel is tagged that way.

	Fixes https://github.com/hercules-team/augeas/issues/398

2016-09-27  David Lutterkort  <lutter@watzmann.net>

	* src/augtool.c (main): call aug_close before returning
	While it's not necessary to call that, as the OS will clean up for us, it
	might help in uncovering memory handling errors more easily.

2016-09-27  David Lutterkort  <lutter@watzmann.net>

	* src/get.c (visit_enter, visit_exit): fix use-after-free when spans are used
	When spans are enabled, we used to store a a pointer to the same span both
	in a frame and in the current state for L_SUBTREE lenses, which meant that
	two different tree nodes might have pointers to the same span. That is
	counter to the assumptions made about tree nodes, in that they need to own
	the spans attached to them, resulting in a use-after-free. It would also
	record incorrect span information in one of the tree nodes.  We now
	allocate a new span when we store one in the frame - that way we are
	guaranteed that there is no aliasing.

	With L_MAYBE lenses, visit_enter allocated a new span in state, thus
	possibly leaking the one that might be there already. We now store that
	span in the frame that we push for L_MAYBE, avoiding that leak.

	Finally, we popped frames in visit_exit without doing anything with
	them. We now also free any associated span to make sure we do not leak that
	information.

	Fixes https://github.com/hercules-team/augeas/issues/397

2016-09-26  David Lutterkort  <lutter@watzmann.net>

	* src/transform.c (transform_load): fix leak when ignoring a file match

	* src/try: allow passing arguments to augtool when running valgrind

2016-08-20  David Lutterkort  <lutter@watzmann.net>

	Update gnulib to 6fafd688

2016-08-18  Michael Wodniok  <michi@noorganization.org>

	Reflect Ubuntu 16.04 location of php.ini (#399)
	php.ini has moved with upgrade from PHP5 to PHP7 (included in Ubuntu 16.04).

2016-08-16  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update Copyright date to 2016

2016-08-15  Dominic Cleal  <dominic@cleal.org>

	Csv: remove unused caret from comment regexp
	Fixes #396

2016-08-06  David Lutterkort  <lutter@watzmann.net>

	Version 1.6.0

	man/augtool.pod: clarify the description of --load-file and load-file

2016-08-06  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c: make numbers in path expressions 64 bit integers
	Previously, they were whatever 'int' was, which might be too small, for
	example to handle timestamps. With making them int64_t, it is now possible
	to find files that have changed since a certain point in time with

	  match /augeas/files//*[mtime][int(mtime) >= TIMESTAMP]

	where TIMESTAMP is in seconds since the epoch

2016-08-06  Loren Gordon  <loren@fleet-it.com>

	Uses spaces between tokens instead of tabs for pam files
	pam.d(5) man page states: "The format of each rule is a space
	separated collection of tokens..." Previsouly, pam.aug used
	`Util.del_ws_tab` to insert tabs as a token separator. This patch
	modifies pamconf.aug and pam.aug to use `Sep.space`, which
	uses a space as a separator instead.

	Fixes #236

2016-08-06  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: include lbu.conf
	Alpine Linux Local Backup Utility

2016-08-06  Omer Katz  <omer.drow@gmail.com>

	Added nginx locations for homebrew installed nginx.

2016-08-05  g-coder  <garima.g@samsung.com>

	NO_VA_END
	Function 'va_end' was not called before internal.c:55 and internal.c:64 inside function 'pathjoin'.
	Added 'va_end(ap)' before return statement.

2016-07-22  g-coder  <garima.g@samsung.com>

	DEREF_OF_NULL
	Return value of a function 'add_state' is dereferenced at fa.c:2776 without checking.
	Added check on return value.

2016-07-11  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2016-07-11  Josef Reidinger  <jreidinger@suse.cz>

	Ntp: fix restrict to allow also -4 and also fix save/store ability (#386)
	* fix restrict to allow also -4 and also fix save/store ability
	* use backward compatible ip flags

2016-07-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2016-07-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add aug_load_file to load individual files
	API:

	  - Add aug_load_file() API entry to load an individual file

	Augtool:

	  - Add -l|--load-file option
	  - Add load-file command

	Internal:

	  - change transform_load() signature to take a FILE filter
	  - expose filter_matches() in transform.h

2016-06-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add /etc/profile and /etc/byobu to Shellvars.lns

2016-06-22  Dominic Cleal  <dominic@cleal.org>

	Httpd: follow line continuations in comments

2016-06-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2016-06-17  Anton Baranov  <abaranov@linuxfoundation.org>

	Add lens to parse postfix password maps

2016-06-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2016-06-13  Craig Miskell  <craig@catalyst.net.nz>

	Support for rsyslog RainerScript syntax
	Specifically configuration objects per http://www.rsyslog.com/doc/v8-stable/rainerscript/configuration_objects.html

2016-06-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS and NEWS

2016-06-10  Craig Miskell  <craig@catalyst.net.nz>

	Recent ntp.conf allows for 'pool' instead of 'server' et al

2016-05-16  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS & NEWS

2016-05-16  Robert Moucha  <robert.moucha@gooddata.com>

	Add allow_writeable_chroot boolead option to vsftpd lens
	* available since version 2.3.5 of vsftpd
	* not well documented, yet widely used

2016-05-16  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	It's already 2016

2016-05-12  David Lutterkort  <lutter@watzmann.net>

	Version 1.5.0

	Remove some test files with very long names
	Since tar and automake have conspired to make it impossible to distribute
	files with very long names, simply remove them; we still get coverage of
	what we need since there is another ifcfg file with special characters in
	the name

	* Makefile.md: distribute HACKING.md rather than the now nonexistant HACKING

2016-05-08  Dominic Cleal  <dominic@cleal.org>

	Httpd: parse escaped spaces in directive/section arguments

	Httpd: allow blank continuation lines in section args

2016-05-07  David Lutterkort  <lutter@watzmann.net>

	* augrun.c (cmd_errors): include the path where an error happened if there is one

	Make the error message when a tree does not match a lens easier to read

	aug_get: set *value to NULL even if called with invalid path
	Fixes https://github.com/hercules-team/augeas/issues/372

2016-05-05  David Lutterkort  <lutter@watzmann.net>

	NEWS: add entry for chrony-2.4 additions

2016-05-05  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: add new options
	chrony-2.4 will have a new maxdrift directive and new options for the
	local directive.

2016-04-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Properties: add test for empty comment

2016-04-27  David Lutterkort  <lutter@watzmann.net>

	Set MALLOC_CHECK_ for some tests
	The malloc in glibc can be told to check and abort a program for some cases
	of incorrectly using memory. Turn these checks on for the lens and
	interpreter tests (in tests/modules/) to give us some better coverage and
	so that we can spot some memory handling errors.

2016-04-27  David Lutterkort  <lutter@watzmann.net>

	Fix buffer overflow in format_union_atype
	The change in commit 234de0e did not correctly calculate the length of the
	output buffer, which would lead to writing beyond the end of that buffer,
	and ultimately to memory corruption.

	The format_atype (and ultimately, format_union_atype) functions are not
	just used for debugging printing purposes, but also for error reporting
	when users create invalid subtrees and try to save them. In that case,
	merely creating an invalid tree can lead to a segfault.

	This change corrects the length calculation and adds a test that fails with
	the old length calculation, provided the test is run with MALLOC_CHECK_=3
	in the environment.

	Fixes issue #349

2016-04-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2016-04-25  Gerlof Fokkema  <gerlof.fokkema@gmail.com>

	Add support for redirecting output to named pipes.

2016-04-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2016-04-23  Chris Reeves  <chris.reeves@york.ac.uk>

	logrotate: support dateyesterday option (GH #367)

2016-04-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS and NEWS

	Puppetfile: add support for moduledir (Christoph Maser)

2016-04-18  Cédric Bosdonnat  <cedric.bosdonnat@free.fr>

	Add lens to parse /etc/default/star
	/etc/default/star is not really matching the shellvars expected syntax.
	Create a lens for it based on man 1 star and exclude it from the
	shellvars lens.

2016-04-16  Cédric Bosdonnat  <cedric.bosdonnat@free.fr>

	smbusers: add support for ; comments

2016-03-31  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	add paths to default filters
	additions mostly specific to Alpine Linux directory layout

2016-03-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Updating NEWS

2016-03-31  Cédric Bosdonnat  <cedric.bosdonnat@free.fr>

	Exclude network/if-up.d/SuSEfirewall2 in shellvars lens
	openSUSE has /etc/sysconfig/network/if-up.d/SuSEfirewall2 that is not a
	shell variable script, exclude it to avoid errors.

2016-03-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2016-03-31  Cédric Bosdonnat  <cedric.bosdonnat@free.fr>

	host_conf lens: spaces between list items support
	List items are separated by commas in host.conf, but we may find spaces
	on top of the comma.

2016-03-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS and NEWS

2016-03-30  Cédric Bosdonnat  <cedric.bosdonnat@free.fr>

	inputrc lens: support @else
	@if structures can also have an @else, let's read them into another
	subtree.

	inputrc lens: support mapping like ","
	The mapping values aren't always words. They can also be quoted values
	containing characters like [,+/*-]

2016-03-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add missing test

2016-03-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	MySQL: include /etc/my.cnf.d/*.cnf (fix #353)

2016-02-26  Dominic Cleal  <dominic@cleal.org>

	Httpd: permit backslashes in section tags
	Fixes a regression introduced by 0b22176 which failed when a backslash
	was present in a section tag.  Now it's permitted apart from being the
	last character, when it's taken to be a line continuation.

2016-02-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	NEWS

	Trapperkeeper: new lens for Puppetserver configuration files

2016-02-23  Dominic Cleal  <dominic@cleal.org>

	Httpd: parse line continuations in section arguments

2016-02-11  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2016-02-11  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: improve lens
	Add new directives and options that were added in chrony-2.2 and
	chrony-2.3.

	Also, improve parsing of access configuration. The allow, deny,
	cmdallow, and cmddeny directives can be specified with no address and
	they can use the "all" option.

2016-01-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	YAML: continued lines

	YAML: Documentation

	YAML: add support for headers

2015-12-24  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: add unsupported syntax to tests (Issue #343)

2015-12-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Interfaces: add support for source-directory (Issue #306)

	Update NEWS

	Shellvars: support subshells (Issue #339)

	Shellvars: newlines in start of functions

	Shellvars: allow newlines after actions

	Shellvars: support comments after function name (Issue #339)

2015-12-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	AptConf: allow empty hash-style comments

	Util: add empty_any

	Update NEWS

2015-12-22  Omer Katz  <omer.drow@gmail.com>

	Nginx: add @server simple nodes (Issue #335)
	Thanks to Omer Katz for the test case.

2015-12-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2015-12-22  Dimitar Dimitrov  <mitkofr@yahoo.fr>

	Yaml subset lens

2015-12-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Httpd: support perl directives (Issue #327)

2015-12-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2015-12-18  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: allow command-specific environment variables

2015-12-18  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse directive args containing quotes

2015-12-17  Dominic Cleal  <dcleal@redhat.com>

	* tests/test-save.c (testSaveNoPermission): skip when root

2015-12-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2015-12-17  florian chazal  <florianchazal@gmail.com>

	Vsftpd: add isolate and isolate_network options

2015-12-17  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: test case for wrapping command arguments

2015-12-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2015-12-17  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: allow wrapping command sequences

2015-12-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Nginx: allow masks in IP keys and IPv6 (GH #260)

2015-12-11  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse directive args starting with double quote
	ErrorDocument and similar directives can take a message as the last or
	only argument, which starts with a double quote and ends at the EOL.

	Fixes #330

2015-12-07  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse wordlists in braces in SSLRequire directives

2015-12-04  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse multiple ending section tags on one line

	Httpd: parse mismatching case in opening/closing tags

2015-12-02  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse backslashes at the start of directive args
	Fixes #324

2015-12-01  David Lutterkort  <lutter@watzmann.net>

	Skip hidden tree nodes in path expressions
	When we were evaluating path expressions, we were not skipping hidden tree
	nodes, i.e. tree nodes whose label is NULL. In most cases, that's not
	visible to users, but when we match something like /foo/*[2] where /foo has
	a bunch of hidden children, the result was not what the user might expect,
	as we might actually return a hidden node to aug_match, which would
	suppress that node and make it seem to the user as if nothing had matched.

	With this patch, we try to skip over hidden nodes while evaluating the path
	expression to avoid this issue.

	Thanks to Xavier Mol for reporting this

2015-11-26  David Lutterkort  <lutter@watzmann.net>

	* HACKING.md: add a note on using Homebrew to install readline on OSX
	Thanks to Daniel Trebbien for the tip

2015-11-26  David Lutterkort  <lutter@watzmann.net>

	* src/augtool.c: add stubs for readline functions missing on OSX
	OSX ships with a crippled version of readline, libedit, which does not
	contain rl_crlf and rl_replace_line. This patch makes builds on OSX work
	again by providing trivial replacements for these functions.

	Fixes https://github.com/hercules-team/augeas/issues/256

2015-11-26  David Lutterkort  <lutter@watzmann.net>

	* HACKING.md: rename from HACKING and format as markdown

2015-11-26  David Lutterkort  <lutter@watzmann.net>

	aug_rm: fix segfault when deleting a tree and one of its ancestors
	In a tree like /files/1/2, when we execute 'rm /files//*', the path
	expression matches /files/1 and /files/1/2. When tree_rm goes to delete
	these two nodes, it first deletes (frees) /files/1 and all its
	descendents. By the time we try to delete /files/1/2, the pointer we have
	to that is no longer valid and we end up causing a double-free.

	With this change, we make sure we only delete a node if none of its
	ancestors is being deleted beforehand in the same operation - deleting a
	node, and one of its ancestors afterwards is fine as the pointer to the
	ancestor is still valid.

	Fixes https://github.com/hercules-team/augeas/issues/319

	Special shoutout to Geoff Williams for finding, diagnosing and filing a
	great bug report about this.

2015-11-26  Daniel Trebbien  <dtrebbien@gmail.com>

	fa.h: Minor documentation improvements

2015-11-26  Daniel Trebbien  <dtrebbien@gmail.com>

	Fix fa_ambig_example() when the automata involve NULs
	After the example for `amb' was calculated, the code that generated the
	*UPV string and pointers *PV and *V within this string used strlen() to
	calculate the length of the example; however, the example string may
	contain NUL bytes. Thus, it could happen that not enough space would be
	allocated for the *UPV string.

	Instead of computing the length of the example using strlen(), just use
	`s_len'.

	Added a new test to fatest, testAmbigWithNuls.

2015-11-25  Dominic Cleal  <dcleal@redhat.com>

	Httpd: parse backslashes in unquoted directive args
	Fixes issue #307

2015-11-25  David Lutterkort  <lutter@watzmann.net>

	NEWS: updated for commit baa87fdc

	* src/augtool.c: print brief, more standard message when invalid option is given
	Instead of dumping all our help, just tell hte user to run with --help when
	they provide an unsupported option.

	* src/augtool.c: new option '--timing' to print timing info after each command

2015-11-25  Daniel Trebbien  <dtrebbien@gmail.com>

	Correct the documentation of fa_minimize()
	It uses the currently-set fa_minimization_algorithm.

	Fix a Clang 'sometimes-uninitialized' warning
	clang-700.1.76 was issuing a 'sometimes-uninitialized' warning for
	minimize_hopcroft() because it was possible for control flow to reach
	the `for (int i=0; i < nstates*nsigma; i++)' loop in done: before
	`nstates' and/or `nsigma' were initialized.

	Fix a Clang 'sometimes-uninitialized' warning in aug_escape_name()
	If `in' or `out' is NULL, then the uninitialized value of `result' was
	returned.

2015-11-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Ssh: add support for GlobalKnownHostsFile

2015-10-04  David Lutterkort  <lutter@watzmann.net>

	Update the end year in Copyright statements to 2015

	* man/ : update copyright in man pages, correct email address

	* man/augtool.pod: update copyright statement
	Because of Red Hat's copyright policy for employees, the statement
	'Copyright Red Hat' had never been true, and it was 'Copyright David
	Lutterkort' all along.

2015-09-30  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (ns_from_locpath): special-case 'name[42]' path expressions
	We know that in a path expression like 'name[42]', only one node can
	possibly match, and that we simply need to step through all the nodes and
	count until we've reached the 42nd matching node. This greatly simplifies
	how we construct the resulting nodeset, and is done in the new function
	position_filter.

2015-09-29  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (ns_filter): speed up by removing nodes in batches
	We used to remove nodes that did not match one-by-one by calling memmove
	for each of them. Now we batch runs of non-matching nodes and call memmove
	only once for each run. The common case of a predicate that matches only
	one node at a certain position ('service[17]') now requires two memmoves
	rather than size(ns)-1 many memmoves.

	This leads to a drastic performance improvement for large nodesets.

2015-09-29  David Lutterkort  <lutter@watzmann.net>

	Speed up the duplicate check when constructing nodesets
	When we evaluate path expressions, we need to construct nodesets, and they
	truly need to be sets, i.e. contain each node at most once. This leads to
	problems when a node has lots of children with the same name. The duplicate
	check in ns_add lead to O(n^2) behavior for nodes with n children.

	We simplify this by adding a flag to each tree node that we use only around
	repeated calls of ns_add when we construct a node set. This is possible
	since the construction of nodesets is very local, and it is therefore easy
	to determine where we need to put the call to ns_clear_added when we are
	done building the nodeset.

2015-09-29  Dominic Cleal  <dcleal@redhat.com>

	* test-perf.c (testPerfPredicate): add test showing slow predicates
	When parsing a file with NagiosObjects and many objects inside, a large
	tree forms like this:

	    /files/etc/nagios/objects/services.cfg/service[1]
	    /files/etc/nagios/objects/services.cfg/service[2]
	    ...
	    /files/etc/nagios/objects/services.cfg/service[5000]

	aug_get performance is pretty terrible at this size when using a path
	above, due to the evaluation of the [5000] predicate.  Paths without a
	predicate (e.g. using seq or uniquely labelled nodes) are retrieved
	quickly.

	The time taken to set and get 5,000 such nodes is recorded in
	tests/test-perf.log and is currently about:

	    testPerfPredicate = 66636ms

	A helper to run Valgrind's callgrind tool is added to src/try.

2015-09-15  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS

	Update NEWS

2015-09-15  Geoff Williams  <geoff.williams@puppetlabs.com>

	Sudoers: support for negated command alias (Issue #262)

2015-09-14  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Aptsources: fix name in Makefile

	Aptsources: rename test file properly

	Aptsources: support brackets with spaces in URI (GH #296)

	Aptsource: support operation on options (GH #295)

	Aptsource: support options (GH #295)

2015-09-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Dhclient: avoid put ambiguity for node without value

2015-09-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Merge commit 'refs/pull/289/head' of github.com:hercules-team/augeas

	Update NEWS and AUTHORS

2015-09-01  Oliver Mangold  <o.mangold@gmail.com>

	ssh lense: adding new keywords HostKeyAlgorithms, KexAlgorithms and PubkeyAcceptedKeyTypes

	multipath.conf lense: added bunch of missing keywords

2015-09-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

	Merge commit 'refs/pull/278/head' of github.com:hercules-team/augeas

2015-09-01  Justin Akers  <justin.akers@opengear.com>

	openvpn: simple ipv6 regex to save memory for tests

2015-08-28  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Puppetfile: separator is not mandatory

2015-08-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Json: parse verbatim escaped spaces and newlines in quotes

	Json: refactor escapes in quotes

	Json: allow escaped quotes and blackslashes

2015-08-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Reprepro_Uploaders: support unused group declaration

	Reprepro_Uploaders: support empty group declaration

	Reprepro_Uploaders: support group contains declaration

	Reprepro_Uploaders: support group declaration

2015-08-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Reprepro_Uploaders: support group conditions

	Shellvars: allow &&/|| in commands

2015-08-24  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Spacevars: Support flags
	Fix #279

	Typo

	Update NEWS and AUTHORS

2015-08-23  Gregory Smith  <gasmith@nutanix.com>

	Rsyslog: Improve property filter parsing.
	 - Treat whitespace after commas as optional.
	 - Recognize '~' as a valid syslog action (discard).

2015-08-06  Justin Akers  <justin.akers@opengear.com>

	openvpn: added all options available in OpenVPN2.3 and all tests

2015-08-05  Mathieu Alorent  <malorent.ext@orange.com>

	Reprepro_Uploaders: Add support for distribution field

2015-08-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: support pipes in commands

2015-08-03  Raphaël Pinson  <raphink@gmail.com>

	Shellvars: Allow (almost) any command
	    Note: this may have edge effects in recursive sublenses
	          that augparse cannot check.

2015-08-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2015-08-03  Joe Topjian  <joe@topjian.net>

	Keepalived: Allow notify option

	Keepalived: Expanding vrrp_sync_group block

	Keepalived: Adding vrrp_script options

	Keepalived: Added missing garp options

	Keepalived: Added mcast/unicast_src_ip and unicast_peer
	These are related option that handle unicast configuration of
	keepalived. They are configured as EOL options since I believe they can
	take both IPv4 and IPv6 addresses.

	Keepalived: Added more vrrp_instance flags

	Keepalived: Added vrrp_mcast_group4 and vrrp_mcast_group6

	Keepalived: fixing spacing/tag alignments and hanging spaces.

2015-08-03  Julien Pivotto  <roidelapluie@inuits.eu>

	Fstab: remove unneeded brackets

2015-08-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	CSV: New lens to parse CSV files (Issue #275)

	Update NEWS and AUTHORS

2015-08-03  Julien Pivotto  <roidelapluie@inuits.eu>

	Add a tmpfiles.d lens

2015-07-30  Dominic Cleal  <dcleal@redhat.com>

	Rhsm: new lens to parse subscription-manager's rhsm.conf

2015-07-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Json: improve readability

	Json: Cleanup and refactor
	Use comment_delim instead of comment_multiline
	Use Util.del_str instead of delim
	Use Quote.dquote
	Simplify comments

	Json: Move recursion tests to test_json.aug

2015-07-30  Joe Topjian  <joe@topjian.net>

	Rabbitmq: Utilizing regexes for some options

	Rabbitmq: Adding versions option to ssl_options

	Rabbitmq: Adding some missing simple options

	Rabbitmq: cluster_partitioning_handling
	Adds support for the rabbitmq.config cluster_partition_handling option.

	Rabbitmq: Removed space in option name

2015-07-30  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: allow && and || constructs after condition

	Shellvars: use sto_to_semicol in condition lens

	Shellvars: pattern nodes in case entries
	Breaking change: case entry values are now in a @pattern subnode.

2015-07-30  jamido  <jan.doleschal@lgl.bwl.de>

	Support for SLES
	Added SLES vhosts path

2015-07-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: add alias builtin support

	Shellvars: add eval builtin support

	OpenShift_Quickstarts: Fix tests after Json update

	OpenShift_Quickstarts: Use Json.lns lens

	Json: multiline comments

2015-07-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Json: support empty comments

	Json: Support comments, C-style

2015-07-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Ntp: support basic interface syntax

	AptConf: Support hash comments

	Util: Add comment_c_style_or_hash

2015-07-13  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: case: support quotes and spaces in pattern lists

	Shellvars: allow quotes in loop conditions

	Shellvars: allow wrapping builtin arguments to multiple lines

	Shellvars: guard against comments

	Shellvars: allow wrapping loop condition to multiple lines

	Shellvars: allow partial quoting, mixing multiple styles

2015-07-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: Add test for [[]]

	Shellvars: accept [] and [[]] builtins
	Fix GH #188

2015-07-13  Matt Dainty  <matt@bodgit-n-scarper.com>

	Update /etc/group lens for NIS map
	Supports an overridden and disabled password, i.e. `+:*::`

	Add support for /etc/master.passwd

2015-06-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Nginx: Add non-recursive ambiguities test

	Update NEWS

	Merge branch 'dev/xml_empty'

2015-06-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Rework Known_Hosts

	Known_Hosts: fix description

2015-06-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Xml: Accept empty document

2015-06-06  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Simplelines: parse OpenBSD's hostname.if(5) files

2015-06-05  Dominic Cleal  <dcleal@redhat.com>

	Update NEWS, AUTHORS

2015-06-04  Miroslav Lichvar  <mlichvar@redhat.com>

	Chrony: add missing directives and options
	Add all missing directives and options that are supported in the current
	chrony git.

	Chrony: include end of line in broadcast with port

	Chrony: allow indentation and don't allow comment on end of line

	Chrony: allow signed numbers

2015-06-02  David Lutterkort  <lutter@watzmann.net>

	Version 1.4.0

	* src/augeas_sym.version: correct version for aug_escape_name
	The (unreleased) version for aug_escape_name was erroneously set to 0.19.0
	in commit 1aa51f93; the correct version for the next release is 0.20.0

	Httpd: add test to verify that issue #140 is fixed
	Issue: https://github.com/hercules-team/augeas/issues/140

2015-06-02  David Lutterkort  <lutter@watzmann.net>

	Fix SEGV when target file is not writable
	When the file we want to wirte to is not writable by us, we used to
	segfault. With this change, we now report a proper error.

	Fixes https://github.com/hercules-team/augeas/issues/178

2015-06-02  David Lutterkort  <lutter@watzmann.net>

	Add the default ssl.conf from CentOS 6.6
	This shows that Issue #191 is fixed

2015-06-02  Matt Dainty  <matt@bodgit-n-scarper.com>

	Passwd: fix @nisdefault on OpenBSD
	Following passwd(5) on OpenBSD results in an /etc/passwd NIS entry like:

	    +:*:0:0:::

	Passwd lens barfs on the '*' password. Change to match how normal entries are
	matched.

2015-06-02  Borislav Stoichkov  <borislav.stoichkov@gmail.com>

	Passwd: support nis [+-]username syntax
	The /etc/passwd file can contain nis users with the syntax [+-]username for
	the pruprose of including or excluding specific accounts.

	Importing of particular users' accounts can be restricted by using the
	prefix "+" with a username.

	    root:x:0:0:root user:/home/root:/bin/bash
	    +bob::::::
	    +alice::::Alice:/home/alice:/bin/bash

	Certain users' accounts can be excluded from being imported by using the
	"-" prefix with a username.

	    root:x:0:0:root user:/home/root:/bin/bash
	    -bob::::::
	    +

	The string that can comprise a valid username has been updated to cover a
	range slightly larger that the definitions in POSIX
	(http://pubs.opengroup.org/onlinepubs/9699919799/ , section 3.431),
	is_valid_name() in chkname.c in shadow-utils and the NAME_REGEX definition
	in distributions where defined. Rx.word was too broad and did not allow for
	the -username syntax.

2015-05-27  Michael Moll  <kvedulv@kvedulv.de>

	integrate two patches from FreeBSD ports
	- /boot/loader.conf can be parsed with the sysctl lens
	- /etc/perodic.conf can be parsed with the shellvars lens

2015-05-23  David Lutterkort  <lutter@watzmann.net>

	Grub: support a password stanza inside a boot/title section
	The biggest change in this commit is changing the structure of lns: it now
	says that boot sections have to come after the general menu_setting and
	debian sections. Since 'password' is legal in both a top-level menu_setting
	and in a boot section, that is necessary to keep the lens unambiguous.

	Fixes https://github.com/hercules-team/augeas/issues/229

2015-05-23  Borislav Stoichkov  <borislav.stoichkov@gmail.com>

	Shadow: allow NIS entries
	Add support for the NIS default entry + and the nis default entry with
	overrides +::::::::

	Based on https://github.com/hercules-team/augeas/pull/237

2015-05-22  Geoffrey Gardella  <gardella@gmail.com>

	Updated tests/test-put-symlink-augsave.sh to remedy failure on Solaris
	Due to output from 'sum' command containing the filename.

	Fixes #242

2015-05-22  David Lutterkort  <lutter@watzmann.net>

	Nginx: change how we handle indentation of lines
	Before this change, any change to the file would drop all indentation from
	it. Now, we preserve existing indentation. Newly inserted lines don't get
	the indentation of their block, but at least we preserve it for existing lines

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	* NEWS: add note about errors command and better error messages
	Should have been part of the last 4 commits, but I fat-fingered the push.

	Suppress repeated errors about not finding a module
	We used to print 'Could not load module XYZ' every time that module wsa
	mentioned. To cut down the number of annoying error messages, we now create
	an empty dummy module when we fail to look one up; subsequent lookups will
	find that and therefore not print the error message again.

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	* src/lens.c (lns_format_atype): make output more readable
	Try to make the output more readable by using better formatting:
	  - each entry in a concatenation and a union now goes on its own line
	  - indent formatted entries

	This is not perfect, but much better than splatting everything into one line

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	Add an 'errors' command that pretty prints /augeas//error messages

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	Analyze 'short iteration' errors better
	When an iteration fell short, we would just throw our hands in the air and
	produce not very helpful information. We now try to find the exact place
	where some part of the iterated lens still matched and the rest didn't and
	provide that information to the user.

	Note that these errors will only be produced for regular lenses, not for
	recursive lenses

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	* src/get.c (vget_error): replace unchecked CALLOC with checked ALLOC
	One more place where a failing allocation won't cause a crash

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	Nginx: rework to support a much broader set of valid configurations
	The Nginx.lns is now recursive and can handle nested blocks.

	It can now also deal with some special block-start directives like
	'location' and 'if' which have additonal stuff between the keyword and the
	opening brace.

	The file tests/root/etc/nginx/nginx.conf if the stock Nginx configuration
	example from their siurce control, with everything that was commented out
	activated. Having that file makes sure (via tests/test-get.sh) that we
	successfully parse that file.

	Fixes https://github.com/hercules-team/augeas/issues/179

2015-05-21  David Lutterkort  <lutter@watzmann.net>

	Test_Nginx: no functional change, reformatted

2015-05-21  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: more associate array syntax

	Shellvars: support associative arrays

2015-05-20  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Known_Hosts: support aliases

2015-05-16  Michael Smith  <michael.smith@puppetlabs.com>

	Add /etc/puppetlabs/mcollective to mcollective lens
	In the latest release of Puppet, the mcollective paths have been updated
	to reflect the documentation at
	https://github.com/puppetlabs/puppet-specifications/blob/master/file_paths.md

	This commit adds server.cfg and client.cfg in
	/etc/puppetlabs/mcollective to the mcollective filter.

2015-04-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Puppetfile: Use seq instead of a fixed label

2015-04-21  Haotian Liu  <liuhaotian.air@gmail.com>

	Postgresql: add default paths used on Red Hat-based distros
	As of Postgres 9.4, postgresql.conf is stored in the database cluster's
	data directory

	See:
	http://www.postgresql.org/docs/9.4/static/runtime-config-file-locations.html

2015-04-21  timdeluxe  <tim.eilers@web.de>

	Limits: allow comments at end of line
	Here is my proposal for changing limits.aug lens to allow comments at the end of the line, which are no problem for the OS and heavily used in the limits.conf on our systems. Without that change you get a parse error.

2015-04-21  Steve Shipway  <steve@steveshipway.org>

	Jaas: add several improvements to cover more valid syntax
	Add flexibility to Jaas lens: allow comments within Modules, optionless
	flags, options without intervening linebreaks, and true/false option
	values without quotes.  All of these are valid syntax in the Shibboleth
	file.

2015-04-21  David Lutterkort  <lutter@watzmann.net>

	* src/get.c: fix possible NULL dereference
	Reported in https://github.com/hercules-team/augeas/issues/218 by ggardella

	* src/fa.c: fix a number of possible NULL dereferences
	Reported in https://github.com/hercules-team/augeas/issues/218 by ggardella

	* src/augtool.c: fix minor memory leak

2015-04-20  Dominic Cleal  <dcleal@redhat.com>

	Logrotate: support 'maxsize' directive
	Fixes RHBZ#1213292

2015-04-11  Jurjen Bokma  <j.bokma@rug.nl>

	Krb5: add keyword 'krb524_server'

	Krb5: allow realm names that start with lower case characters

2015-04-11  David Lutterkort  <lutter@watzmann.net>

	* src/parser.y: update to work with Bison 3.0.2

2015-04-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Httpd: Properly manage eol after opening tag
	Allow comments and empty lines after opening tag.

	Fix #220

2015-04-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Httpd: Make \ illegal in char_arg_dir
	Add tests to check non-recursive behaviour
	of partial lenses

	Fix #223

2015-04-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Httpd: Do not pass empty as body to section
	This causes a conflict with eol_comment over newlines.
	`empty` is just a generic part of `section`, not really a body.

	.travis.yml: Use sudo false and the apt addons

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	Logrotate: do not require a space before the opening brace
	The actual fix was in the previous commit c2abb62c, this just adds a test

	Fixes issue #123

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	Build (block_newlines): make the space before the opening brace optional
	Added block_newlines_spc for the palces where we really need a block to
	start with ' {'; it seems that everywhere else requiring that space was an
	oversight.

	The two lenses that needed the space are Dovecot and Xinetd.

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	Dovecot: no functional change; remove trailing whitespace

	Logrotate: no functional change; remove tabs

	NEWS: mention augtool fix from previous commit
	The fix came from https://github.com/hercules-team/augeas/pull/93

2015-04-04  Robert Drake  <rdrake@direcpath.com>

	* src/augtool.c: fix for readline add_history with interactive mode
	If you use interactive mode, augtool never adds anything to history that
	you type once the input becomes a normal tty.

	This is because it was checking stdin, which as far as the system is
	concerned is still !isatty().

2015-04-04  fonfon  <blubb@fonfon.at>

	Allow more fine-grained control of service_on entries

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	* tests/Makefile.am: fix breakage introduced in c1b7784e

2015-04-04  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Dns_Zone: new lens to parse DNS zone files

2015-04-04  Pat Riehecky  <riehecky@fnal.gov>

	AFS_Cellalias: new lens
	https://github.com/hercules-team/augeas/pull/210

2015-04-04  Pat Riehecky  <riehecky@fnal.gov>

	Iscsid: new lens
	Thanks to Joey Boggs for writing tests

	Fixes issue #174

	https://github.com/hercules-team/augeas/pull/216

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	NEWS: mention Logrotate change and issue # for Postfix_sasl_smtpd
	Minor changes for commits 2face8cf and c1b7784e

	Logrotate: support 'dateformat' directive
	Fixes issue #217

2015-04-04  David Lutterkort  <lutter@watzmann.net>

	Postfix_sasl_smtpd: new lens
	Fixes issue #182

	Contributed by larsen0815

2015-04-03  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (pathx_escape_name): also escape backslash
	Since backslash is an escape character in parse_name, we need to escape it
	with a backslash to make sure that parse_name is really the inverse of
	pathx_escape_name.

	Thanks to Eric Blake for spotting this problem with the initial attempt to
	escape names introduced in e4f0a677

2015-04-03  David Lutterkort  <lutter@watzmann.net>

	Revert previous commit 27e36585; that change did more than was needed
	I overlooked that pathx_escape_name already escaped whitespace, and
	therefore we only need to also escape backslashes. The next patch will add
	escaping of backslashes to patchx_escape_name.

2015-04-02  David Lutterkort  <lutter@watzmann.net>

	* src/pathx.c (pathx_escape_name): also escape backslash and space
	Since backslash is an escape character in parse_name, we need to escape it
	with a backslash to make sure that parse_name is really the inverse of
	pathx_escape_name.

	We also escape a space as that is used in some circumstances to end a name
	(when we encounter ' or ' or ' and ')

	Thanks to Eric Blake for spotting this problem with the initial attempt to
	escape names introduced in e4f0a677

2015-03-14  David Lutterkort  <lutter@watzmann.net>

	Shellvars: fix insertion at top of file that starts with blank lines
	Possible blank lines at the start of a file were mapped with Util.empty
	which produces empty 'hidden' nodes (nodes with NULL label and value)

	This causes problem when a user inserts something before these nodes, for
	example with "insert 'foo' before /*[1]". Even though the nodes that
	Util.empty produces are generally hidden from the user, they are still in
	the tree and /*[1] selects such a node. The resulting tree has a hidden
	node in the middle, something that Shellvars.lns does not allow and
	therefore putting this tree fails. This is really hard to understand for
	users as the tree they see with 'print' is indistinguishable from one that
	doesn't have these hidden nodes.

	To fix this, the changed lens simply deletes the blank lines at the
	beginning of the file without creating any tree nodes. This makes the above
	insertion work at the cost of losing these blank lines as soon as anything
	is inserted into or deleted from the file.

	Fixes #202

2015-03-14  David Lutterkort  <lutter@watzmann.net>

	Sysconfig: accept leading whitespace before variables
	Make sure we allow '  var=value' and similar entries in files

	Fixes part of https://bugzilla.redhat.com/show_bug.cgi?id=761246

2015-03-03  Pat Riehecky  <riehecky@fnal.gov>

	Chrony: fix error in spelling of 'measurements' and add test for that

2015-02-28  Jeremy Lin  <jjlin@cs.stanford.edu>

	augtool: on interrupt, cancel current line instead of exiting

2015-02-28  David Lutterkort  <lutter@watzmann.net>

	New API aug_escape_name
	Provide a way to escape the characters that are special in a path
	expression

	* src/internal.c (path_expand): escape path components as needed
	    path_expand, which is used to turn the name of a tree node into a path
	    component, now escapes special characters for path expressions so that the
	    resulting paths can be used to look up that node even if the node name
	    contains special characters.

	* src/transform.c (remove_file): do not use path_of_tree
	remove_file uses path_of_tree to derive the name of the file that should be
	removed. Since we will change path_of_tree so that it escapes certain
	characters, we need to use a different way to get at the filename.

	* src/pathx.c (pathx_escape_name): new function
	Several characters in a path component are treated special, such as '[' and
	']'; to treat a string containing such characters as a literal path
	component, they need to be escaped with a '\\'.

	Move constant 'follow' out of parse_name

	* src/try: when running from the cli, exec augtool
	Before, when using this script, it was not really possible to put the
	resulting augtool run into the background.

2015-02-26  Russell Knighton  <russellk@motionpicturesolutions.com>

	Added support for conf-available apache config file location

2015-02-09  Andrew Colin Kissa  <andrew@topdog.za.net>

	Add Mailscanner_Rules lens for MailScanner rules files

	Add Pylonspaste lens

	Add Pgbouncer lens

	Add Mailscanner lens

	Add Clamav lens

2015-02-03  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Dnsmasq: add structure to 'address' and 'server' options
	This is a backwards incompatible change.

2015-02-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Authorized_keys: Allow double quotes in option values (GH #135)

2015-02-03  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Shellvars: case: support ;; on same line with multiple commands

2015-01-28  Vincent Desjardins  <vincent.desjardins@lacapitale.com>

	exports: add bracket support to the supported machine name formats.

2015-01-21  David Lutterkort  <lutter@watzmann.net>

	NEWS: mention previous commit

2015-01-21  grueni  <andreas.grueninger@lgl.bwl.de>

	Fix: '+' in user_alias
	Users of Samba may use '+' as separator between group and user name if
	domain accounts are used.

2015-01-07  Dominic Cleal  <dcleal@redhat.com>

	Erlang: parse kernel app config, handle empty lists
	Fixes RHBZ#1175546

2015-01-05  Dominic Cleal  <dcleal@redhat.com>

	PythonPaste: parse "set" keyword for default overrides
	Fixes RHBZ#1175545

2014-12-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Puppetfile: New lens to parse the Puppetfile format

2014-12-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars_list: Support double-quoted continued lines

2014-11-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	NagiosCfg: default to no spaces around equal, fix #177

2014-11-20  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Exports: Do not use Hosts lenses

	Hosts: Refactor module

2014-11-14  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Ssh: allow indented commas_entry

2014-11-08  David Lutterkort  <lutter@watzmann.net>

	Version 1.3.0

	* tests/test-save.c (teardown): make <root>/etc writable after test
	Leaving it non-writable, as testRemovePermission does, causes 'make
	distcheck' to fail

2014-11-01  Chris Hollowell  <hollowec@bnl.gov>

	Cgconfig: permit quoted spaces in parameter values
	Allow quoted spaces in controller parameter value assignments, making valid
	statements such as the following permissible:

	  blkio.throttle.read_iops_device="8:0 50";

2014-10-30  Kenaniah Cerny  <kenaniah@users.noreply.github.com>

	Added config.d files to the filter
	Used by systems running Red Hat or a variant

2014-10-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Build: remove unused indent definition

2014-10-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Httpd: Allow comparison operators in tags (GH #154)

2014-10-18  Tomáš Chvátal  <tomas.chvatal@gmail.com>

	Add more possible SUSE extensions to read from multipath config.

2014-10-18  Alastair Lynn  <arplynn@gmail.com>

	Inifile: allow single-character keys

2014-10-18  Yanis Guenane  <yguenane@gmail.com>

	xml.aug: Allow nmotoken rather than plain word after !DOCTYPE
	Currently, the lens only accepts a word after the !DOCTYPE word.

	A - valid - Doctype can have the following form :
	<!DOCTYPE log4j:configuration SYSTEM "log4j.dtd"> making the xml
	file invalid with the current lens. This commits aims for the lens
	to accept nmtoken rather than strict word after the DOCTYPE string.

2014-10-18  fonfon  <blubb@fonfon.at>

	Pagekite: new lens and tests

2014-09-23  Dominic Cleal  <dcleal@redhat.com>

	Iptables: parse /etc/sysconfig/iptables.save
	Fixes RHBZ#1144651

2014-09-23  Pino Toscano  <ptoscano@redhat.com>

	LVM: handle also /etc/lvm/lvm.conf
	The syntax should be the same, so use the lvm lens also for the main
	lvm2 configuration file.

	LVM: support negative numbers
	Use Rx.relinteger instead of Rx.integer so negative numbers as values
	can be read.

2014-09-18  Dominic Cleal  <dcleal@redhat.com>

	Systemd: parse environment variables where only value is quoted
	Fixes regression introduced in 5226ae7, which added support to parse fully
	quoted "NAME=value" environment vars.  To support both, this commit stores
	the quotes in the value if it's only the value quoted.

	Fixes RHBZ#1138508

2014-09-12  Dominic Cleal  <dcleal@redhat.com>

	Dhclient: parse hash statements with dhcp-eval strings

	Systemd: parse semicolons inside entry values, not as EOL comments
	Fixes RHBZ#1139498

2014-09-09  Dominic Cleal  <dcleal@redhat.com>

	Kdump: parse new options, permit EOL comments, refactor
	Fixes RHBZ#1139298

	Test_Kdump: fix test of complete config file

2014-09-05  Dominic Cleal  <dcleal@redhat.com>

	Xml: enable CDATA parsing
	Fixes GitHub #80

2014-09-04  Dominic Cleal  <dcleal@redhat.com>

	* src/augeas.c (unlink_removed_files): ensure aug_save returns non-zero result   when unable to delete files
	Fixes RHBZ#1091143

	Syslog: permit IPv6 loghost addresses
	Fixes RHBZ#1129388

	Aliases: permit missing whitespace between colon and recipients

2014-07-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	NEWS

	Xml: Allow backslash in #attribute values

2014-07-21  Dominic Cleal  <dcleal@redhat.com>

	Services: permit colons in service name
	Fixes RHBZ#1121263

2014-07-09  Dominic Cleal  <dcleal@redhat.com>

	Rmt: new lens to parse /etc/default/rmt
	Fixes RHBZ#1100549

	Systemd: parse /etc/sysconfig/*.systemd as used in 389-ds
	Fixes RHBZ#1083022

	Shellvars: support $(( .. )) arithmetic expansion in variable assignment
	Fixes RHBZ#1100550

	Systemd: allow quoted Environment key=value pairs
	Fixes RHBZ#1100547

2014-07-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Simplevars: Support empty values

2014-06-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Sshd: support doseol and standardize code

	Sshd: Use Build.opt_list

	Sshd: Also make Host entries case-insensitive

	Ssh: support case-insensitive entries everywhere

2014-06-25  Andy Grimm  <agrimm@redhat.com>

	Add other valid controllers to cgconfig lens

2014-06-19  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Xymon_Alerting: refactor lens (GH issue #89)

2014-06-12  Nick  <npiace@mars.asu.edu>

	Sudoers: Allow quoted string in default str/bool parameters
	  Made string or bool parameters able to be quoted strings like non-bool strings.
	  Also added "mailfrom" parameter to the list of string/bool parameters
	  and removed duplicates from that list.

2014-06-06  Frank Grötzner  <frank@unforgotten.de>

	add support for mtu relevant parameters fragment and mssfix

2014-06-06  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2014-06-06  fonk  <frank@unforgotten.de>

	OpenVPN/ Add support for setting script-security
	Setting script security is especially needed when using learn-address,
	which we can already set via augeas but is useless without script-security.

2014-06-04  Dominic Cleal  <dcleal@redhat.com>

	* man/augtool.pod: fix description of 'move' alias

2014-06-03  Dominic Cleal  <dcleal@redhat.com>

	* src/augrun.c: remove unused "filename" argument from dump-xml command
	Fixes RHBZ#1100106

	* man/augtool.pod: update man page with --span option

2014-06-03  Raphaël Pinson  <raphink@gmail.com>

	Update AUTHORS and NEWS

2014-06-03  Joel Loudermilk  <joel@loudermilk.org>

	Multipath: add support for rr_min_io_rq

2014-06-02  Dominic Cleal  <dcleal@redhat.com>

	* man/augtool.pod: update man page with new commands
	Fixes RHBZ#1100077

	* src/augtool.c: add command aliases to autocomplete
	Fixes RHBZ#1100184

	Ldso: handle "hwcap" lines
	Fixes #100

	Rsyslog: parse property filters and file actions with complex templates
	Fixes RHBZ#1083016

2014-06-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2014-06-02  Pat Riehecky  <riehecky@fnal.gov>

	Added tuned lense

2014-06-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2014-06-02  Lorenzo M. Catucci  <lorenzo@sancho.ccd.uniroma2.it>

	Add a little bit of ducumentation
	for both the shadow and the gshadow lenses

2014-06-02  Lorenzo M. Catucci  <lorenzo@sancho.ccd.uniroma2.it>

	Add a lens for /etc/gshadow file format
	and wire-up its test to the runner's list in Makefile.am

	Also add a mock /etc/gshadow in tests/root

2014-06-02  Lorenzo M. Catucci  <lorenzo@sancho.ccd.uniroma2.it>

	Add a lens for /etc/shadow file format
	and wire-up its test to the runner's list in Makefile.am

	Also add a mock /etc/shadow in tests/root

2014-06-02  Lorenzo M. Catucci  <lorenzo@sancho.ccd.uniroma2.it>

	Refactor and document
	 - import already defined lenses from the respective modules
	   instead of defining them internally

	 - add a missing \r to the excluded chars in sto_to_col

	 - add some documentation

2014-05-15  Michael Tiernan  <michael.tiernan@gmail.com>

	* HACKING: fix git repository URL

2014-05-12  Mike Latimer  <mlatimer@suse.com>

	Device_map: Parse all device.map files under /boot

2014-05-09  Raphaël Pinson  <raphink@gmail.com>

	CPanel: Allow colons in keys

	CPanel: New lens to parse cpanel.config files

2014-05-06  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Simplevars: Support flags

2014-04-24  Raphaël Pinson  <raphink@gmail.com>

	Shellvars: Allow any kind of quoted values in block conditions (GH issue #118)

2014-04-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Sssd: Allow ; for comments

2014-04-16  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Allow empty quoted values (GH issue #115)

	Allow continued lines inside quoted value (GH issue #104)

2014-04-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2014-04-12  Robert Drake  <rdrake@direcpath.com>

	syslog, support for "# !" style comments
	This makes it so if a comment begins with "# " then +, -, or ! it's
	treated as a comment and won't have a special meaning.

	fixes #65

2014-04-12  Robert Drake  <rdrake@direcpath.com>

	dhclient, add support for option modifiers
	This adds basic support for append|prepend|supercede|default

	I believe it has the same limitations as the existing "option" support.
	Any arguments supplied to the option can't have a space.

	fixes #95

2014-04-12  Vincent Brillault  <vincent.brillault@cern.ch>

	pam: partial support of arguments enclosed in [ .. ]
	Pam.conf(5) manual page states 'module-arguments are a space separated list
	of tokens that can be used to modify the specific behavior of the given PAM.
	Such arguments will be documented for each individual module. Note, if you
	wish to include spaces in an argument, you should surround that argument with
	square brackets.', but such arguments are not supported by the pam lenses, as
	expressed in the comments 'This isn't entirely right: arguments enclosed in
	[ .. ] are allowed and should be parsed as one'.

	This commit add basic support of such arguments via the regex:
	'/(\[[^]#\n]+\]|[^[#\n \t][^#\n \t]*)/'

	It is only a partial support as some corner cases are not covered:
	- Multi line arguments (lines ending with '\')
	- Arguments containing a '[' (escaped via '\')

2014-04-12  Robert Drake  <rdrake@direcpath.com>

	added seq to vim syntax highlight

2014-04-03  Simon Séhier  <simon.sehier@camptocamp.com>

	add missing } in file path for nagios/icinga objects

2014-03-14  Raphaël Pinson  <raphink@gmail.com>

	UpdateDB: Update tests to ensure spaces around = are OK

	Update NEWS

	UpdateDB: New lens to parse /etc/updatedb.conf

2014-03-13  Dominic Cleal  <dcleal@redhat.com>

	* augeas.spec.in: improve augeas-libs description

2014-03-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Httpd: Add unit test for comment on next line

	Httpd: Define an eol_comment in section to allow for \n before comment

	Httpd: Allow eol comments after section tags

2014-03-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Rx: Add iso_8601 simple regex

2014-03-06  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Update AUTHORS and NEWS

2014-03-06  Robert Drake  <rdrake@direcpath.com>

	dhcpd, style and test changes suggested by raphink
	I also updated the NEWS entry to note the incompatible change

	dhcpd, fix for put on dhcp option records
	Type cannot be blank.  I fixed this by making it use record instead of
	nesting through "type"

	dhcpd, fix for key block puts
	I discovered this after thinking I was done.  It actually was a problem
	before I started messing with the code but I didn't notice it because
	there was never any test for keys.

	dhcpd, removed unused variable and reformatted
	stmt_subclass was a little too cluttered so I changed it to multiple
	lines for readability.  I had also introduced an unused lens sep_to_ncl
	which I removed.

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, changing quotes on stmt_block_arg
	This patch can break users parsers.

	Fixes failover-peer, shared-network, class, host, zone, group, and "on" to
	handle quoted values properly.

	It also allows optional semicolon at the end of key {} block.

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, adding support for "on" statement
	For things like:

	on commit {
	      set ClientIP = binary-to-ascii(10, 8, ".", leased-address);
	      set ClientMac = binary-to-ascii(16, 8, ":", substring(hardware, 1, 6));
	}

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, added fddi to stmt_hardware
	getting pretty obscure..

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, adding support for set command
	This allows you to define variables in your dhcp configuration.  They
	can be arbitrarily complicated.

	Things like this:

	      set ClientIP = binary-to-ascii(10, 8, ".", leased-address);
	      set ClientMac = binary-to-ascii(16, 8, ":" , substring(hardware, 1, 6));

	I also added most of the rest of the functions from dhcp-eval and listed
	the limitations of the current parser.  I don't think I'm going to be
	able to fix most of it but I think I'm getting into obscure features
	that most people don't bother using.

	At this point if they need to do very strange class maps they could put
	them in an include file and not have augeas parse it.

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, added support for match if suffix|option
	I also relaxed the rules on matching quoted and unquoted values.

	Things like:
	    match if suffix (option vendor-class-identifier,6)="123456";
	or
	    match if option vendor-class-identifier="Brave, Warrior Pidgins";

	work now.

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd fix to allow subclasses values to be quoted
	DHCP subclass values can have spaces in them.

	Here is an example:
	subclass "consoles" "Xbox 360";
	subclass "consoles" "Nintendo 3DS";
	subclass "consoles" Wii;
	subclass "consoles" NintendoDS;

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd known-clients allows spaces in it's value
	This is a fix for lines like these:

	   deny unknown clients;
	   deny known clients;
	   allow known clients;
	   allow unknown clients;

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, fix for quoted characters in members of
	Some of my "allow members of" statements have more complicated names
	that include things like parenthesis.  This change makes it so semicolon
	and space are the only things not allowed in barewords, and quotes and
	newlines are the only thing not allowed in quoted things.

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, fix whitespace problems with blocks
	Most blocks should support braces at the end of a line or
	on the next line.

	Like this:

	class "test class"
	{

	}

	or

	class testclass {}

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, expanding support for user-defined-options
	This incorporates changes suggested by raphink.

	It should be able to parse all of the following DHCP options now:

	    option name-service-search code 117 = array of unsigned integer 16;
	    option domain-search code 119 = string;
	    option sip-servers code 120 = string;
	    option classless-static-route code 121 = string;
	    option space cable-labs;
	    option cable-labs.tsp-primary-dhcp-server code 1 = ip-address;
	    option cable-labs.tsp-secondary-dhcp-server code 2 = ip-address;
	    option cable-labs.tsp-provisioning-server code 3 = string;
	    option cable-labs.tsp-as-backoff-retry code 4 = { unsigned integer 32, unsigned integer 32, unsigned integer 32 };
	    option cable-labs.tsp-ap-backoff-retry code 5 = { unsigned integer 32, unsigned integer 32, unsigned integer 32 };
	    option cable-labs.tsp-kerberos-realm-name code 6 = string;
	    option cable-labs.tsp-ticket-granting-server-utilization code 7 = boolean;
	    option cable-labs.tsp-provisioning-timer code 8 = unsigned integer 8;
	    option cable-labs-encapsulation code 122 = encapsulate cable-labs;
	    option tftp-server-address code 150 = array of ip-address;
	    option ip-telephone code 176 = string;
	    option wpad-url code 252 = text;

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, add support for omapi-key statement
	You can use this along with omapi-port to specify a secure way to talk
	to your DHCP server.

	key myspecialkey {
	    algorithm hmac-md5;
	    secret "base64string==";
	}

	omapi-key myspecialkey;
	omapi-port 7911;

2014-03-06  Robert Drake  <rdrake@direcpath.net>

	dhcpd, add support for named groups
	Things like group Special_users {

	}

2014-03-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Desktop: Allow @ in keys (GH issue #92)

2014-03-04  KaMichael  <KaMichael@users.noreply.github.com>

	Group: Dropped nisentry (not valid here)

	group: Testcase for NIS default

2014-03-04  KaMichael  <KaMichael@gmail.com>

	Update group.aug

	Update group.aug to parse NIS entries

2014-03-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2014-03-01  Pat Riehecky  <riehecky@fnal.gov>

	Added chrony lense

2014-02-26  Dominic Cleal  <dcleal@redhat.com>

	Krb5: permit braces in values when not in sub-section
	Fixes RHBZ#1066419

2014-02-21  Dominic Cleal  <dcleal@redhat.com>

	Keepalived: add more virtual/real server settings and checks
	Fixes RHBZ#1064388

2014-02-21  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	NetworkManager: Use the Quote module, support # in values (no eol comments)

	AptPreferences: Support spaces in origin fields

	Remove mercurial legacy files

	Sshd: Allow all types of issues in Match groups (GH issue #75)

	Update NEWS

	Add cp to manpage (issue #78)

	Update AUTHORS and NEWS

2014-02-21  Mykola Nikishov  <mn@mn.com.ua>

	Support configuration file for Squid 3

2014-02-12  Dominic Cleal  <dcleal@redhat.com>

	IPRoute2: handle "/" in protocol names, swap ID and name fields
	This is an incompatible change.

	Fixes RHBZ#1063968

2014-02-12  Dominic Cleal  <dcleal@redhat.com>

	IPRoute2: handle hex IDs and hyphens in names, as present in rt_dsfield
	Fixes RHBZ#1063961

2014-02-10  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: handle case statements with same-line ;; tokens
	Fixes RHBZ#1033799

2014-02-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Fix release date for 1.2.0 in NEWS

	Add Known_Hosts lens

2014-01-30  Miguel Armas  <kuko@canarytek.com>

	Grub: handle "foreground" option
	Fixes RHBZ#1059383

2014-01-28  David Lutterkort  <lutter@watzmann.net>

	Version 1.2.0

2014-01-27  Raphaël Pinson  <raphink@gmail.com>

	Update NEWS with span info in XML dump

2014-01-27  Dominic Cleal  <dcleal@redhat.com>

	Add %check to RPM spec, fix download URL
	  * augeas.spec.in: add %check to run `make check` during build, skipping
	    SELinux tests which don't work in a mock environment

	Original %check patch from Richard Jones <rjones@redhat.com>

2014-01-27  Raphaël Pinson  <raphink@gmail.com>

	Add span info to XML dump
	For a node, add span information for the label, value, and node overall if
	it is present in the tree. The resulting XML looks like

	  <node label="..." file="..." path="...">
	    <span for="label" start="..." end="..."/>
	    <span for="value" start="..." end="..."/>
	    <span for="node" start="..." end="..."/>
	    <value>...</value>
	  </node>

2014-01-27  David Lutterkort  <lutter@watzmann.net>

	Rename build/aux to build/ac-aux
	The directory name 'aux' is special on Windows, and using it keeps the
	build from working.

	You will need to rerun autogen.sh after this change

2014-01-24  Raphaël Pinson  <raphink@gmail.com>

	Update NEWS

	Sshd: let all special keys be case-insensitive

	Update NEWS

	Sshd: Support Ciphers and KexAlgorithms groups, GH issue #69

	Update NEWS

	Grub: Add 'verbose' option, GH issue #73

	Update NEWS

	Shellvars_list: Allow end-of-line values, bug #342

	Fix xymonalerting into xymon_alerting in tests/Makefile.am

	Add Xymon_Alerting lens to NEWS, update AUTHORS

	Rename XymonAlerting lens as Xymon_Alerting

	Fix NaturalDocs comments in XymonAlerting lens

2014-01-24  Francois Maillard  <fmaillard@gmail.com>

	Add NaturalDocs documentation to the xymonalerting lens and its tests

	add basic doc

	Add the test lens to the Makefile

	New lens for xymon alerting rules

2014-01-24  Raphaël Pinson  <raphink@gmail.com>

	Update NEWS with Authorized_Keys change

2014-01-24  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Allow 'ssh-ed25519' as a valid authorized_key type

2014-01-24  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

2014-01-14  Kaarle Ritvanen  <kaarle.ritvanen@datakunkku.fi>

	Interfaces: map bond-slaves and bridge-ports options to arrays
	This is a backwards incompatible change, as these would previously show up
	as strings in the tree

2014-01-14  Tomas Klouda  <tomas.klouda@gooddata.com>

	Fix MongoDB Server lens - MongoDB doesn't accept quoted values
	This lens worked for already defined values, but once you wanted to
	add new value, it was created with quotes and MongoDB failed to start

2014-01-14  Dominic Cleal  <dcleal@redhat.com>

	Fix umask handling when creating new files
	  * src/transform.c (transform_save): faulty umask arithmetic would cause
	    overly-open file modes when the umask contains "7", as the umask was
	    incorrectly subtracted from the target file mode

	Fixes CVE-2013-6412, RHBZ#1034261

2014-01-14  Freakin  <brendanaye@gmail.com>

	OpenVPN: additional config options
	Support
	  1) daemon
	  2) client-config-dir
	  3) route
	  4) management

2014-01-14  David Lutterkort  <lutter@watzmann.net>

	* NEWS: describe Slapd changes in last few commits

2014-01-14  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Slapd: move by/who to the value of by

	Slapd: Allow any allowed combination of who/access/control in by field

	Slapd: support smart quotes in database entry

	Slapd: remove duplicate entry in database_re

	Slapd: rename by parameters
	* Rename by/what as by/access (as per official doc)
	* Allow access to be absent (as per official doc)

2014-01-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Slapd: Add unit test for by/control

2013-12-19  Dominic Cleal  <dcleal@redhat.com>

	Shellvars, Sysconfig: map "bare" export and unset lines using seq to handle multiple variables
	Fixes RHBZ#1033795

2013-12-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars.lns: Actually test continued lines and fix support

	Shellvars.lns: add unit test for continued lines in double quoted values

2013-12-17  Dominic Cleal  <dcleal@redhat.com>

	Sysconfig: permit empty comments after comment lines
	Fixes RHBZ#1043636

2013-12-05  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: fix syntax error in filter

2013-12-05  David Lutterkort  <lutter@watzmann.net>

	Shellvars: exclude /etc/sysconfig/ip*tables.save files

2013-12-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Sudoers.lns: Allow uppercase characters in user names (ticket #376)

	Build: Add combine_three_ord and combine_three

	Build: Add combine_two_ord and combine_two

2013-12-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Yum.lns: split excludes as lists (ticket #275)

	Build: Add combinatorics group

	Yum.lns: simplify code for combinatory logic of list_entry elements

2013-12-03  Tomas Hoger  <thoger@redhat.com>

	Corrections for CVE-2012-0786 tests
	- test-put-symlink-augsave.sh - variable $HOSTS_AUGNEW was used to check if
	  file was still symlink, while it wasn't set before.  Fix to use
	  $HOSTS_AUGSAVE.
	- test-put-symlink-augnew.sh, test-put-symlink-augsave.sh - 'test -f'
	  dereferences symlink and hence can not be used to check if file is regular
	  file or symlink to a regular file.  Use 'test -h' instead.

2013-12-03  Tomas Hoger  <thoger@redhat.com>

	Correct locations table for transform_save()
	Commit 16387744 introduced a table with locations of temporary, destination and
	backup file in various modes as part of the comment for transform_save().  This
	corrects two incorrectly listed temporary file locations.

	Note that PATH_canon is somewhat misleading, as canonicalized path is always
	used when not using NEWFILE save flag, while it is meant to indicate whether
	file is created in a directory that contains symlink, or a directory that
	contains symlink's target.

2013-12-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Desktop.lns: Support square brackets in keys

2013-11-19  Dominic Cleal  <dcleal@redhat.com>

	* src/transform.c (filter_matches): wrap fnmatch to ensure that an incl   pattern containing "//" matches file paths
	Fixes RHBZ#1031084

2013-11-09  Sean Millichamp  <sean.millichamp@secure-24.com>

	Enhance Nagiosobjects lens
	This adds support and tests for three additional Nagios
	supported behaviors:
	- An optional space between the object name and the {
	   Example: "define host{"
	- An optional indent prior to the closing }
	   Example: "    }"
	- Whole-line comments that start with ;
	   Example: "; This is a comment"

	It does not add support for end-of-line comments with ;

2013-11-09  Yanis Guenane  <yguenane@gmail.com>

	Dhcpd: support a wider variety of DHCP allow/deny/ignore statement
	The Dhcpd.aug was missing a part of the allow/deny/ignore possible
	statement. This commit updates the lense so it supports the list
	of options available here

	http://www.ipamworldwide.com/declarations-topological/declarations-allowdenyignore.html

	Also this bug was preventing a Foreman user to parse the dhcpd.conf
	generated by theforeman/dhcp puppet module

2013-11-09  Dominic Cleal  <dcleal@redhat.com>

	Yum: permit spaces after equals sign in list options
	Fixes GitHub issue #45

2013-11-09  Matteo Cerutti  <matteo.cerutti@hotmail.co.uk>

	Sudoers: permit underscores in group names
	Fixes ticket #370

2013-11-01  Andrew N Golovkov  <a.golovkov@dwteam.ru>

	include only *.repo files from yum.repos.d;

2013-10-25  Michael Haslgrübler  <work-michael@haslgruebler.eu>

	Use Quote module in dovecot
	* use Quote.dquote_spaces for quoting

	dovecot enchancement and bug fixes
	* add mailbox to block_names
	* fix for block_args in quotes
	* fix for block's brackets upon write
	* fixes broken tests for mailbox
	* fixes indention
	* test case for block_args with "
	* fixes broken indention

2013-10-17  Dominic Cleal  <dcleal@redhat.com>

	Shellvars_list: handle backtick variable assignments
	Fixes ticket #368

2013-10-09  Yanis Guenane  <yguenane@gmail.com>

	Update NEWS

2013-10-07  Dietmar Kling  <baldur@email.de>

	Cyrus_Imapd: create new entries without space before separator
	Fixes RHBZ#1014974

2013-10-06  Dominic Cleal  <dcleal@redhat.com>

	Exports: permit colons for IPv6 client addresses
	Fixes ticket #366

2013-09-20  Esteve Fernandez  <esteve.fernandez@gmail.com>

	Added dhclient.conf path for Debian/Ubuntu

2013-09-10  Yanis Guenane  <yguenane@gmail.com>

	Fix Trac#364. Syslog lense accept UDP(@) and TCP(@@) protocol
	Currently the syslog lense only accept sending log to another host
	via UDP - a single @ -, and was discarding TCP - a double @ -. This
	PR fixes that.

	Fix test_rsyslog.aug

	Remove unused variable at

2013-09-08  Yanis Guenane  <yguenane@gmail.com>

	Fix NagiosCfg lense so /etc/nagios/nrpe.cfg is parsed by Nrpe and not NagiosCfg
	Currently NagiosCfg lense is in charge of parsing all files under /etc/nagios/*.cfg
	but /etc/nagios/commands.cfg. /etc/nagios/nrpe.cfg should be also added as an exception
	since it needs to be parsed by the Nrpe lense. This issue currently causes the following
	error : "Lenses @NagiosCfg and @Nrpe could be used to load this file"

2013-09-03  Dominic Cleal  <dcleal@redhat.com>

	* tests/test-load.c (testPermsErrorReported): skip permissions test when root

2013-08-28  Tom Hendrikx  <tom@whyscream.net>

	Postfix_virtual: allow '+' and '=' in email addresses
	+ ('plus') and = ('equals') are valid characters in email addresses.
	Example is from postfix docs, see:
	http://www.postfix.org/MULTI_INSTANCE_README.html#quick

2013-08-28  Raphaël Pinson  <raphink@gmail.com>

	Add aug_cp and the cp and copy commands

2013-08-28  Dominic Cleal  <dcleal@redhat.com>

	Grub: handle makeactive menu command
	Fixes ticket #340

	Postfix_Main: handle stray whitespace at end of multiline lines
	Fixes ticket #348

2013-08-28  Pat Riehecky  <riehecky@fnal.gov>

	Koji: new lens to parse Koji configs

2013-08-28  Dominic Cleal  <dcleal@redhat.com>

	Access: support DOMAIN\user syntax for users and groups
	Fixes ticket #353

	Samba: permit asterisk in key name
	Fixes ticket #354

	Shellvars: support all types of quoted strings in arrays
	Patch from webmeister.  Fixes ticket #357.

2013-08-28  Pat Riehecky  <prieheck@iwu.edu>

	Yum: add yum-cron*.conf files

2013-08-28  Pascal Lalonde  <plalonde@google.com>

	Interfaces: allow numeric characters in stanza options

2013-08-28  David Lutterkort  <lutter@watzmann.net>

	Shellvars: read /etc/firewalld/firewalld.conf
	Fixes https://fedorahosted.org/augeas/ticket/363

2013-08-28  Matthew Booth  <mbooth@redhat.com>

	Grub: support the 'lock' directive

	Grub: NFC fix whitespace errors introduced by 4e09d15
	Kill tabs!

	Grub: support the 'setkey' directive

2013-08-27  Michael Wisheu  <wisheu@google.com>

	Interfaces: add /etc/network/interfaces.d/* as another commonly used location

2013-08-07  Raphaël Pinson  <raphink@gmail.com>

	Update NEWS

	Fix NaturalDocs comments in lenses

2013-08-07  Stephen P. Schaefer  <sschaefer@acm.org>

	Allow augeas to deal with one variant of /etc/sysconfig/network-scripts/route-*

2013-08-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Properties: Support multiline starting with an empty string, GH issue #19

2013-08-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Dhcpd: support conditionals, GH issue #34

	Update NEWS

	PHP: Allow php-fpm syntax (GH issue #35)

2013-08-01  Patrick Adair  <padair@he.net>

	Interfaces: add in support for the source stanza in /etc/network/interfaces files

2013-07-30  Dominic Cleal  <dcleal@redhat.com>

	Simplevars: adopt /etc/selinux/semanage.conf due to spaces around delimiters

2013-07-30  Michael Scherer  <misc@zarb.org>

	Shellvars: add /etc/selinux/semanage.conf

2013-07-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Start new NEWS section

	Fix documentation links in c_api naturaldocs menu

2013-07-25  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Sshd: also indent comments by 2 spaces by default in Match groups

	Sshd: Indent Match entries by 2 spaces by default

2013-06-27  Jan Vansteenkiste  <jan@vstone.eu>

	Fixes #27: Automounter lens does not handle hostnames with dashes in them

2013-06-24  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Fix my name

2013-06-15  David Lutterkort  <lutter@watzmann.net>

	Version 1.1.0

	Make tree_unlink safer to use
	tree_unlink used to only remove nodes from the tree, leaving the
	possibilities of dangling references from variables stored in the
	symtab. The new incarnation is safer in that it cleans up the symtab first.

2013-06-15  David Lutterkort  <lutter@watzmann.net>

	Do not interpret file names as path exprs during load
	We used to interpret file names as path expressions at various points in
	the process of loading the tree. That lead to nasty failures if the file
	names contained characters that have a special meaning in path expressions,
	like '!', '[' etc.

	When the loading code now creates nodes or looks them up based on filenames
	(e.g. to create the file's top level node in /files or the info node in
	/augeas/files), we now use tree_fpath/tree_fpath_cr to do that.

	The workaround introduced into shellvars.aug to fix tiecket #246 is also no
	longer needed.

	Fixes https://fedorahosted.org/augeas/ticket/343
	Fixes https://fedorahosted.org/augeas/ticket/333
	Improves on the fix for https://fedorahosted.org/augeas/ticket/246

2013-06-15  David Lutterkort  <lutter@watzmann.net>

	* src/transform.c (xfm_error): do not segfault when msg is NULL

	* src/try: make 'try gdb' work with emacs-24 and gdb-7.5.1

2013-06-12  David Lutterkort  <lutter@watzmann.net>

	LVM: fix handling of quoted strings that contain quotes
	Fixes https://github.com/hercules-team/augeas-do-not-use/issues/28 reported
	by brianredbeard

2013-06-12  Erik B. Andersen  <erik.b.andersen@gmail.com>

	AptCacherNGSecurity: new lens for /etc/apt-cacher-ng/security.conf

2013-06-12  brian redbeard  <brian@dead-city.org>

	Added node config for OpenShift
	When the intial lens was developed there was a missing transform
	on /etc/openshift/node.conf

	This is a fix for bug hercules-team/augeas#22

2013-06-05  David Lutterkort  <lutter@watzmann.net>

	Xorg: allow 'Screen' in Device section
	Patch from merkela

	Fixes bug https://fedorahosted.org/augeas/ticket/344

2013-06-04  David Lutterkort  <lutter@watzmann.net>

	Xorg: support extmod section
	Patch by merkela

	Partial fix for https://fedorahosted.org/augeas/ticket/344

2013-05-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Yum: optimize regexp substractions

	Nrpe: optimize regexp substractions

	Mdadm_Conf: optimize regexp substractions

	Fai_Diskconfig: Optimize regexp substractions

	Shellvars: Optimize regexp substraction

2013-05-28  Dominic Cleal  <dcleal@redhat.com>

	Automaster: accept spaces between options

2013-05-24  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	Add Rob Tucker to AUTHORS

	Add README as a symlink to README.md to make autogen relax

2013-05-24  Rob Tucker  <rtucker11@gmail.com>

	Added augeas lens and test for the asterisk sip.conf file

2013-05-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	postfix_master: Allow [] in words (ticket #345)

2013-05-18  David Lutterkort  <github@watzmann.net>

	Update README.md
	Reformat as GH-flavored markdown; add a License section

	Rename README to README.md

2013-05-18  David Lutterkort  <lutter@watzmann.net>

	* tests/test-run.c (load_module): do not downcase the lensdir
	We should not touch the lensdir, since it is user provided; we only want to
	downcase the module name.

	Patch by aponomarenko

	Fixes bug #332

2013-05-17  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add --echo alias to augtool manpage

	Add -t option to augtool manpage

2013-05-17  Enrico Stahn  <mail@enricostahn.com>

	PHPFPM Support

2013-05-17  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add Splunk lens
	Lens to parse Splunk configuration. Based on IniFile lens, with few differences:

	* Accepts empty value in entry
	* Entries without parent section are children of .anon node

	Thanks to Tim Brigham for this contribution.

2013-05-17  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add CR as a white space char in RX.space_in
	CR is used in the IniFile lens as of EOL. To avoid concat ambig between
	IniFile.store_to_eol and IniFile.eol, CR has to be added to Rx.space_in. This
	change do not break any existing lens in the repository.

2013-05-17  Davide Guerri  <davide.guerri@gmail.com>

	adds support for iptoute2 configuration files (/etc/iproute2/*)

2013-05-17  Simon Vocella  <voxsim@gmail.com>

	JaaS: lens for the Java Authentication and Authorization Service

2013-05-16  David Lutterkort  <lutter@redhat.com>

	Function composition: fix the typing of the generated lambda
	When f and g are functions, 'f ; g' gets translated into
	  lambda x: g (f x)

	The resulting function wasn't typed right, which led to an internal error.

	This fixes bug #328

2013-05-09  Raphaël Pinson  <raphink@gmail.com>

	Update AUTHORS

2013-05-09  Brian Harrington  <bharrington@redhat.com>

	Added support for OpenShift
	Added a series of lenses to support the corresponding configuration
	formats including conf, JSON, & HTTP.

2013-05-09  Brian Harrington  <bharrington@redhat.com>

	Add support for MongoDB Server
	A basic lens and test to support the configuration of MongoDB

	Added infrastructure components for MongoDB

	Included references to MongoDBServer to handle the auto testing of
	lenses on build & mention of lens in for autodoc generation.

	fixes hercules-team/augeas/#25

	Improved documentation on MongoDBServer filter

	Added improved reference and usage information for the lens

	Mistyped port path in MongoDBServer lens usage

	The port component was missing from the set command

	fixes herclues/team-augeas/#25

2013-05-09  Brian Harrington  <bharrington@redhat.com>

	Added support for ActiveMQ / Red Hat JBoss A-MQ
	Added a series of lenses to support the file formats utilized with
	the project ActiveMQ / Red Hat JBoss A-MQ.

	ActiveMQ is a standards-based, open source messaging platform
	shipped by Red Hat (Formerly Fuse Source).

	http://activemq.apache.org/
	http://www.redhat.com/products/jbossenterprisemiddleware/amq/

2013-05-01  Mathieu Alorent  <malorent@kumy.net>

	Add more flags
	add other flags, and use regexp to check

2013-05-01  Mathieu Alorent  <malorent@kumy.net>

	implement Downtime feature
	As seen in this thread, there is a downtime feature that is not
	parsed by Augeas.

	http://lists.xymon.com/archive/2011-March/030998.html

2013-04-21  Dominic Cleal  <dcleal@redhat.com>

	Rsyslog: support :omusrmsg: list of users in actions

2013-04-16  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Passwd: allow period in user names in spec (fixes #337)

	Passwd: allow overrides in nisentry

2013-04-01  Gonzalo Servat  <gservat@gmail.com>

	Nrpe: accept any config option, remove predefined list

2013-03-31  Branan Purvine-Riley  <branan@puppetlabs.com>

	Add support for port ranges to /etc/services lens
	The `/etc/services` file on AIX can contain entries with ranges of ports. This change allows Augeas to parse such files.

	Example from an AIX /etc/services file:
	    x11                      6000-6063/tcp  # X Window System
	    x11                      6000-6063/udp  # X Window System

2013-03-22  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: reinstate /etc/sysconfig/network
	Fixes #330, RHBZ#904222, RHBZ#920609

2013-03-15  Gabriel  <g2p.code@gmail.com>

	Add some autodoc comments.

	Add a lens for LVM metadata.

2013-03-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

2013-03-12  Serge Smetana  <smetana@pluron.com>

	Added lens for Dovecot config files

2013-03-02  Dominic Cleal  <dcleal@redhat.com>

	* src/augtool.c (usage): fix spelling error

2013-02-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Krb5: Improve performances

2013-02-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	IniFile: Support dos eol
	  Subversion: Support dos eol
	  Desktop: Support dos eol
	  MySQL: Support dos eol
	  Samba: Support dos eol
	  Yum: Support dos eol
	  Krb5: Support dos eol

	  IniFile: Add empty_generic_nocomment
	  Rx: make no_spaces compatible with doseol
	  Schroot: Use empty_generic_nocomment

2013-02-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	IniFile: Allow quotes inside bare values

	IniFile: Multiline values can begin with a single newline

	IniFile: Add empty_generic and empty_noindent
	  Subversion: Use IniFile.empty_noindent

	IniFile: Add entry_generic and entry_multiline_generic
	Subversion: Use IniFile.entry_multiline_generic

	IniFile: Allow spaces in entry_multiline* values

2013-02-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	IniFile: Use Util.comment_generic and Util.empty
	  Add put test for ace

	  Lightdm: empty comments are mapped as empty
	  PHP: empty comments are mapped as empty
	  Odbc: empty comments are mapped as empty
	  Samba: empty comments are mapped as empty
	  Krb5: Fix tests for new IniFile.empty
	  MySQL: Support smart quotes and empty comments
	  Yum: Use Util.empty instead of IniFile.empty
	  Subversion: Adapt to new IniFile.empty definition
	  Systemd: Fix tests for new IniFile.empty

2013-02-07  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	IniFile: Support smart quotes
	  Add support for smart quotes in IniFile lenses.
	  Fix PHP lens to support smart quotes.
	  Subversion: Adapt to smart quotes but allow ; in values
	  Schroot: Support smart quotes

	IniFile: Add ready-to-use lns_loose and lns_loose_multiline lenses

2013-02-07  Andrew Anderson  <andrew@lirn.net>

	Krb5: fix parse error with IPA generated krb5.conf

2013-02-07  Igor Pashev  <pashev.igor@gmail.com>

	* configure.ac: better detection of how to pass version script to linker
	This now also works on Illumos when using GNU ld

	Fixes https://fedorahosted.org/augeas/ticket/289

2013-02-07  Jan Pokorný  <jpokorny@redhat.com>

	lenses.tex: fix typos, single-quote cleanup

2013-01-24  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: ignore network configs with brackets in their name
	SSIDs containing brackets would cause aug_init failures, as the characters are
	parsed in path expressions.

	Fixes ticket #246

2013-01-24  David Lutterkort  <lutter@redhat.com>

	augparse: add --trace option
	Using --trace will print the filenames of all modules that are loaded.

	Shellvars: ignore network configs with ! in their name
	NetworkManager would write such files, but that leads to problems during
	aug_init, as the attempt to create the node
	/augeas/files/etc/sysconfig/network-scripts/FILE!NAME will fail as that is
	not a valid path expression

	* .gitignore: ignore test result files (*.trs)

	* acinclude.m4: only turn on FORTIFY_SOURCE if it won't anger gcc
	Following libvirt commits cf9bced0 and 1c2edf0f

2013-01-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Quote: Allow multiple spaces in quote_spaces

2013-01-10  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Add two files found on OpenBSD to the simplevars lens.

2013-01-08  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	The nagios filters work for Icinga too

	Modify the Nagios lens to handle resources.cfg too.
	Fixes ticket #312

2013-01-05  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	AptPreferences: adjust a little bit to simplified lens

	AptPreferences: Simplify/Standardize the module

2013-01-05  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Make sure the usage shows up properly formated.

	sync another comment with ND definition

	Sync View comment with actual definition.

	Properly document this lens.

	Basic documentation for final apt lenses and sync Menu.txt

	regen Menu.txt after recent changes.

	Move the 'coding' comment to the end of the file to fix the menu entry.

	Fix some more broken module names

	Small fixes to improve documentation:
	- Declare a module name in test_yum, so that gets taken instead of Yum.lns
	- Filter is a view, not a variable in ntpd.aug
	- Properly declare the module name nginx.aug

	Correctly set the module name, and let it actually test the Lightdm lens.

2013-01-05  David Lutterkort  <lutter@redhat.com>

	Xml test (input1): modify to mildly check handling DOS line endings

2013-01-05  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Add support for handling the "client-output-buffer-limit" to the Redis lens.

2013-01-04  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Some small Rx tweaks: include regexes for octal and hex and simplify ipv4 matching.
	Fixes ticket #327

	Add a lens for OpenNTPD's config file (ntpd.conf).
	Extend rx.aug with some helpful regexes while here.
	Fixes ticket #324

	Adjust the fonts lens' exclusion rule to ignore all README files
	Fixes ticket #323

2013-01-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Quote: improve lens usage

	Quote: lens usage

	Quote: Improve documentation for functions

	Xorg: Fix filter

2013-01-04  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Also handle /etc/monitrc
	Fixes ticket #326

2013-01-04  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Remove bogus use of Util.stdexcl.
	It should only be used for wildcard includes.
	Add an exclude to Util.stdexcl for "#*#" while here.

	Fixes ticket #325

2013-01-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Erlang and Quote are generic lenses

2013-01-03  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Add a new lens for OpenBSD's /etc/boot.conf.
	Fixes ticket #322

2013-01-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Networks: networks can have weird submasks, too

	Sysctl: exclude /etc/sysctl.d/README.sysctl

	Sudoers: Allow user aliases in specs

	Systemd: Allow backslashes inside values

	Systemd: Simplify expression

2013-01-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Systemd: Don't use multiple negates in regexps

2012-12-31  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	* tests/cutest.c: include sys/wait.h for WIFEXITED and WEXITSTATUS.
	Fixes ticket #321

2012-12-31  Dominic Cleal  <dcleal@redhat.com>

	Inetd: support IPv6 addresses
	Fixes ticket #320

2012-12-31  Jasper Lievisse Adriaanse  <jasper@humppa.nl>

	Shellvars: parse /etc/rc.conf.local which is found on OpenBSD.
	Fixes ticket #320

	Dhclient: on OpenBSD dhclient.conf lives in /etc/dhclient.conf
	Fixes ticket #320

	Resolv: Add two new views (family and lookup)
	Fixes ticket #320

2012-12-29  Dominic Cleal  <dcleal@redhat.com>

	* src/augrun.c: fix spelling in defnode help

2012-12-28  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	AptPreferences: Add "n" to pin keys

2012-12-23  Dominic Cleal  <dcleal@redhat.com>

	Xinetd: handle missing values in lists
	Fixes ticket #307

2012-12-22  Dominic Cleal  <dcleal@redhat.com>

	Update NEWS and AUTHORS

2012-12-22  David Lutterkort  <lutter@redhat.com>

	Version 1.0.0

2012-12-22  Dominic Cleal  <dcleal@redhat.com>

	Krb5: support semicolon comments, allow empty lines within subsections
	Fixes ticket #288

2012-12-22  Pat Riehecky  <riehecky@fnal.gov>

	Krb5: support host { } subsections inside v4_name_convert, handle multiple arguments to *_enctypes settings, support ticket_lifetime
	Contains a minor incompatible lens change for permitted_enctypes,
	default_tgs_enctypes and default_tkt_enctypes settings, where labels are now
	lower-cased.

	Fixes ticket #274

2012-12-22  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS and AUTHORS

	Merge branch 'master' of ssh://git.fedorahosted.org/git/augeas into dev/nginx

	Add Nginx lens to parse /etc/nginx/nginx.conf, bug #319

2012-12-22  David Lutterkort  <lutter@redhat.com>

	* src/Makefile.am: add $(top_builddir)/gnulib/lib to GNULIB_CFLAGS
	Needed for building under IllumOS

	Fixes https://fedorahosted.org/augeas/ticket/270

2012-12-20  Matthaus Owens  <matthaus@puppetlabs.com>

	Add /etc/puppetlabs/puppet path to puppet lenses
	In Puppet Enterprise, puppet is rooted in /etc/puppetlabs/puppet instead of
	/etc/puppet, so that is also a valid location for puppet.conf, fileserver.conf,
	and auth.conf. This commit also adds /usr/local/etc/puppet/auth.conf as a
	filter for the puppet auth lens.

2012-12-18  Marc Fournier  <marc.fournier@camptocamp.com>

	Redis: new lens and tests

2012-12-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Quote: Add tests for *_nil entries

2012-12-18  Marc Fournier  <marc.fournier@camptocamp.com>

	Add Quote.*quote_opt_nil variables and functions
	... which are exactly the same as  Quote.*quote_opt, except they don't
	set quotes by default.

	This patch also completes a couple of existing comments.

2012-12-18  Marc Fournier  <marc.fournier@camptocamp.com>

	augeas.vim: added a couple of keywords recently introduced.

2012-12-18  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Dhcpd: force double quotes for filename attribute, bug #311

2012-12-17  Marc Fournier  <marc.fournier@camptocamp.com>

	Postgresql: properly support quotes
	Fixes trac#317

2012-12-15  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Postfix_Transport: allow host:port and [host]:port syntaxes, bug #303

	Really test Avahi.lns in test_avahi.aug

	Update NEWS

2012-12-15  Athir Nuaimi  <athir@nuaimi.com>

	Add new Avahi lens to manage /etc/avahi/avahi-daemon.conf

2012-12-15  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Merge branch 'trac#281' of git://github.com/mfournier/augeas into review/pr4

2012-12-14  Marc Fournier  <marc.fournier@camptocamp.com>

	Add a path to pg_hba.aug, fixes Trac ticket #281.

	Htpasswd: new lens and tests

2012-12-14  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update NEWS

	src/augtool.c: honor --echo in run_args

	src/augtool.c: print_aug_error when run_args fails

	src/augtool.c: run_args is successful if code >= 0, bug #316

2012-12-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update AUTHORS

	Prepare NEWS for 1.0 release

	Add Quote.dquote_spaces and Quote.squote_spaces

	Use Quote.quote_spaces in pg_hba.aug

	Add Quote.quote_spaces

	Automagically manage quotes in pg_hba.aug

	pg_hba.aug: Support multiple options (ticket #313)

	Add test for ticket 313

	pg_hba.aug: fix method to avoid clashing with hostname

2012-12-12  Andreas Ntaflos  <daff@pseudoterminal.org>

	Support hostnames/FQDNs and FQDN suffixes in pg_hba.conf
	In pg_hba.conf the "address" column may also be a hostname, FQDN or part
	of an FQDN starting with a dot, in addition to IP addresses. This adds
	support for such hostnames and hostname suffixes.

2012-12-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Merge branch 'master' of ssh://git.fedorahosted.org/git/augeas into dev/shellvars_newlines

2012-12-09  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: add locale.conf, vconsole.conf systemd configs
	Fixes BZ#881841

2012-12-09  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Fix support for empty comments after comments

	shellvars.aug: Fix newlines after comments being mapped as Util.empty

2012-12-06  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: add locale.conf, vconsole.conf systemd configs
	Fixes BZ#881841

2012-12-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add rsyslog.aug

2012-11-29  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	No need for comment in rabbitmq.aug (managed in erlang.aug)

	Support comments in erlang.aug and rabbitmq.aug

	Add rabbitmq.aug

	Add erlang.aug

2012-11-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add /etc/audit/auditd.conf to simplevars.aug

2012-11-21  Domen Kožar  <domen@dev.si>

	correctly parse escaped string literals in vim syntax file

2012-11-21  Francois Lebel  <francoislebel@gmail.com>

	Add a lens for logwatch.

2012-11-21  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add tests for regexp builtin with flag

	Add support for an 'i' flag in regexp builtin function

2012-11-21  David Lutterkort  <lutter@redhat.com>

	* src/pathx.c: pass the number of actual arguments to the func implementation

	* src/pathx.c: match functions by name and arity
	This makes it possible to have different numbers of arguments for the same
	function, e.g. count() and count(nodeset)

	* src/pathx.c: disallow ',' in names in path expressions
	Note that this breaks backwards compatibility, since, when searching for a
	node 'a,b' you now must write "match a\,b" rather than "match a,b"

2012-11-15  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add Puppet_Auth lens

2012-11-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add aug_label to retrieve the label from a path.

2012-11-10  David Lutterkort  <lutter@redhat.com>

	Sysconfig: handle end of line comments and semicolons; strip quotes
	Fixes RHBZ #761246

	square lens: correctly process skeletons during put
	The current code would identify a L_SQUARE skeleton to match even when it
	did not, meaning we would not trigger a create in all instances where it
	was needed.

	Shellvars: add tests for semicolon handling

	* lenses/tests/test_sysconfig.aug: use a variable 'lns' for Sysconfig.lns

	* lenses/tests/test_sysconfig.aug: use a variable 'lns' for Shellvars.lns

	* tests/Makefile.am (lens_tests): add quote test

2012-10-30  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Use the Quote module in dhcpd.aug

	Use the Quote module in openvpn.aug

	Add quote.aug to easily manage quotes

2012-10-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	vmware_config: use square lens to manage quotes

2012-10-27  David Lutterkort  <lutter@redhat.com>

	square: properly handle first lens matching empty string
	The rewriting of the ctype of (square l1 l2 l3) introduced in commit
	1484afc3 was not correct when the ctype of l1 matched the empty string: the
	rewritten ctype did not match the empty string any more.

	This patch fixes that by making sure that fa_enumerate includes the empty
	word if the language contains it.

2012-10-27  Marc Fournier  <marc.fournier@camptocamp.com>

	improved documentation for carbon/mcollective/memcached/thttpd lenses.

2012-10-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	VMware_Config accepts values without quotes

2012-10-24  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Xml: support single _and_ double quoted attribute values
	Fixes RHBZ #799885
	Fixes ticket #258

2012-10-24  David Lutterkort  <lutter@redhat.com>

	Use precise ctype of a square lens if it is indeed regular

	libfa (fa_enumerate): new function
	Function to enumerate FA's with a finite language, given a preset limit of
	words.

	* src/syntax.c (compile_test): print which test failed when missing exception
	Tests which should produce an exception, but produce a regular value didn't
	print their line info when they failed.

	* tests/modules/fail_shadow_union.aug: fix unintended test failure

2012-10-20  David Lutterkort  <lutter@redhat.com>

	Gdm: also read /etc/gdm/custom.conf by default

2012-10-20  Filip Andres  <filip.andres@gooddata.com>

	cgconfig.aug adds space between group and id

2012-10-20  David Lutterkort  <lutter@redhat.com>

	Lightdm: new lens and tests
	Fixes ticket #302
	Contributed by David Salmen

2012-10-20  jmccann  <jacob.m.mccann@usps.gov>

	Ntp: add tos directive
	Fixes ticket #297

2012-10-20  David Lutterkort  <lutter@redhat.com>

	Phpvars: support classes and public/var values
	Fixes ticket #299

	Patch by aheahe

2012-10-20  Marc Fournier  <marc.fournier@camptocamp.com>

	Memcached: new lens and tests

	Thttpd: new lens and tests

	Carbon: new lens and tests for Carbon cache.

	MCollective: new lens and tests

2012-09-25  Dominic Cleal  <dcleal@redhat.com>

	Revert f04d7dfb3fe7c54b0be650e68aa7778eaf02ea66
	This was a subtle feature which uses counters named after the setting key to
	index the values beneath it, over all instances of the setting key.  This allows
	for path expressions such as /files/etc/ssh/sshd/AllowEnv/10 to map to the
	tenth value, irrespective of how many setting lines they are split over.

	Modprobe: revert inner lens name change, fixes Modules_conf
	Modules: define own entry regexp as referenced Modprobe inner lens doesn't
	match file format

2012-09-22  Dominic Cleal  <dcleal@redhat.com>

	Modprobe: support multiline split commands
	Fixes Ubuntu bug #1054306

2012-09-18  Dominic Cleal  <dcleal@redhat.com>

	Sshd: reset seq counter for each array setting

2012-09-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Fix test_syslog.aug

	Capital letters are allowed in tokens in syslog.aug

	Add collectd.aug and associated test

2012-09-11  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add postfix_virtual.aug and associated test

	Remove /etc/postfix/virtual from postfix_transport.aug

2012-09-05  Dominic Cleal  <dcleal@redhat.com>

	Sshd: permit hyphens in subsystem names

2012-09-04  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add apt_update_manager.aug and test

2012-09-03  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add vmware_config.aug and test

	Allow empty lines in gtkbookmarks.aug

	Use label instead of seq in gtkbookmarks.aug

	Add gtkbookmarks.aug and test

2012-08-28  Pat Riehecky  <riehecky@fnal.gov>

	Cachefilesd: new lens for /etc/cachefilesd.conf

2012-08-24  jmccann  <jacob.m.mccann@usps.gov>

	fixes #278 multipath: allow devices to override defaults

2012-08-22  Michal Filka  <mfilka@suse.cz>

	Fixed logrotate.aug.
	    Logrotate accepts integers prefixed by a sign. Added real world
	    ntp config file example from SLES into test_logrotate.aug.

2012-08-22  Jeroen van Meeuwen (Kolab Systems)  <vanmeeuwen@kolabsys.com>

	Add a lens for Cyrus IMAP configuration file /etc/imapd.conf (includes /etc/imap/*.conf)
	Fixes ticket #296

2012-08-15  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Generic square lens v4
	Lens square now takes lenses instead of regular expressions as arguments, as follow:

	  square left body right

	The left and right lenses must accept the same language. The left lens can be
	either key or del, while the right lens must be del.

	This patch changes the semantic of the square lens and is thus not backward
	compatible. Modules must be updated accordingly. The definition of the square
	lens should now be definitive, and later addition may add support for
	additionnal lenses for left and right sides.

	  * builtin.c: change definition of the square lens.
	  * get.c: use the AST to recover the left and right strings matched by the
	    square lens.Regular lenses are handled with regexp registers.
	  * put.c: the variable state->override is used to indicate to a del part of a
	    square lens that it should use the provided value instead of the saved
	    string in the skel or the default value.
	  * lens.c: change the lns_make_square to match the new structure.

	Update square lens test to use lens arguments instead of regexp. The change
	consists to replace "square re lens" into "square right lens left", where right
	and left are lenses. Hence, legacy lens is converted this way:

	Legacy:
	  let x = square re body

	New definition:
	  let x =
		let right = key re in
		let left = del re "" in
		square right body left

	This patch splits pass_square.aug into regular and recursive tests. Other tests
	are added to verify constraints on the square lens arguments and typechecking.

	Finally, this patch updates httpd and xml lens according to square args

	Changes in v2:
	  * protect arg with parenthesis in child_first and child_last macros
	  * drop flag in_square, avoid lens copy, drop square_left/right strings
	    replaced by ast for rec lens and regs for regular lens. This
	    processing is more general than the previous approach, and thus
	    will help to extends the square lens more in the future.
	Changed in v3:
	  * Split the patch into smaller units
	Changed in v4:
	  * Rejoin patches to avoid breaking make check

2012-08-15  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Build AST while visiting the parse v2
	The AST records the structure of the parse according to the lens tree. The
	indices of the text matched is recorded for later use.

	Changed in v2:
	  * Additional checks for correctness
	  * Create the root node in rec_process()
	  * Merge ast_add_child() and ast_append()

2012-08-14  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix memory leak in dbg_visit
	dbg_visit() calls format_lens() to display the lens information. The caller of
	format_lens() must free the memory allocated, just do it.

	Ignore Eclipse settings directory

2012-08-13  Dominic Cleal  <dcleal@redhat.com>

	Simplevars: use to parse /etc/default/grub_installdevice
	Ticket #290

2012-08-12  Dominic Cleal  <dcleal@redhat.com>

	Hosts_Access: add hosts_options(5) support
	Fixes ticket #256

2012-08-12  Dominic Cleal  <dcleal@redhat.com>

	Hosts_Access: permit more client list formats
	  * whitespace separated lists
	  * @netgroups
	  * IPv6 hosts, inc. zone indices
	  * paths to lists of clients
	  * wildcards

	Mostly fixes ticket #256

2012-08-12  Dominic Cleal  <dcleal@redhat.com>

	Fix regression in permissions of created files
	Commit 16387744 changed temporary file creation to use mkstemp, resulting in
	new files being created with 0600 permissions.  For brand new files created
	through Augeas, their permissions stayed at 0600 rather than being set by the
	umask as before.

	  * src/transform.c (transform_save): chmod after creating new files to
	    permissions implied by the umask

2012-08-12  Dominic Cleal  <dcleal@redhat.com>

	Fix issues reported by clang static analyser
	  * src/transform.c (text_retrieve): initialise variable before use
	  * src/transform.c (filter_generate): remove duplicate variable assignment
	  * src/jmt.c (parse_add_item): ensure return is defined on goto error

	Fix augtool --transform documentation
	  * src/augtool.c (usage): -t syntax is now same as 'transform' command
	  * src/augrun.c (cmd_transform_def): improve description

	Arrange commands into groups for better help
	  * src/augrun.c: create group definitions, move commands into arrays per
	    group, update help output to iterate over and announce each group

2012-08-11  Dominic Cleal  <dcleal@redhat.com>

	Ldif: new lens to read LDIF files per RFC2849

	* src/augtool.c (add_transforms): move free() to prevent free(NULL) and run on   each iteration

2012-08-11  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add a way to specify explict transforms
	Allow specifying transforms in three different ways:
	 - an aug_transform API call
	 - a transform command for aug_srun
	 - a -t|--transform option to augtool

2012-08-11  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c: use constants for "lens", "incl" and "excl"

2012-08-10  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix typo in previous commit
	Adjust comment and remove duplicated test case for primary statement in
	dhcpd.conf lens.

	Fix bug #293 primary statement in dhcpd.conf
	The "primary" statement does not support any arguments, while it should when
	it's used in the "zone" block statement. The solution is to add the primary
	statement in the statements that requires a string argument. The primary
	statement can thus take a value or not, and thus do not cause any ambiguity in
	the put direction.

2012-08-08  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add entry_list and entry_list_nocomment to inifile.aug Use entry_list_nocomment in subversion.aug

	Add aug_rename to rename node labels without moving them in the tree.

2012-08-07  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Escape double quotes when dumping regexp
	Graphviz DOT is using double quotes to quotes the string of a label. Escape
	double quotes to avoid parsing errors with graphviz when the regexp of the lens
	includes double quotes.

2012-08-02  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Update doc/naturaldocs/conf/lenses/Menu.txt

	Update email address for Raphaël Pinson in AUTHORS

2012-08-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Make get_square case insensitive on the ending key.

2012-07-30  Dominic Cleal  <dcleal@redhat.com>

	* src/augrun.c (cmd_retrieve_help): tidy line wrapping

	NetworkManager: support semicolons in values, spaces and brackets in entry names

	* src/transform.c (xread_file): catch failed fopen, e.g. EACCES

2012-07-29  Dominic Cleal  <dcleal@redhat.com>

	Fix Valgrind memcheck errors
	  * src/augtool.c (main_loop): free memory allocated by readline
	  * src/augrun.c (aug_srun): free command opts after use

2012-07-28  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Notify #augeas channel

2012-07-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add valgrind test in .travis.yml

	Add Travis CI file

	Shellvars.aug fix empty comments

	Shellvars.aug: Allow double quotes around variables in case statements

	Shellvars.aug: Add shift and exit builtins, with optional args

	Shellvars.aug: Fix empty lines after comments

	Shellvars.aug: Support matching keys in var_action (ticket #290)

	Shellvars.aug: Add dbquot for double bquoted values

	Shellvars.aug: eol_comments must begin with a space char can contain #

	Shellvars.aug: Add bquot and dollar-assigned tests

	shellvars.aug: Allow semi-colons in bquot and dollar_assign Fix wrong test using bquot and eol_comment

	Allow newlines in quoted values

	Add lns_norec to shellvars.aug and fix ambiguities in the lens.

	Fix ambiguity in shellvars.aug by making semi-colons illegal in bquot and arrays.

2012-07-26  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Allow end of line comments in fstab.aug

2012-07-24  Michal Filka  <mfilka@suse.cz>

	Cron: records can be prefixed by '-'.

2012-07-20  Danny Yates  <danny@codeaholics.org>

	vsftpd.aug: Add require_ssl_reuse option

2012-07-20  David Lutterkort  <lutter@redhat.com>

	* augeas.spec.in: add bundled(gnulib) provides
	Fixes BZ 821745

2012-07-20  Dominic Cleal  <dcleal@redhat.com>

	Prevent cross-mountpoint attacks via .augsave during saving
	Previously Augeas would open PATH.augsave for writing if a rename from PATH to
	PATH.augsave failed, then write the file contents in.  Now if the rename fails,
	it tries to unlink PATH.augsave and open it with O_EXCL first.

	Mountpoints remain permitted at either PATH or PATH.augnew provided
	/augeas/save/copy_if_rename_fails exists.

	* src/transform.c (clone_file):
	    add argument to perform unlink and O_EXCL on destination filename after a
	    rename failure to prevent PATH.augsave being a mountpoint
	* src/transform.c (transform_save, remove_file):
	    always try to unlink PATH.augsave if rename fails, only allowing PATH to be
	    a mountpoint; allow PATH or PATH.augnew to be mountpoints
	* tests/
	    test-put-mount: check PATH being a mountpoint is supported
	    test-put-mount-augnew.sh: check PATH.augnew being a mountpoint is supported
	    test-put-mount-augsave.sh: check unlink error when PATH.augsave is a mount

	Fixes BZ 772261

2012-07-20  Dominic Cleal  <dcleal@redhat.com>

	Prevent symlink attacks via .augnew during saving
	Instead of saving into a predictable PATH.augnew file, save into a securely
	created PATH.augnew.XXXXXX

	* src/transform.c (transform_save):
	    write changes to a temporary file in the same directory as the destination
	    (either the file's canonical path or the path of .augnew), before renaming

	* src/transform.c (transfer_file_attrs):
	    use fchown, fchmod etc. on the same file handles to ensure consistent
	    permission changes

	* bootstrap: add mkstemp gnulib module
	* tests/
	    test-put-symlink-augnew.sh: test symlink attack when writing .augnew
	    test-put-symlink-augsave.sh: test symlink attack when writing .augsave
	    test-put-symlink-augtemp.sh: test symlink attack via temp .augnew
	    test-put-symlink.sh: also test file modification

	Fixes BZ 772257

2012-07-19  Dan Prince  <dprince@redhat.com>

	Pythonpaste: new lens for Python Paste configs.
	Added a new lense file for Python Paste configs. This is useful
	for editing a variety of Openstack config files including,
	Nova api-paste.ini, Glance *.ini files, keystone.conf, and the
	swift config files.

2012-07-19  David Lutterkort  <lutter@redhat.com>

	Xinetd: slight formatting improvements

	Case-insensitive regexps: fix a problem with number of groups
	When we expand a regexp to a case-sensitive regexp in regexp_expand_nocase,
	it is possible that the number of groups in that regexp changes,
	e.g. /(a)|(b)/i becomes /[AaBb]/. That confuses the parser when that regexp
	is used in a union or concatenation, since it expects the match following
	the match for this regexp to be in group 3, not group 1.

	* src/regexp.c (regexp_union_n, regexp_concat_n): fix bad memory access
	Avoid calling strlen on a possibly unintialized string (since we overwrite
	the trailing '\0' with a '(' just before calling REALLOC

2012-07-19  Michal Filka  <mfilka@suse.cz>

	made xinetd.aug case insensitive on attribute names

2012-07-19  David Lutterkort  <lutter@redhat.com>

	Update gnulib to commit cabce6b8

2012-07-19  David Lutterkort  <lutter@redhat.com>

	* src/builtin.c (pr_tree): new primitive print_tree
	Useful in 'put' tests, as in

	  test lns put ".." after
	    set .. ;
	    print_tree;
	    set ..
	  = ?

2012-07-18  David Lutterkort  <lutter@redhat.com>

	aug_text_store, aug_text_retrieve: fix segfault when passed in node was NULL
	When the node existed, but had a NULL value, we segfaulted instead of
	reporting an error. We now report ENOMATCH.

	Fixes https://fedorahosted.org/augeas/ticket/283

2012-07-16  Dominic Cleal  <dcleal@redhat.com>

	Fstab: options field is optional

2012-07-13  Dominic Cleal  <dcleal@redhat.com>

	Authorized_Keys: add more tests

2012-07-13  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add authorized_keys.aug and associated test.

2012-07-05  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	simplevars.aug: Add /etc/zabbix/*.conf to includes

	simplevars.aug: Allow quotes in variables that do not begin with a quote

2012-06-28  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: exclude directories from /etc/sysconfig/* wildcard
	This prevents a bug where Augeas maps a directory such as
	/etc/sysconfig/network-scripts to a lens via a matching transform and fails
	to save if the user edits /etc/sysconfig/network-scripts/ifcfg-eth0.

2012-06-20  Micah Anderson  <micah@riseup.net>

	escape all possible regular expressions before they are sent to sed

2012-06-13  David Lutterkort  <lutter@redhat.com>

	Modprobe: allow spaces around '=' in option
	Fixes https://bugzilla.redhat.com/show_bug.cgi?id=826752

2012-06-06  David Lutterkort  <lutter@redhat.com>

	* man/augtool.pod: update mentions of default load path

2012-06-02  Luc Didry  <luc@didry.org>

	Add su logrotate.conf option in logrotate.aug

2012-06-01  David Lutterkort  <lutter@redhat.com>

	Tests for aug_text_store and aug_text_retrieve

	aug_text_store, aug_text_retrieve: expose in augtool and aug_srun

	aug_text_store, aug_text_retrieve: new API functions

	* src/transform.c (text_retrieve): new function to turn tree into text

	* src/transform.c (text_store): new function to write string to tree

	* tests/test-run.c: allow loading of a module with 'use'

2012-06-01  David Lutterkort  <lutter@redhat.com>

	Allow running individual tests with test-run
	Invoking 'test-run t1 t2 t3' will only run tests t1, t2 and t3

	  * tests/test-xpath.c: move checking if a test is mentioned in argv to
	    cutest
	  * tests/cutest.c, tests/cutest.h: add should_run
	  * Makefile.am: test-xpath now uses cutest.[ch]
	  * tests/test-run.c (run_tests): check if tests is mentioned on cmd line

2012-06-01  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add postgresql lens

2012-05-31  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Allow eol comments in simplevars.aug

	Add lens for cups

	Add lens for samba's smbusers

2012-05-22  David Lutterkort  <lutter@redhat.com>

	* src/augrun.c (cmd_span): better synopsis

	* tests/run.tests: fix lines with trailing whitespace

	* tests/test-run.c (errtokens): bring in sync with actual error codes

2012-05-18  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (load_file): remove unused variable file

2012-05-17  David Lutterkort  <lutter@redhat.com>

	Fix behavior of set with empty strings
	  * src/augrun.c (cmd_set, cmd_setm): distinguish between empty string and
	    NULL value
	  * tests/run.tests (set-args): adapt to new behavior

2012-05-12  Dominic Cleal  <dcleal@redhat.com>

	* src/try: don't overwrite gdbcmds.txt if it exists

2012-05-11  Dominic Cleal  <dcleal@redhat.com>

	Fstab: handle options with empty values ("password=")

2012-05-07  Tim Bishop  <tim@bishnet.net>

	Puppet, PuppetFileserver: add /usr/local/etc/puppet paths

2012-04-27  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Shellvars: various edge cases in case entries

	AptPreferences: #comments are accepted within entries

	NagiosCfg: /etc/nagios3/commands.cfg and /etc/nagios3/resource.cfg have their own syntax, allow spaces in values.

	/etc/default/whoopsie is an IniFile

	Merge branch 'master' of ssh://git.fedorahosted.org/git/augeas

	Mke2fs: Add support for default_mntopts, enable_periodic_fsck, and auto_64-bit_support.

2012-04-27  Dominic Cleal  <dcleal@redhat.com>

	Make creating NULL value nodes more intuitive
	* src/augrun.c: add "touch" command to create node if it doesn't exist, make
	  <VALUE> argument to "set" and "setm" optional

	Fixes ticket #276

2012-04-24  David Lutterkort  <lutter@redhat.com>

	* src/augeas.h: include 'extern "C"' wrapper for C++
	Fixes https://fedorahosted.org/augeas/ticket/272

	Patch from Igor Pashev

2012-04-23  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Use Sys.getenv("HOME") in dput.aug

2012-04-19  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	PHPVars: map arrays with @arraykey subnodes to make working paths

2012-04-13  Michal Filka  <michal.filka@suse.cz>

	Shellvars: handle bash's implicit concatenation of quoted strings

2012-04-13  Josh  <jokajak@gmail.com>

	Grub: add /boot/grub/grub.conf to transform

2012-04-13  Luc Didry  <luc@didry.org>

	Use Sys.getenv('HOME') in filter instead of ~ since it's not expanded

2012-04-13  Brett Porter  <brett@apache.org>

	Properties: improve handling of whitespace, empty props, and underscores in keys
	This brings the lens closer to the Java specification

	With help from Carlos Sanchez <csanchez@maestrodev.com> and Dominic Cleal
	<dcleal@redhat.com>

2012-04-12  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Use a more standard way of writing LGPL v2+ in lens headers

2012-04-11  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	postfix_transport.aug also applies to virtual (5)

	Add postfix_transport.aug and associated test.

	Add subversion lens and associated test.

	Add networkmanager lens to tests and doc

2012-04-10  Raphaël Pinson  <raphael.pinson@camptocamp.com>

	Add networkmanager.aug and associated test file.

2012-04-09  Dominic Cleal  <dcleal@redhat.com>

	Sudoers: allow quoted strings in Defaults parameters
	Fixes bug #263

	Debctrl: allow control extensions for Python packages
	Fixes bug #267

	Debctrl: fixed package paragraph keywords, allow variables for version numbers in dependency lists, allow DM-Upload-Allowed keyword
	Fixes Debian bug #650887

2012-04-07  Dominic Cleal  <dcleal@redhat.com>

	AUTHORS: updated from recent commits

2012-04-07  Jason Kincl  <jkincl@gmail.com>

	Xymon: new lens for Xymon config files
	Fixes ticket #266

2012-04-07  Jim Meyering  <meyering@redhat.com>

	compile_exp: don't return an uninitialized pointer upon failure
	As a result of its improved flow analysis gcc-4.7.0 20111202 reported:

	  syntax.c: In function 'compile_exp':
	  syntax.c:1694:5: warning: 'v' may be used uninitialized in this \
	  function [-Wmaybe-uninitialized]

	However, compile_exp calls many functions that return values that are
	then assigned to "v".  Only two of those had a problem: in each there
	is an error path by which the returned pointer is not initialized.
	* src/syntax.c (compile_concat): Initialize "v".
	(compile_minus): Likewise.

2012-04-05  Duncan Mac-Vicar P  <dmacvicar@suse.de>

	bootloader is also present in shellvars_list, exclude from shellvars.

2012-04-02  Dominic Cleal  <dcleal@redhat.com>

	Sudoers: allow "!" as a type of Defaults entry
	Fixes Debian bug #650079

	Modprobe: support softdep command
	Fixes Debian bug #641813

2012-03-29  Dominic Cleal  <dcleal@redhat.com>

	* src/augrun.c (nexttoken): support \t and \n in aug_srun tokens
	Fixes bug #265

2012-03-24  Raphaël Pinson  <raphink@gmail.com>

	Add netmask to hosts_access.aug

2012-03-19  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: add systemd's /etc/os-release file

	Systemd: new lens to parse systemd unit files

2012-03-18  Dominic Cleal  <dcleal@redhat.com>

	* src/augeas.c (aug_save): remove loop that added a second iteration around   children of /files, causing multiple saves in newfile and noop modes when   editing under /files/boot
	Fixes ticket #264

2012-03-17  Dominic Cleal  <dcleal@redhat.com>

	Qpid: new lens to read Apache Qpid daemon/client configs
	Contributed by Andrew Replogle.

2012-03-13  David Lutterkort  <lutter@redhat.com>

	Make sure reloading discards changes after save with mode 'newfile'

2012-03-11  Dominic Cleal  <dcleal@redhat.com>

	Util: add *.bak and *.old to stdexcl, to match files in /etc/sysconfig

	Fix excl filters that only specify a filename or wildcard
	  * src/transform.c (transform_validate): only normalise excl paths with
	    directory separators into absolute paths
	  * src/transform.c (filter_generate): don't apply root prefix to excl filter
	    values when only comparing the base filename

	Shellvars: exclude non-shell files in tests/root/etc/sysconfig

2012-03-10  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: add /etc/selinux/config

2012-03-07  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: include /etc/{default,sysconfig}/* and list exceptions instead

2012-03-03  Tim Mooney  <Tim.Mooney@ndsu.edu>

	src/augtool.c: rename echo to echo_commands to fix differing types reported with Solaris linker
	Fixes ticket #262

2012-02-25  Dominic Cleal  <dcleal@redhat.com>

	Up2date: change tree to distinguish between empty values and empty lists

2012-02-24  Dominic Cleal  <dcleal@redhat.com>

	Up2date: change tree to fix ambiguity during put, remove list of known config options and separation of possible values

2012-02-23  Dominic Cleal  <dcleal@redhat.com>

	Protocols: change tree to support protocols named "a/n" and "tp++"

	Shellvars: remove non-shell files, up2date now has a lens, move updatedb.conf to Simplevars
	Fonts: exclude README

	Sep: add semicolon

	Ntp: allow deprecated 'authenticate' setting

2012-02-21  Raphaël Pinson  <raphink@gmail.com>

	Add up2date.aug and associated test file

2012-02-18  Raphaël Pinson  <raphink@gmail.com>

	Support \r in httpd.aug

	Support \r in comments in util.aug

	Support \r\n in xml.aug

	Do not allow \r in comment_or_eol

	Add Util.doseol

2012-02-14  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (clone_file): do not leak from_fp

2012-02-14  Raphaël Pinson  <raphink@gmail.com>

	Allow commands without full path if they begin with a lowcase letter in sudoers.aug

	Allow = in commands in sudoers.aug (but force ! or / as first character if not an alias)

2012-02-13  Raphaël Pinson  <raphink@gmail.com>

	Use Build.opt_list in sudoers.aug

2012-02-13  Dominic Cleal  <dcleal@redhat.com>

	Shellvars: add BSD's /etc/rc.conf
	Fixes ticket #255

	Improve aug_srun quoting to permit concatenation and better detect bad quoting
	* src/augrun.c (nexttoken): permit shell-like concatenation of quoted and
	  unquoted strings, detect unmatched quotes and raise AUG_ECMDRUN.
	* tests/run.tests: add lots of tests to cover quoting mismatches, single and
	  double quote combinations, courtesy of David Schmitt

	Passwd: allow asterisk in password field
	Fixes ticket #255

	Pam: exclude /etc/pam.d/README
	Fixes ticket #255

2012-02-10  Raphaël Pinson  <raphink@gmail.com>

	Simplify Sudoers.sto_to_com_user to improve performance. Use more standard constructs.

	Add continued lines to rx.aug and sep.aug

	Improve grub.aug's performances slightly

2012-02-09  Raphaël Pinson  <raphink@gmail.com>

	Improve keepalived.aug: cut typechecking time and resident size by 2.

	Use Cron.shellvar in anacron.aug

	Simplify Cron.key_re to improve typechecking of cron.aug

	Allow # and ; in quoted values in inifile.aug (Fix ticket #243)

2012-02-09  Terence Haddock  <thaddock@tripi.com>

	* lenses/tests/test_iptables.aug: test that we accept blank lines

2012-02-09  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Allocate exception instead of static const value
	The static const value returned by exn_error() may cause SIGSEGV in case
	the value is further changed. To avoid this situation, the structure is
	allocated early in aug_init instead and released in aug_close, and is
	accessible via aug->error->exn. The resulting exception value can be
	modified without adverse effect.

2012-02-09  Duncan Mac-Vicar P  <dmacvicar@suse.de>

	Shellvars: autoload some SuSe and RHN specific files

2012-02-08  David Lutterkort  <lutter@redhat.com>

	Add very simplistic leak test

	Fix some memory leaks
	  * src/augeas.c (tree_from_transform): do not do unneeded strdups which
	    lead to leaks
	  * src/lens.h: any lens can carry a jmt when it is recursive; this was a
	    pretty serious issue which could have lead to memory corruptions, since
	    struct lens was not right for that
	  * src/lens.c (free_lens, lens_release): call jmt_free for all lenses

2012-02-07  Raphaël Pinson  <raphink@gmail.com>

	Fix test-save by allowing (empty | comment)* in yum.aug.

2012-02-07  Dominic Cleal  <dcleal@redhat.com>

	CronAllow: remove accompanying test, moved into Simplelines test earlier

2012-02-07  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (transform_save): different errors for parse and put failure

2012-02-07  David Lutterkort  <lutter@redhat.com>

	Graphviz: remove since it can not be typechecked
	Typechecking for the Graphviz lens requires too much memory right now,
	which makes it impossible to run 'mke check' on a reasonably sized machine
	(6GB memory)

	Backing out the lens until we can figure out a way to fix it so that 'make
	check' works with it in practice.

2012-02-07  Raphaël Pinson  <raphink@gmail.com>

	Disable recursive mode in graphviz.aug since it fails in the put direction.

2012-02-06  Raphaël Pinson  <raphink@gmail.com>

	Pass Util.empty with entry in Build.block_generic. Fix ambiguity with Util.empty in graphviz.aug.

2012-02-04  Raphaël Pinson  <raphink@gmail.com>

	graphviz.aug: space is optional before options

	graphviz.aug: names can be empty

	Support crazy example in graphviz.aug

	Add a simple graphviz.aug and associated test

	Use Build.block_newlines in keepalived.aug

	Build.block_newlines takes a comment parameter, newline is optional

2012-02-03  Raphaël Pinson  <raphink@gmail.com>

	Add variables for default delimiters and regexps in build.aug

2012-02-03  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (filter_generate): take root into account for excludes
	When matching an exclude pattern against a path, only try to match against
	the part of path after the root. The paths found by globbing include
	patterns contain the root.

	Fixes bug #252

2012-02-03  Raphaël Pinson  <raphink@gmail.com>

	Improve logrotate, use Build, Rx, Sep

	Add lbracket and rbracket to sep.aug

	Add tests for build.aug

	Add Build.block_newlines and use it in xinetd.aug

	Rewrite xinetd.aug with Build, Sep, Rx

	Allow to set lbracket_re and rbracket_re in Build.block_generic

	Add Util.delim and use it in Sep.space_equal

	Add Build.block_setdefault

	Add default_lbracket and default_rbracket to Build.block_generic

	Add blocks to build.aug, add comment_noindent to util.aug Add test_build.aug

2012-02-01  Raphaël Pinson  <raphink@gmail.com>

	Support dollar assignment ($(bar)) in shellvars.aug

	Parse functions in shellvars.aug

	Shellvars.aug allows multiple elif statements

	Add test_fonts.aug

2012-02-01  Dominic Cleal  <dcleal@redhat.com>

	CronAllow: remove lens, add files to the Simplelines lens

2012-02-01  Raphaël Pinson  <raphink@gmail.com>

	Add fonts.aug

	Add ldso.aug and test

	Fix author

	Add /etc/sysctl.d to sysctl.aug, improve lens and add it to docs.

	Add protocols.aug and associated test

	Add /etc/wgetrc to simplevars.aug

	Add simplelines.aug and test

	Add simplevars.aug and associated test

2012-01-31  Raphaël Pinson  <raphink@gmail.com>

	Add inputrc.aug and associated test

	Add anacron.aug and associated test

	cowpoke.conf

	Ignore allow.pamlist from pam.aug

	Add a few files to shellvars.aug

	Add fuse.aug and associated test

2012-01-27  Dominic Cleal  <dcleal@redhat.com>

	Vfstab: new lens for /etc/vfstab config on Solaris

2012-01-23  Dominic Cleal  <dcleal@redhat.com>

	Automounter: exclude /etc/auto_master for Solaris, small tidyup

2012-01-22  Dominic Cleal  <dcleal@redhat.com>

	Automounter: exclude /etc/auto.master

	Automaster: change to lowercase for consistency with Automounter

	Automounter: new lens to parse automounter maps (/etc/auto.*)

	AutoMaster: new lens to parse autofs auto.master files

2012-01-21  Dominic Cleal  <dcleal@redhat.com>

	CronAllow: new lens to parse both cron/at allow/deny files
	Cron: exclude cron allow/deny files

	Nsswitch: remove long list of databases, match by regexp

	PamConf: new lens to parse /etc/pam.conf with the additional service field

	Pam: allow uppercase chars in 'types', remove /etc/pam.conf from filter
	PamConf: new lens to parse /etc/pam.conf with the additional service field

	Networks: handle multiple missing network octets, fix sequencing of aliases

	Nsswitch: add extra databases used on Solaris

	Shells: permit same-line comments

	Netmasks: new lens for parsing /etc/inet/netmasks on Solaris

2012-01-20  Travis Groth  <tgroth@gmail.com>

	Nsswitch: add passwd_compat, group_compat and shadow_compat GNU extensions

2012-01-19  Raphaël Pinson  <raphink@gmail.com>

	Add channels.aug and associated test.

2012-01-14  Dominic Cleal  <dcleal@redhat.com>

	Grub: parse "password --encrypted" properly, add tests for file subnode
	Fixes ticket #250

2012-01-12  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix fatest linking with libfa
	fatest requires libfa symbols which are not exported by libaugeas library.

2012-01-10  Lubomir Rintel  <lubo.rintel@gooddata.com>

	Correctly parse empty object and arrays in JSON
	Add a test case.
	Fix from David Lutterkort <lutter@redhat.com>.

	https://fedorahosted.org/augeas/ticket/248

2012-01-10  Lubomir Rintel  <lubo.rintel@gooddata.com>

	Allow JSON number literals to be followed by whitespace
	Add a test case.

	Fixes https://fedorahosted.org/augeas/ticket/247

2012-01-10  David Lutterkort  <lutter@redhat.com>

	* build/aux/move-if-change: refresh with latest from gnulib
	Taken from gnulib commit 1602f0af

2012-01-02  Dominic Cleal  <dcleal@redhat.com>

	* src/augtool.c (main_loop): re-open rl_outstream/stdout only when stdout isn't   a tty (fixes -e -i); use /dev/tty instead of /dev/stdout when re-opening to   prevent permission errors
	Fixes ticket #241

2012-01-01  Dominic Cleal  <dcleal@redhat.com>

	* tests/test-augtool.sh: fix broken gsed check

2011-12-31  Dominic Cleal  <dcleal@redhat.com>

	Remove Linux-isms so tests can run on Solaris
	* tests/test-augtool-modify-root.sh: /bin/sh -> /bin/bash
	* tests/test-augtool.sh: /bin/sh -> /bin/bash, use 'gsed' if available (GNU sed
	  is required)
	* tests/test-load.c: don't use GNU sed in-place extension
	* tests/test-preserve.sh: handle Solaris `ls -il` output

	* bootstrap: add strchrnul gnulib module (for Solaris)

2011-12-25  Jim Meyering  <meyering@redhat.com>

	Don't use variables uninitialized upon error
	* src/transform.c (filter_generate): Move declarations and
	  initializations of pathv and pathc to precede possible
	  "goto error;" via which those variables are used.

2011-12-24  Francis Giraldeau  <francis.giraldeau@gmail.com>

	fix fatest linking

2011-12-19  Raphaël Pinson  <raphink@gmail.com>

	Rebase yum.aug on inifile.aug, support comments (except in lists) Fix ticket #217

	Add @return to shellvars.aug

2011-12-19  Erinn Looney-Triggs  <erinn.looneytriggs@gmail.com>

	Create lens and tests for sssd.conf heavily based on mysql and php lenses.

2011-12-19  Raphaël Pinson  <raphink@gmail.com>

	aliases.aug: commands can be fully enclosed in quotes (Fix ticket #229)

2011-12-19  Erinn Looney-Triggs  <erinn.looneytriggs@gmail.com>

	Add in single-request-reopen into lens and tests.

2011-12-16  Michael Chapman  <mike@very.puzzling.org>

	Add missing argument to escape()
	Fixes ticket #242.

2011-12-10  Dominic Cleal  <dcleal@redhat.com>

	* src/augeas.c (tree_root_ctx): create context path if it doesn't exist

2011-12-10  Raphaël Pinson  <raphink@gmail.com>

	Add libxml2-devel to requirements in HACKING

2011-12-09  Raphaël Pinson  <raphink@gmail.com>

	Debian-based distributions use /etc/mdadm/mdadm.conf

2011-12-05  Raphaël Pinson  <raphink@gmail.com>

	Support include() in phpvars.aug

	Add unit test for bug #239

	In aug_to_xml: do not replace pathin with '/*' unless the length is 0 or pathin is '/' (Fix ticket #239)

2011-12-04  Richard W.M. Jones  <rjones@redhat.com>

	pkg-config: Augeas requires libxml2.

2011-12-03  David Lutterkort  <lutter@redhat.com>

	Version 0.10.0

2011-12-03  Dominic Cleal  <dcleal@redhat.com>

	Implement escape sequences for whitespace, quotes and square brackets in command arguments to match Puppet provider.
	  * \<sp> or \<tab> will be escaped if not in quotes, else literal
	  * \' or \" will be escaped if in the same type of quotes, else literal
	  * \\ will be escaped
	  * \[ or \] will be passed through so they're escaped in path expressions

	  * src/augrun.c: implement escape sequences
	  * tests/run.tests: add covering tests

2011-12-02  Raphaël Pinson  <raphink@gmail.com>

	Add approx.aug and test to Menu.txt

	Document approx.aug

	Fix nocommand as nocomma in test_aliases.aug

	Add documentation to test_aliases.aug

2011-12-02  David Lutterkort  <lutter@redhat.com>

	* src/augtool.c (print_aug_error): print newline after error details

	augtool: rename 'print-xml' to 'dump-xml'
	That way, 'p' tab-completes to print as before.

	* src/augeas.c (tree_from_transform): handle alloc failure better

	* src/augeas.c (aug_init): make more robust
	  - propagate errors from aug_set and similar
	  - only call api_exit if we called api_enter before

	* src/augeas.c (aug_init): pull logic to set up loadpath into separate function

	* src/augeas.c (init_root): properly report out-of-memory

	* tests/test-api.c (testToXml): swap expected/actual values in assertions

	* src/augeas.c (aug_to_xml): rename 'path' attr on root to 'match'
	The attribute contains a path expression, not just a path.

2011-12-02  David Lutterkort  <lutter@redhat.com>

	Make it possible for aug_init to report initialization errors
	Sometimes initialization fails for mundane reasons, like syntax errors in
	lens files. So far, it was not possible for callers to report details for
	these errors, because they always got a NULL augeas handle back.

	The new flag AUG_NO_ERR_CLOSE causes aug_init to return a handle even if
	initialization fails, so that callers can use the aug_error* functions to
	extract error details before calling aug_close.

	  * src/augeas.c (aug_init): return a partially initialized struct augeas
	    if AUG_NO_ERR_CLOSE is set
	  * src/augeas.h (aug_flags): add AUG_NO_ERR_CLOSE
	  * src/augtool.c: call aug_init with AUG_NO_ERR_CLOSE and print errors on
	    initialization failure

2011-12-02  David Lutterkort  <lutter@redhat.com>

	Update documentation for augtool/augrun and man page

	Adjust more copyright notices

	Fstab: allow ',' in file names
	Fixes BZ https://bugzilla.redhat.com/show_bug.cgi?id=751342

	* man/augtool.pod: update copyright years, regenerate

2011-12-02  Raphaël Pinson  <raphink@gmail.com>

	Sub::Install is not necessary to override functions in Augeas.pm

	Fix white_spaces into with_spaces in test_faidiskconfig.aug

	Add documentation to test_fai_diskconfig.aug

	Extend copyright to 2011 in src/*

	Add test_xml.aug to the lens Menu.txt

	Improve documentation in test_xml.aug

	Add test_keepalived.aug doc to lens Menu.txt and keepaved.aug

	Add documentation to test_keepalived.aug

	Improve documentation for sep.aug

	Improve documentation for rx.aug

2011-12-02  Dominic Cleal  <dcleal@redhat.com>

	src/augrun.c: fix parsing of commands with trailing whitespace tests/test-run.c: use : to write tests with trailing whitespace

2011-12-02  Raphaël Pinson  <raphink@gmail.com>

	Improve documentation for access.aug and test_access.aug

	Fix examples note in inifile.aug

	Add examples note to reprepro_uploaders.aug

	Finalize doc for test_reprepro_uploaders.aug

2011-12-02  Dominic Cleal  <dcleal@redhat.com>

	Fix path context with trailing slash or whitespace

	Add tests from Puppet's Augeas provider, some commented out until fixed.

2011-12-01  Raphaël Pinson  <raphink@gmail.com>

	Fix test_inifile.aug's typo

	Add documentation to test_inifile.aug

	Better integration of tests in NaturalDocs, verbatim code display in doc.

	Add unit tests for aug_to_xml

	libaugeas must now be linked to libxml, too.

2011-11-30  Dominic Cleal  <dcleal@redhat.com>

	* augeas.spec.in: add build req on libxml2-devel

2011-11-30  Raphaël Pinson  <raphink@gmail.com>

	Add an Examples section to reprepro_uploaders.aug's header

	ARG_CHECK errors when condition is met. Invert conditions in aug_to_xml.

2011-11-30  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Sudoers: add more parameter flags/options
	Fixes bug #143

2011-11-30  Raphaël Pinson  <raphink@gmail.com>

	Add aug_to_xml to public API

2011-11-30  David Lutterkort  <lutter@redhat.com>

	New error code AUG_EBADARG and ARG_CHECK macro
	Use ARG_CHECK to check arguments passed through the public API for
	validity; invalid paramters lead to an error of AUG_EBADARG.

	  * src/augeas.h (aug_errcode_t): new error code AUG_EBADARG
	  * src/augeas.c (errcodes): human-readable text for AUG_EBADARG
	  * src/errcode.h (ARG_CHECK): new macro

2011-11-30  Raphaël Pinson  <raphink@gmail.com>

	Improve doc in test_reprepro_uploaders.aug and update Menu.txt for lenses.

	Fix parsing of tests in Augeas.pm, add a test doc to test_reprepro.aug

	Fix parsing of 'in[ \t\r\n]+let' in Augeas.pm

2011-11-30  David Lutterkort  <lutter@redhat.com>

	Normalize lens filters to absolute paths
	It doesn't really make sense to specify relative paths in lens filters; we
	treat them as absolute to avoid unpleasant surprises for users who think
	relative paths are relative to AUGEAS_ROOT. With this change, they are.

	Fixes bug #238

2011-11-30  David Lutterkort  <lutter@redhat.com>

	* tests/cutest.c: run one test when CUTEST env var is set

2011-11-29  Raphaël Pinson  <raphink@gmail.com>

	Add support for 'not' in reprepro_uploaders.aug

	Improve CSS for NaturalDocs

2011-11-29  Dominic Cleal  <dcleal@redhat.com>

	augtool: change readline tab completion to be context-aware

	path expressions: prepend context from /augeas/context to all relative paths
	A path context is prepended to all paths that do not begin at the root,
	changing relative paths into absolute paths.  The context is stored in
	/augeas/context and defaults to the value "/files".

2011-11-29  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (load_file): fix segfault when storing span in NULL tree

	* src/syntax.c (print_tree): print something for a NULL tree

2011-11-29  Raphaël Pinson  <raphink@gmail.com>

	Add header to shellvars.aug

	Add Kdump and Ssh to Menu.txt

	Fix NaturalDocs CSS a bit

	Add a Tests and Examples group in naturaldocs

	Improve documentation for reprepro_uploaders.aug

	Add 'contain' subnodes to reprepro_uploaders.aug and improve documentation.

	Simplify logical tree in reprepro_uploaders.aug

	Improve parameter parsing in reprepro_uploaders.aug

	Add reprepro.aug and associated test.

	Fix small type in comment

2011-11-23  Raphaël Pinson  <raphink@gmail.com>

	Add support for until and select loops in shellvars.aug

	Add elif support to shellvars.aug

	Add big WARNING to aptconf.aug

	Register modules.aug with naturaldocs

2011-11-23  Tom Limoncelli  <tal@whatexit.org>

	Xendconfsxp: new lens and tests for Xen configuration

2011-11-23  David Lutterkort  <lutter@redhat.com>

	* tests/Makefile.am (lens_tests): add missing tests

2011-11-23  Raphaël Pinson  <raphink@gmail.com>

	Add modules.aug and associated test file (Fix ticket #236)

	Add backuppchosts.aug and test (Fix ticket #233)

	mdadm.aug: dev_device cannot match dev_partitions_re

	Fix test_phpvars.aug as per using Util.empty_c_style

	Clean wrong lines in modprobe.aug's header

	Update tests and documentation for new lenses

	Add desktop.aug and associated test.

	Add aptconf.aug and associated test.

	Use Util.empty_c_style in phpvars.aug and don't map empty comments in Util.comment_multiline

2011-11-22  Raphaël Pinson  <raphink@gmail.com>

	Add support for case in shellvars.aug

	Add for and while loops to shellvars.aug

	Adapt modules_conf.aug and test file to refect the changes in modprobe.aug

	Refactor modprobe.aug: * Parse commands in install/remove stanzas; * Drop support for include as it is not documented in manpages and no unit tests are shipped.

	Fix unpriviliged into unpriviliged in test_postfix_master.aug, too.

	Add one-liner unit test for shellvars.aug

	shellvars.aug: Refactor lens, add end-of-line comment support, if/then/else/fi conditionals, one-liners support

	phpvars.aug: Add test for bash-style comment, improve eol comments, use generic_function in simple_function definition

	Parse /etc/mailname with hostname.aug

	Add hosts_access.aug to parse /etc/hosts.{allow,deny} and associated test.

2011-11-19  Raphaël Pinson  <raphink@gmail.com>

	Double quotes are allowed in variable names in phpvars.aug

	Refactor entries in phpvars.aug

	PHP tags are case-insensitive in phpvars.aug

	Add include_once() to phpvars.aug

	Fix typo in postfix_master.aug (Fix ticket 234)

	Allow empty lines at end of files in phpvars.aug

	Better define() support in phpvars.aug

	Support bash-style comments and define() functions in phpvars.aug

	Implement end-of-line comments in phpvars.aug and add tests. In order to add this, I had to forbig the use of /.*;[ \t]*\/\/.*/ in values. There might be a way to make this regexp more strict to be less intrusive, but I believe this pattern is not very common anyway, so I think it's safe to keep it this way for now.

	Cleanup phpvars.aug, rebase it on sep.aug and util.aug and prepare the way to support end-of-line comments

	Fix comment_multiline and add a test file for util.aug

	Spaces are not mandatory around = in phpvars.aug

	Fix open_php and close_php tags in phpvars.aug (Fix ticket 232)

2011-11-18  Jim Meyering  <jim@meyering.net>

	avoid double-free upon fclose failure
	  * src/transform.c (transform_save): Upon initial fclose failure, set "fp
	    = NULL;" so that we don't attempt to free/close "fp" while cleaning up
	    upon "goto done".

2011-11-18  David Lutterkort  <lutter@redhat.com>

	* lenses/util.aug: do not set caml mode for Emacs

	* lenses/rx.aug: delete trailing whitespace

2011-11-18  Raphaël Pinson  <raphink@gmail.com>

	Parse pam.conf in pam.aug

	Add hostname.aug

	Add networks.aug lens

	Add host_conf.aug lens

	Add flag_line to build.aug

	Add blkid.conf to shellvars.aug

2011-11-17  Raphaël Pinson  <raphink@gmail.com>

	Add doc to grub.aug (ticket 33)

2011-11-16  Raphaël Pinson  <raphink@gmail.com>

	Support debug flag in keepalived.aug

	Fix origin entries in aptpreferences.aug

2011-11-16  Dominic Cleal  <dcleal@redhat.com>

	Resolv: Permit end-of-line comments
	Fixes ticket #223

	Krb5: Allow a [pam] section for pam_krb5 (possibly deprecated)
	Fixes ticket #225

2011-11-16  Roman Rakus  <rrakus@redhat.com>

	Kdump: new lens and tests

2011-11-16  Dominic Cleal  <dcleal@redhat.com>

	aug_srun: add 'insert' and 'move' command aliases to 'ins' and 'mv'

2011-11-16  Michael Chapman  <mike@very.puzzling.org>

	Dhcpd: slashes must be double-quoted
	In dhcpd.conf, tokens containing slashes must be double-quoted.

	Fixes the following dhcpd error:

	  /etc/dhcpd.conf line 4: filename string expected.
	  include /
	          ^
	  Configuration file errors encountered -- exiting

2011-11-16  Michael Chapman  <mike@very.puzzling.org>

	Access: parse user@host and (group) in users field
	pam_access matches the hostname in user@host against the system's own
	hostname, which allows a single access.conf to be shared amongst
	multiple machines yet still contain per-server rules.

	pam_access also allows group names to be optionally enclosed in
	parentheses to disambiguate them from user names.

2011-11-16  Michael Chapman  <mike@very.puzzling.org>

	Access: field separator need not be surrounded by spaces
	For compatibility with the old behaviour and to match the examples in
	the PAM documentation, new entries are still emitted with spaces.

	Dhcpd: add Red Hat's dhcpd.conf locations
	RHEL 5 uses /etc/dhcpd.conf.
	RHEL 6 uses /etc/dhcp/dhcpd.conf.

2011-11-16  David Lutterkort  <lutter@redhat.com>

	Mdadm: use case-insensitive regexps

2011-11-16  David Lutterkort  <lutter@redhat.com>

	* src/fa.c (totalize): handle case-insensitive FA's properly
	The convention for case-insensitive FA's is that they do not contain any
	transitions on [A-Z], effectively removing upper case letters from the
	alphabet.

	totalize used to create transitions into the crash state that did
	transition on upper case letters, violating the convention.

2011-11-14  David Lutterkort  <lutter@redhat.com>

	* src/builtin.c (regexp_match): new helper to test a regexp

2011-11-14  Matthew Booth  <mbooth@redhat.com>

	Mdadm_conf: new lens for /etc/mdadm.conf

2011-11-14  David Lutterkort  <lutter@redhat.com>

	* lenses/tests/test_iptables.aug: fix syntax error

2011-11-01  Raphaël Pinson  <raphink@gmail.com>

	Allow digits in ipt_match keys (bug #224)

2011-10-18  David Lutterkort  <lutter@redhat.com>

	* src/syntax.c: fix composition of unit and function
	For a composition with types 'unit ; a -> b' we tricked ourselves into
	doing function composition, when we should do unit composition.

	* src/syntax.c (type_names): fix order of names

2011-10-18  Michael Chapman  <mike@very.puzzling.org>

	Fix regular expression escaping
	This patch fixes:

	  /[\/]/

	Previously, this matched either a backslash or a slash, since \/ was not
	an escape sequence known to unescape(). Now this matches only a slash.

	We pass an extra argument to escape() and unescape() listing the extra
	characters that should be handled. STR_ESCAPES and RX_ESCAPES provide
	the extra characters for strings and regexps respectively, and NULL may
	be passed if no extra characters should be handled.

2011-10-17  David Lutterkort  <lutter@redhat.com>

	Json: fix handling of whitespace
	We just gobble up whitespace after various expressions as part of the lens
	processing that expression.

2011-10-14  Raphaël Pinson  <raphink@gmail.com>

	Spaces are allowed before colons in aliases.aug

	Empty options are allowed in exports.aug

	Entries outside Host statements are allowed (though not documented) in ssh.aug

	Allow indentations in array_entry in ssh.aug

	Small improvements to squid.aug. This lens is inconsistent and should probably be deeply reviewed, although that might break compatibility.

	Not really shellvar entries in cron.aug, semi-colons are allowed for email addresses

	Add schroot to tests and doc

	Add schroot.aug lens

2011-10-13  Raphaël Pinson  <raphink@gmail.com>

	Simplify rsyncd.aug and support indented anon entries and records.

2011-10-11  Raphaël Pinson  <raphink@gmail.com>

	Small adjustments in postfix_master.aug

2011-10-10  Michael Chapman  <mike@very.puzzling.org>

	Fix escape sequences in bracket expressions
	With POSIX extended regexps, escape sequences are not recognised within
	bracket expressions. Any escape sequences passed through by the
	unescape() function would be misinterpreted. For instance, the regular
	expression:

	  /[\.-]/

	matches any of the three characters backslash, dot or hyphen, when the
	lens author most likely wanted dot or hyphen only.

	This patch cleans up the bracket expressions in all lenses, with the
	exception of \/ and \\ sequences. These needs to be handled by
	unescape() directly.

2011-10-10  Michael Chapman  <mike@very.puzzling.org>

	FAI_DiskConfig: Fix invalid escape sequence \s
	It should be expanded to [ \n\t].

2011-10-10  Michael Chapman  <mike@very.puzzling.org>

	Cron: Fix parsing of numeric fields
	In:

	  let num = /[0-9\*][0-9\/,-\*]*/

	the hyphen was treated as a range, not a literal character. This
	erroneously allowed a whole bunch of characters (including all uppercase
	letters) in numeric fields.

2011-10-10  Michael Chapman  <mike@very.puzzling.org>

	Cgconfig: Fix parsing of group names
	In:

	  let id = /[a-zA-Z0-9_\-\/\.]+/

	the hyphen was treated as a range, not a literal character.

2011-10-10  Raphaël Pinson  <raphink@gmail.com>

	Revert badly applied series or patches.
	This reverts commit dc9ef16bc7a4cc45e4d66ea69b4bdf0038e816bb.

2011-10-10  Michael Chapman  <mike@very.puzzling.org>

	Cgconfig: Fix parsing of group names
	In:

	  let id = /[a-zA-Z0-9_\-\/\.]+/

	the hyphen was treated as a range, not a literal character.

2011-10-07  David Lutterkort  <lutter@redhat.com>

	path expressions: add a function 'int'
	This makes it possible to do numerical comparisons of node values, for
	example, 'match /files/etc/group/*[int(gid) < 3]'

2011-10-06  Raphaël Pinson  <raphink@gmail.com>

	Fix cmd_span (ticket #220):
	 - Retrieve option from tree before using it;
	 - Invert conditions since we now use streqv.

	Replace sep_spc? with sep_opt_spc in bbhosts.aug

2011-10-06  Michael Chapman  <mike@very.puzzling.org>

	Postfix_master: allow commas in commands
	Postfix daemons accept "-o name=value" to override main.cf configuration
	parameters, and the value can be a comma-separated value list.

2011-10-05  Raphaël Pinson  <raphink@gmail.com>

	Support \!include in mysql.aug

	Various changes to keepalived.aug:  - Implement vrrp_script;  - Make spaces optional before lbracket;  - Support track_interface, track_script and garp_master_delay;  - Add ha_suspend and notify_*;  - Add relinteger to rx.aug and use it in keepalived.aug.

2011-10-04  Raphaël Pinson  <raphink@gmail.com>

	Spaces are mandatory after # in bbhosts.aug

2011-10-02  Marc Fournier  <marc.fournier@camptocamp.com>

	nrpe: fixed #218 - error caused by unused '=' in lens

2011-10-01  Dominic Cleal  <dcleal@redhat.com>

	Multipath: add support for six options in the defaults section:   dev_loss_tmo, max_polling_interval, verbosity,   reassign_maps, fast_io_fail_tmo, async_timeout
	Fixes ticket #207

2011-09-12  Raphaël Pinson  <raphink@gmail.com>

	Support more ranges in cron.aug

	Flags also can be indented in mysql.aug

2011-09-09  Raphaël Pinson  <raphink@gmail.com>

	Allow indented entries in php.aug

	{ can be followed by spaces in xinetd.aug

	Allow indented entries in mysql.aug

	Allow empty lines after includedir

	includedir statements are not part of sections in mysql.aug

2011-09-08  Raphaël Pinson  <raphink@gmail.com>

	Hooks without any lines are valid in logrotate.aug

	Allow spaces after 'endscript' in logrotate.aug

2011-09-07  Raphaël Pinson  <raphink@gmail.com>

	Various fixes in bbhosts.aug

2011-09-06  Raphaël Pinson  <raphink@gmail.com>

	Fix empty lines support in fai_diskconfig.aug

2011-09-05  Raphaël Pinson  <raphink@gmail.com>

	Add functionalities, refactor volume by type of disk_config entry and add tests to fai_diskconfig.aug

2011-09-02  David Lutterkort  <lutter@redhat.com>

	* src/pathx.c (nodeset_as_regexp): match nothing if nodeset is empty
	This makes sure that constructs like 'glob(no_such_node)' or
	'regexp(no_such_node)' in path expressions never match anything, which is a
	better default than the empty regexp that was produced before.

2011-09-02  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix run single command with autosave
	This patch fixes autosave in the case only one command is provided as
	arguments and adds a test that checks proper handling of this case.

2011-09-01  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Disable autoload transform for the fai_diskconfig
	Autoload transform with only standard exclude makes failing the glob_for_lens
	xpath test. fai_diskconfig does this. As a temporary fix, we disable transform
	from fai_diskconfig.

2011-09-01  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Adding ssh client lens
	This lens parses the client side configuration directives of ssh.

	Thanks to Jiri Suchomel for this contribution.

2011-08-31  Raphaël Pinson  <raphink@gmail.com>

	Add fai_diskconfig.aug and test

2011-08-30  Raphaël Pinson  <raphink@gmail.com>

	Allow semicolons in shellvars.aug, add non regression test

2011-08-22  Francis Giraldeau  <francis.giraldeau@gmail.com>

	New stunnel lens
	Stunnel provides SSL tunnel for daemons. The configuration is based on the ini
	file syntax.

	Thanks to Oliver Beattie that contributed this lens.

2011-08-17  David Lutterkort  <lutter@redhat.com>

	Fix uses of Spacevars as a utility module
	  - add Build.key_ws_value to do the same as Spacevars.entry
	  - expand uses of (Spacevars.lns l) into the more explicit (comment|empty|l)*

	This fixes test breakage introduced by commit 4840c7ab

2011-08-11  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Proper test for eolwhite space handling
	By reformating eol of pupperfileserver test, it's possible to make both git and
	unit test working.

2011-08-11  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Remove trailing white spaces from puppet test
	Trailing white lines are valid in a puppet file, but the test is rejected when
	pushing to master git repository.

	remote: lenses/tests/test_puppetfileserver.aug:20: trailing whitespace.
	remote: +allow *
	remote: error: hook declined to update refs/heads/master
	 ! [remote rejected] master -> master (hook declined)

	Removing white space for now.

2011-08-11  Dominic Cleal  <dcleal@redhat.com>

	PuppetFileserver: support same-line comments and trailing whitespace (2.7.3rc1)
	Fixes ticket #214

2011-08-11  David Lutterkort  <lutter@redhat.com>

	Spacevars: rename toplevel lens to lns
	Leave simple_lns as an alias for backwards compatibility

2011-08-09  David Lutterkort  <lutter@redhat.com>

	* examples/fadot.c: accept -h option to print usage

2011-07-26  David Lutterkort  <lutter@redhat.com>

	.gitignore: ignore tests/test-run

	Version 0.9.0

	Minor fixes to make distcheck pass

2011-07-23  David Lutterkort  <lutter@redhat.com>

	path expressions: parse [expr1 or expr2] correctly
	Since commit ea010d85, we would interpret the predicate [e1 or e2] as
	matching any node with a child labelled 'e1 or e2'; this patch restores the
	semantics that the predicate is true if either e1 or e2 are true. It does
	the same for [e1 and e2]

	Of course, this is a heinous hack.

2011-07-23  David Lutterkort  <lutter@redhat.com>

	Migrate tests from test-mv.sh into run.tests

	aug_srun: new API call

	aug_mv: report EMVDESC if move would move a node into its descendant

	path expressions: produce straight augeas errors when it makes sense
	Some errors, especially matching no nodes or multiple nodes in
	pathx_expand_tree can be directly translated to AUG_ENOMATCH and
	AUG_EMMATCH, and there's no need to give pathx details about the error

	Fix some of the errors reported by coverity
	These are some of the errors by running coverity on augeas 0.8.0

2011-07-19  Mathieu Arnold  <mat@FreeBSD.org>

	Aliases: allow spaces and commas in aliases; add docs

2011-07-12  Dominic Cleal  <dcleal@redhat.com>

	Sudoers: support users:groups format in a Runas_Spec line for sudo -g
	Fixes ticket #211

2011-07-12  David Lutterkort  <lutter@redhat.com>

	* tests/test-bug-1.sh: fix test
	The test caused an augtool failure for all the wrong reasons

2011-07-07  David Lutterkort  <lutter@redhat.com>

	Php: include files from Zend community edition
	Fixes ticket #210

2011-07-07  Craig Dunn  <craig@craigdunn.org>

	Properties: new lens for Java properties files
	Fixes ticket #194

2011-07-02  Dominic Cleal  <dcleal@redhat.com>

	Grub: allow "bootfs" Solaris/ZFS extension for dataset name
	Fixes ticket #201

2011-07-02  John Morrissey  <jwm@horde.net>

	Spacevars: add two more filse to parse by default
	Fixes ticket #202

2011-07-02  David Lutterkort  <lutter@redhat.com>

	Interpret escape sequences in function regexp() in path expressions
	The wildcard character '.' in regular expressions, just as in the rest of
	Augeas, does not match an end of line. It is therefore crucial to be able
	to write '(.|\n)' to match any character, including newlines.

	  * src/regexp.h: (make_regexp_unescape): new function; (make_regexp_dup)
	    removed
	  * src/regexp.c: (make_regexp_unescape): new function; (make_regexp_dup)
	    removed
	  * src/pathx.c: (nodeset_as_regexp, func_regexp_or_glob): use
	                  make_regexp_unescape

2011-06-30  Dominic Cleal  <dcleal@redhat.com>

	Sudoers: add CSW paths, /opt/csw/etc and /etc/opt/csw/sudoers

	Sudoers: allow same-line comments
	Fixes ticket #206

2011-06-30  Dominic Cleal  <dcleal@redhat.com>

	Util: allow comment_or_eol to match empty comments containing only whitespace
	Services: add test for line with a whitespace-only comment

	Fixes ticket #205

2011-06-30  David Lutterkort  <lutter@redhat.com>

	* tests/test-bug-1.sh: fix broken logrotate file

2011-06-09  Raphaël Pinson  <raphink@gmail.com>

	Implement multiline values in inifile.aug

2011-05-15  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c (static_nodes): add list of pathx functions to /augeas/version

2011-05-13  David Lutterkort  <lutter@redhat.com>

	Grub: allow kernel path to start with a device like (hd0,0)
	Fixes ticket #199

	* examples/fadot.c: include <config.h>, link against GNULIB

2011-05-11  David Lutterkort  <lutter@redhat.com>

	tests: expand what the valgrind target runs

	* src/pathx.c: rename CHECK_ERROR{,_RET0} to RET{,0}_ON_ERROR
	This should make it harder to misuse them and cause memory leaks

	* src/pathx.c (ns_from_locpath, parse_relative_location_path): free memory on error

	* tests/test-xpath.c: allow running individual tests from the command line

	* src/pathx.c: fix leaking of function arguments

	path expressions: allow concatenating strings and regexps with '+'

	path expressions: add operator '!~'

	path expressions: add 'glob' function that constructs regexps from globs

	regexp: add make_regexp_from_glob to convert globs to regexps

	regexp: add convenience function make_regexp_dup

	path expressions: allow passing a nodeset to function regexp

	* src/pathx.c (check_app): allow overloaded functions
	Make it possible to have multiple functions with the same name, but
	different signatures. All variants of a function must have the same arity,
	they can only differ in their return type and the types of the arguments.

	Keep a dummy struct info in struct error for convenience
	  * src/errcode.h (struct error): at a info member
	  * src/augeas.c (aug_init): set up the struct info in struct error;
	    (aug_close): free the struct info in struct error

	* src/augtool: store history in ~/.augeas/history

2011-05-05  David Lutterkort  <lutter@redhat.com>

	Xorg: accept InputClass section

2011-05-04  David Lutterkort  <lutter@redhat.com>

	Xorg: autoload from /etc/X11/xorg.conf.d/*.conf
	Based on patch by manugupta

	Fixes bug #197

2011-04-30  David Lutterkort  <lutter@redhat.com>

	test root: add a few more files

2011-04-30  David Lutterkort  <lutter@redhat.com>

	path expressions: allow whitespace inside names
	This makes the path expression '/files/etc/foo bar/baz' legal, i.e. it is
	no longer necessary to escape whitespace in path expressions.

	Fixes BZ 700608

2011-04-16  David Lutterkort  <lutter@redhat.com>

	Version 0.8.1

	Iptables: handle --tcp-flags
	Fixes bug #157

2011-04-15  David Lutterkort  <lutter@redhat.com>

	* src/augtool.c: respect autosave flag when executing a single command
	Fixes bug #193

2011-04-14  Erinn Looney-Triggs  <erinn.looneytriggs@gmail.com>

	Grub: support the 'device' directive for UEFI boot
	Fixes bug #189

2011-04-14  David Lutterkort  <lutter@redhat.com>

	Access: support the format @netgroup@@nisdomain
	Fixes bug #190

	* lenses/tests/test_fstab.aug: test that we parse SELinux context correctly

2011-03-26  David Lutterkort  <lutter@redhat.com>

	Httpd: remove duplicate inclusion of /etc/httpd/conf/httpd.conf

2011-03-26  Bill Pemberton  <wfp5p@virginia.edu>

	Deal with continuation lines in httpd.aug
	Apache allows config lines to be continued with a backslash, but the
	lens couldn't deal with it.  Change the value sep_spc to deal with
	continuation lines as found in interfaces.aug

	Enable the test for continuation lines in test_httpd.aug

2011-03-26  Bill Pemberton  <wfp5p@virginia.edu>

	Add /etc/httpd/conf/httpd.conf to the filter list for httpd.aug

	Allow blank and comment lines throughout config file in iptables

	Exclude /etc/yum/pluginconf.d/versionlock.list from yum.aug
	The versionlock plugin puts a file in /etc/yum/pluginconf.d that is
	not a yum config file so yum.aug shouldn't try to parse it.

2011-03-24  David Lutterkort  <lutter@redhat.com>

	Mysql: include /etc/my.cnf used on Fedora/RHEL
	Fixes https://bugzilla.redhat.com/show_bug.cgi?id=688053

	Httpd: include /etc/httpd/conf/httpd.conf used on Fedora/RHEL
	Fixes https://bugzilla.redhat.com/show_bug.cgi?id=688149

2011-03-23  David Lutterkort  <lutter@redhat.com>

	* src/lexer.l: fix a few compilation warnings

	Eliminate global variable 'comment_depth' in lexer

2011-03-20  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add support for configfile and background in grub
	Test for the new configuration directives are also provided.

	Thanks to Onur Küçük for the patch.

2011-03-18  Raphaël Pinson  <raphink@gmail.com>

	#include is also valid in sudoers.aug

	Add support for #includedir in sudoers.aug and test (ticket #188)

2011-03-18  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Support sudoers in nsswitch.aug
	nsswitch.conf support a configuration item to specify database backend, this
	commit adds the support for it.

	Fix bug #187

	Thanks to thefoxbox for the enhancement

2011-03-18  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix unmatch bracket causes segfault in augtool.c
	When command is parsed in augtool, function nexttoken verify that path has
	valid and matching brackets and return NULL if not. The function cleanpath that
	follows was not handling the NULL case, leading to a segmentation fault. By
	checking for NULL value, the error is thrown adequately.

	Fix bug #186

	Thanks to spamaps for the help to resolve this issue.

2011-03-17  David Lutterkort  <lutter@redhat.com>

	* src/lexer.l (augl_init_lexer): really close the input file on error

2011-03-17  Richard W.M. Jones  <rjones@redhat.com>

	Add FreeBSD /etc/rc.conf file to Shellvars lens.

2011-03-16  David Lutterkort  <lutter@redhat.com>

	Replace erroneous assert(0) with proper error report
	  * src/put.c (create_union): report an error to the user if none of the
	    alternatives match
	  * lenses/tests/test_shellvars.aug: add a test to trigger that code path
	    in create_union

	Fixes bug #183

2011-03-11  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c (aug_init): check return value of argz_* for ENOMEM

2011-03-11  Matthew Booth  <mbooth@redhat.com>

	Fix parsing of fstab entries containing fscontext SELinux option
	Systems using SELinux can contain an fstab option like:
	fscontext=system_u:object_r:removable_t

	The fstab lens is currently too strict, and doesn't allow colons in the value.
	This patch relaxes the parsing to make it as lax as possible within the
	constraints of the syntax.

2011-03-09  David Lutterkort  <lutter@redhat.com>

	Be more defensive about closing input files for the lexer

2011-03-05  David Lutterkort  <lutter@redhat.com>

	Explain using ./src/try
	  * HACKING: document the various modes of using ./src/try
	  * src/try: read commands from build/augcmds.txt rather than /tmp; use a
	    more sensible default if augcmds.txt does not exist

2011-03-04  Matthew Booth  <mbooth@redhat.com>

	Use getopt-gnu from gnulib for AIX support

	Update to gnulib commit c2090a8
	Required for updated getopt-gnu license.

2011-03-04  Raphaël Pinson  <raphink@gmail.com>

	Remove trailing spaces in lenses/tests/test_nagiosobjects.aug

	Add nagiosobjects.aug based on Sebastien Aperghis' work.

2011-03-03  Raphaël Pinson  <raphink@gmail.com>

	Remove trailing spaces in nagioscfg.aug

	Improve nagioscfg.aug as per Sebastien Aperghis' work.

	Fix single quotes support in httpd.aug.

	Support single quotes in httpd.aug. Add unit test for it in test_httpd.aug.

2011-03-03  David Lutterkort  <lutter@redhat.com>

	* tests/fatest.c (testManualAmbig): don't use '$' in variable names
	Breaks on, at least, AIX

2011-03-03  Raphaël Pinson  <raphink@gmail.com>

	Add Sep.equal, used in nrpe.aug

	Changes in nrpe.aug Remove wrong ^ in comment regex Use Util.comment_generic Use generic modules Improve NaturalDocs documentation

2011-02-24  David Lutterkort  <lutter@redhat.com>

	Version 0.8.0

2011-02-24  David Lutterkort  <lutter@redhat.com>

	Fix compile errors found by gcc 4.6.0
	There were several places that caused the new 'variable assigned but not
	used' warning.

	The struct lens also contained the member jmt twice; it is now only
	available for L_REC lenses.

2011-02-24  David Lutterkort  <lutter@redhat.com>

	* src/info.h: include stdlib so we can use uint

	* tests/Makefile.am: distribute the test data in test-augtool/

2011-02-24  Dominic Cleal  <dcleal@redhat.com>

	Split Solaris multiboot argument for the kernel path into @path node (ticket #158)

2011-02-23  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add aug_span API function V2
	aug_span API function provides information about the node of the specified
	path. It sets the absolute path of the file name and spans of label, value
	and span inside the node. The span includes all matching chars of the actual
	lens and it's descendant. Hence, the top level node will span the entire file.
	It returns 0 in case of success and -1 if the node is not associated to a file
	or if the path is invalid.  The main use case is to make possible to display
	the related file with the node elements hightlighted in a UI.

	The API option AUG_NO_NODE_SPAN provided to aug_init disable the allocation
	structures to keep node spans. It saves about 5% of memory for a typical
	tree.

	  * src/augeas.c : add aug_span implementation and option handling to aug_in
	    according to the option /augeas/span in the tree
	  * src/augeas.h : add declaration of aug_span and constants for option
	  * src/augeas_sym.version : make the new function visible in libaugeas
	  * src/augtool.c : add the "nodepos" command to augtool
	  * src/get.c : gather filename, label, value and span spans if any
	  * src/info.c : create and release functions for struct node_span
	  * src/info.h : add definition of struct node_info
	  * src/internal.h : add node_info to struct tree
	  * src/transform.c : duplicate filename string
	  * tests/test-load.c : 3 basic unit tests for general correct behavior

2011-02-23  Raphaël Pinson  <raphink@gmail.com>

	Add short options for --nostdinc, --noload and --noautoload Update manpage and pod accordingly

	Distribute bcprules.sty and xpath.txt

2011-02-19  Raphaël Pinson  <raphink@gmail.com>

	Add indented_title_label in inifile.aug Use indented_title_label in mysql.aug Adjust test for mysql.aug accordingly

	Allow indentation for "iface" entries in interfaces.aug (Fix ticket #182) Add unit test for "iface" indentation

2011-02-17  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Minor code format cleanup
	  * Cut long lines to 80 chars
	  * Indentation fix

	Fix memory leak with recursive square lens

2011-02-16  Raphaël Pinson  <raphink@gmail.com>

	Remove trailing whitespaces in util.aug

	Add comment_c_style and comment_multiline Add empty_generic and make empty a call to it Add empty_c_style to complement comment_c_style

2011-02-16  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix segfault in get.c with L_MAYBE lens (bug#180)
	When a L_MAYBE lens was the last child of a L_CONCAT inside a L_SUBTREE, then
	the match in visit_exit top_frame(rec_state)->lens == lens->child was true,
	causing combine of a frame when it shouldn't. This test is true because there
	is no other lens following in the concat in this special case, hence the top
	frame matched the child of the L_MAYBE.

	To avoid this special case, we propose to push L_MAYBE lens on the frames
	stack. If L_MAYBE is encountered in visit_exit, we pop at least one frame and
	two if the child match. This way, the stack is always valid.

	Closes trac ticket #180.

2011-02-16  Raphaël Pinson  <raphink@gmail.com>

	Improve vim syntax file

2011-02-15  David Lutterkort  <lutter@redhat.com>

	man pages: update man page for augtool

2011-02-15  Raphaël Pinson  <raphink@gmail.com>

	augtool: add --interactive option
	This option runs an interactive shell after evaluating STDIN or an explicit
	inputfile

2011-02-15  David Lutterkort  <lutter@redhat.com>

	Mysql: change default comment delimiter from ';' to '#'
	Fixes bug #181 reported by devzero

2011-02-07  Francis Giraldeau  <francis.giraldeau@usherbrooke.ca>

	Add Dhcpd lens
	  * Support unquoting for allow/deny statements
	  * Append new line to block statement braces by default
	  * Add missing string and integer statements according to man dhcpd.conf
	  * Remove trailing white space from the lens file

	Replace seq by label in option list

	  The counter/seq doesn't garantee that node label "1" will get at the first
	  position. Positional arguments are ordered, hence the sequence may be
	  misleading. This is why a fixed label for sequence nodes are better.

2011-01-29  Raphaël Pinson  <raphink@gmail.com>

	Support directives without arg in httpd.aug
	* Use sep.aug in httpd.aug Modify Sep.opt_space to make it fit the
	  definition in httpd.aug (it's only used here)
	* Allow directives without arguments in httpd.aug
	* Adjust test_httpd.aug to test argument-less directives

2011-01-26  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix httpd.aug doc, filter and add to checks
	  * Added other contributors to authors
	  * Changed the licence to LGPLv2+
	  * Fix copy/paste error about config files
	  * Added filters for Fedora and RHEL

2011-01-26  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add Httpd lens
	The Httpd lens parses Apache Web server configuration according to the manual.

	  * Generic sections with square lens
	  * Generic directives
	  * Arguments of sections and directives are handled as list

	The lens doesn't support automatic quoting of string values, because arguments
	are separated by spaces and it raises ambiguity when using unquoting. The lens
	doesn't support either long lines splitted by backslash.

2011-01-26  David Lutterkort  <lutter@redhat.com>

	* src/pathx.c (store_error): make sure pos_str is always NUL terminated
	Fixes bug #178

2011-01-20  Fred  <frederic.lespez@free.fr>

	PuppetFileserver: new lens for Puppet's fileserver.conf

2011-01-20  David Lutterkort  <lutter@redhat.com>

	* man/augtool.pod: fix typos
	Fixes https://bugzilla.redhat.com/show_bug.cgi?id=628502

2011-01-15  David Lutterkort  <lutter@redhat.com>

	Allow compiling with NDEBUG defined
	  * src/errcode.h (ensure0): do not mention 'error' label when NDEBUG is
	    defined
	  * src/pathx.c (coerce_to_bool, eval_pred): make sure we return something
	    when assert(0) is compiled away

2011-01-14  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix a small bashism from test script

2011-01-14  David Lutterkort  <lutter@redhat.com>

	Xorg: "position" in "screen" section is optional; allow "Extensions" section
	Patch by omzzk

	Fixes bug #175

2011-01-12  David Lutterkort  <lutter@redhat.com>

	Replace augtest by test-augtool.sh
	This removes the silly dependency on Ruby, since augtest was the only
	Ruby script in the whole source tree.

	The test files for test-augtool.sh live in tests/test-augtool, and are
	functionally identical to the Ruby test files tests/*.rb. The only
	exception is that test-root.rb has been removed - it tested something that
	is better tested in test-xpath.c

	The new test-augtool.sh test is also a little more efficient in that it
	only copies the file needed by a test into the root, and only sets the lens
	for that file up for loading. This reduces the runtime of the tests from ~
	30s on my machine to under 2s.

2011-01-12  David Lutterkort  <lutter@redhat.com>

	Test that getting and setting the root node works
	This tests the same thing that test-get.sh tests, but in a much more
	reliable fashion

	* src/pathx.c (store_error): never append to an uninitialized string

	* src/augtool.c: be a little more quiet
	Some of the commands used to print unconditionally; we now only print if we
	should be echoing (i.e., if --echo is given on the command line or if stdin
	is a tty)

2011-01-12  Fred  <frederic.lespez@free.fr>

	Crypttab: new lens for /etc/crypttab

2011-01-11  Raphaël Pinson  <raphink@gmail.com>

	In autosave mode, print "save" when in echo or interactive mode. Remove comma at the end of enum list.

	Refactor augtool.c to use only readline

2011-01-11  Raphaël Pinson  <raphink@gmail.com>

	augtool: add --autosave option
	Additional changes to augtool:
	  * Define AUGTOOL_PROMPT as a constant
	  * Do not print (null) lines when using --echo
	  * Add test for --autosave in test-save-mode.sh

	Fixes ticket #172

2011-01-08  David Lutterkort  <lutter@redhat.com>

	bootstrap: add sys_wait module
	Fixes bug #164

2011-01-08  Dominic Cleal  <dcleal@redhat.com>

	Add support for Solaris multiboot kernels with slashes in the first kernel argument (Fix ticket #158)

	Allow kernel$ and module$ extensions to GRUB for Solaris (Fix ticket #158)

2011-01-08  David Lutterkort  <lutter@redhat.com>

	Shellvars: read various snmpd config files
	Patch by erinn

	Fixes ticket #170

2011-01-08  Dominic Cleal  <dcleal@redhat.com>

	Solaris_system: new lens for /etc/system (Solaris)
	File is used to configure the kernel, module loading and parameters. The
	system(4) man page gives a good overview of the commands and a sample file:
	http://docs.sun.com/app/docs/doc/816-5174/system-4?l=en&n=1&a=view

	It supports moddir, rootdev, rootfs, exclude, include, forceload and set.
	The set tree is broken down quite a lot as the operator can vary (equals,
	bitwise AND and OR).

2011-01-08  David Lutterkort  <lutter@redhat.com>

	Resolv: allow comments starting with semicolon
	Patch by erinn

	Fixes bug #173

2011-01-04  Raphaël Pinson  <raphink@gmail.com>

	Add automount, netmasks and sendmailvars keywords for databases in nsswitch.aug

	Add bootparams as database keyword (Fix ticket #171) Update test file accordingly

2010-12-30  Raphaël Pinson  <raphink@gmail.com>

	Rename "host" nodes as "origin" (breaks compatibility) Implement "except" keyword as a subtree Make origin_re less strict to fix comment #6 in ticket #166 Implement multiple users and netgroups Improve test file

2010-12-29  Francis Giraldeau  <francis.giraldeau@usherbrooke.ca>

	Add xml lens
	The XML lens parse arbitrary XML documents. Most, but not all features of XML
	standard are implemented, partially because the nature of augeas. Tests comes
	from OASIS test suite.

	Supported:
	  * Document type declaration: elements, attlist, entity
	  * XML Prolog
	  * XML comments
	  * XML processing instructions
	  * Neested elements, including empty elements
	  * Element attributes
	  * Mixed content, text and elements
	  * CDATA sections

	Not supported:
	  * Single quotes attributes: double quotes is mandatory
	  * External entity reference, because augeas can't load a related file within a lens
	  * Document validation: augeas don't enforce DTD

	This lens doesn't respect the PutGet law, becuse of an ambiguity in union.put
	with text nodes. If a text node is created as a sibling of another text node, a
	put and a get will merge those two nodes. In practice, no error occur and this
	is a desirable behavior.

2010-12-22  Raphaël Pinson  <raphink@gmail.com>

	Fix ticket #169 and add unit tests by Sergio Ballestrero.

2010-12-21  David Lutterkort  <lutter@redhat.com>

	* src/pathx.c (func_regexp): do not SEGV on error; provide better error msg
	Fixes bug 168

	  * when the passed in regexp had a syntax error, we would leave the
	    interpreter variable at VIND uninitialised, but tagged as a regexp. As
	    a result, we'd SEGV when that slot in the variable table is
	    freed. Properly initialize slots in the variable table to NULL, and
	    store the regexp as soon as it has been built (before compilation)
	    there to address that.
	  * when a regexp had a syntax error, we would just drop the details of the
	    syntax error on the floor. We now include that in the error details so
	    that the user has some hint to how the regexp is foobared

	# Please enter the commit message for your changes. Lines starting
	# with '#' will be ignored, and an empty message aborts the commit.
	# On branch master
	# Changes to be committed:
	#   (use "git reset HEAD <file>..." to unstage)
	#
	#	modified:   src/pathx.c
	#
	# Untracked files:
	#   (use "git add <file>..." to include in what will be committed)
	#
	#	doc/cfg.txt
	#	doc/naturaldocs/conf/lenses/Menu_Backup.txt
	#	doc/naturaldocs/conf/lenses/Menu_Backup_2.txt
	#	p/
	#	site.orig/
	#	tests/root-small/
	#	tests/root/etc/network/
	#	tests/root/etc/samba/
	#	tests/root/etc/sysconfig/system-config-firewall

2010-12-11  Francis Giraldeau  <francis.giraldeau@usherbrooke.ca>

	Enable square lens in dump_lens

2010-12-11  Francis Giraldeau  <francis.giraldeau@usherbrooke.ca>

	Add square lens to language
	The new primitive square lens allows to handle XML like open and close tags.
	It takes 2 arguments, a regexp for the tag and a lens for the content. The
	square lens verify that open and close tags are matched in the get direction,
	and put direction handles the close tag by copying the key.

	  * src/builtin.c: add "square" keyword to language
	  * src/lens.c: lns_make_square to compile the lens from actual simpler
	    lenses
	  * src/lens.h: append L_SQUARE to lens_tag enum to identify the square lens
	    type object
	  * src/jmt.c: handle square lens in parser
	  * src/get.c: add char* square to state struct to hold the last L_DEL in
	    square to perform syntax check, and add all get handling functions for
	    L_SQUARE
	  * src/put.c: modify create_del to render current key when default string is
	    NULL and add all put handling functions
	  * tests/modules/pass_square.aug: unit tests to validate the square lens,
	    regular and recursives

2010-12-10  Francis Giraldeau  <francis.giraldeau@usherbrooke.ca>

	Add test for lens-access.sh in Makefile

2010-12-02  Raphaël Pinson  <raphink@gmail.com>

	Relicense pg_hba.aug as LGPLv2+ as the rest of Augeas.

2010-12-02  Lorenzo Dalrio  <lorenzo.dalrio@gmail.com>

	Add access.aug and associated test file

2010-12-02  Raphaël Pinson  <raphink@gmail.com>

	Fix GPL into LGPLv2+ for a series of lenses.

2010-11-25  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Ignore eclipse project files

2010-11-23  Raphael Pinson  <raphink@gmail.com>

	Add support for "map" entries in grub.aug and adapt test accordingly (Fix ticket #148)

2010-11-20  David Lutterkort  <lutter@redhat.com>

	Version 0.7.4

2010-11-20  Raphaël Pinson  <raphink@gmail.com>

	* lenses/util.aug: improve management of eol comments
	  - add comment_generic
	  - use comment_generic in comment
	  - add comment_eol
	  - add comment_or_eol

	Use comment_eol and comment_or_eol in some lenses to fix default eol
	comment entries.  Adapt tests for shellvars and services to take this new
	behaviour in consideration.

2010-11-19  Raphaël Pinson  <raphink@gmail.com>

	Add "indomU" Debian setting to grub.aug (Fix ticket #162)

	Allow "\" style newlines in syslog.aug and add corresponding test (Fix ticket #161).

2010-11-19  Raphael Pinson  <raphink@gmail.com>

	Make filter a View in sudoers.aug to make it appear properly in doc

	Improve doc on services.aug

	Add some doc to pg_hba.aug

	Add a bit of doc to pbuilder.aug

	Add all missing lenses to Menu.txt

2010-11-19  Mathieu Arnold  <mat@FreeBSD.org>

	Add syslog.aug and associated test file

2010-11-19  Raphaël Pinson  <raphink@gmail.com>

	resolve refresh_pattern into fields Parse "extension_methods" into a list break entries upgrade_http0.9 and broken_vary_encoding down similar to what http_access does
	Fix ticket #46

2010-11-19  Mathieu Arnold  <mat@FreeBSD.org>

	On FreeBSD (at least) the sudoers file is in /usr/local/etc/.

2010-11-18  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Parse ulimit builtin in shellvars.aug (fix ticket #73).

	Accept double quotes in arguments in postfix_master.aug, fix bug# 69

2010-11-18  David Lutterkort  <lutter@redhat.com>

	* tests/Makefile.am (lens_tests): add tests for new lenses

2010-11-18  David Lutterkort  <lutter@redhat.com>

	Krb5 (realm_re, app_re): allow digits in realm names
	Still makes the incorrect assumption that realm names start with an upper
	case letter, and app names with a lower case one, but it's an improvement
	over the current restrictions.

	Fixes bug https://fedorahosted.org/augeas/ticket/139

2010-11-18  Matthew Booth  <mbooth@redhat.com>

	Fix crasher in ast.c:dict_pos on i686 with gcc 4.5 and -O2
	This patch works around what appears to be an optimization bug in gcc 4.5. The
	symptom of the bug is that dict_pos, called from dict_lookup, receives an
	invalid value when accessing dict->used. The following ticket describes the bug,
	and includes a simple test case:

	https://fedorahosted.org/augeas/ticket/149

	Adding a printf to dict_lookup immediately before the dict_pos call reveals that
	dict->used has a value of 30 in the crashing case on my F14 system. A printf
	added to the first line of dict_pos shows dict->used has an apparent value of
	16777246. This causes an invalid array lookup shortly afterwards, which causes
	the crash. 16777246, interestingly, is 2^24 + 30, where 24 is the size of the
	dict->used bitfield. This should obviously not be possible, suggesting either a
	compiler bug or undefined behaviour due in incorrect use of the language. Having
	re-read the relevant section of K&R, I can't see anything about this use of
	bitfields which might be a problem, except that: 'Fields may be declared only as
	ints; for portability, specify signed or unsigned explicitly.' uint32_t resolves
	to 'unsigned int' on i686, and in any case, replacing it with 'unsigned int'
	does not solve the problem. As it stands, I believe this is a bug in the
	optimizer.

	The above ticket contains an alternate patch which copies dict in dict_pos,
	which also prevents the crash. However, adding anything to dict_pos which
	prevents the compiler from optimising dict away achieves the same result. For
	example:

	printf("%p", dict);

	This patch instead removes the bitfields in struct dict. While this is a
	workaround, these bitfields save at most 1 word of memory per struct, but at the
	cost of mis-aligned access. The patch does not increase the size of
	dict_max_size to UINT32_MAX, as the lower maximum serves as a better guard
	against runaway memory allocation.

2010-11-18  Raphael Pinson  <raphink@gmail.com>

	Allow underscore in chain_name for iptables.aug and adjust test accordingly.

2010-11-18  Erinn Looney-Triggs  <erinn.looneytriggs@gmail.com>

	Add login_defs.aug and associated test file.

2010-11-15  Marc Fournier  <marc.fournier@camptocamp.com>

	pg_hba: added debian systems path to filter - fixes #154.

	util.aug: exclude unneeded files on debian systems (fix ticket #153)

2010-11-06  Raphael Pinson  <raphink@gmail.com>

	Map comments and use Util.comment and Util.empty in order to full fix ticket #151. Adapt test accordingly.

	Allow indented lines in aptsources.aug (Fix ticket #151) and add associated test

	Allow "=" as a separator for title in grub.aug (Fix ticket #150) and adapt test accordingly.

2010-11-05  Raphael Pinson  <raphink@gmail.com>

	Fix example in lens

2010-11-03  Raphael Pinson  <raphink@gmail.com>

	Add a few lenses to Menu.txt

	Add shells.aug and associated test

2010-11-01  Raphael Pinson  <raphink@gmail.com>

	Add mke2fs.aug and associated test

	Add support for rpc services in inetd.aug, rework lens to allow it and add tests accordingly.

	Parse option values in fstab.aug, adapt test file accordingly.

	Map service names in node values instead of node names to prevent variable node names.

2010-10-30  Raphael Pinson  <raphink@gmail.com>

	Add /etc/mtab to known files

2010-10-29  Raphael Pinson  <raphink@gmail.com>

	Fix paramater into parameter in ND comment

2010-10-27  Raphael Pinson  <raphink@gmail.com>

	Use generic modules in bbhosts.aug

2010-10-27  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fixes bug #144: wrong behavior of iter concat
	This patch fix the list_tail_cons macro to fastforward the tail list when
	the first item is added to the list, otherwise if the first item added when
	the list is NULL has two item, the tail points the the first item.

2010-10-27  Raphael Pinson  <raphink@gmail.com>

	Fix filter to use proper file

	Remove trailing whitespace

	Add nsswitch.aug and associated test

2010-10-27  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add debugging information about lens hierarchy
	When compiled with --enable-debug, will compile a function to output the lens
	hierarchy in dot files. Enable this specific debug info with
	AUGEAS_DEBUG=lenses

2010-10-27  David Lutterkort  <lutter@redhat.com>

	Sudoers: allow 'visiblepw' parameter flag
	Fix provided by christj. Fixes bug #143

2010-10-27  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Add clearm command to augtool
	The clearm command is the same as setm, but sets the node value to
	NULL in place of a string, suitable in some use case.

	Fix ticket #146

2010-10-27  Raphael Pinson  <raphink@gmail.com>

	/etc/sudoers.d is now supported (at least in Debian and Ubuntu)

	Add resolv.aug and test

2010-10-15  Aurelien Bompard  <aurelien@bompard.org>

	Pg_hba: new lens and test
	Fixes bug #140

2010-10-01  Raphaël Pinson  <raphink@gmail.com>

	Add a few lenses to Menu.txt

	Use Rx.ipv4 and Rx.integer in openvpn.aug

	Use generic modules Rx, Sep and Build in keepalived.aug

	Add email_addr to rx.aug

	Improve build.aug

	Improve documentation of build.aug

2010-09-30  Raphaël Pinson  <raphink@gmail.com>

	Move Build, Rx and Sep into Generic Modules, add Keepalived

2010-09-24  Raphaël Pinson  <raphink@gmail.com>

	Improve keepalived.aug

	Add a lens for keepalived.conf and associated test

2010-09-24  David Lutterkort  <lutter@redhat.com>

	Preserve parse errors under /augeas//error
	With the changes in commit 5ee81630, a subtree in /augeas/files that is
	dirty after trying to load all files indicates a file that was loaded
	before, but is not loaded anymore (e.g., because the set of lenses changed
	since the last time we loaded) In that situation, both the subtree in
	/augeas/files as well as the corresponding subtree in /files is deleted.

	The code in store_error, which is called by load_file when a parse error
	happens, would leave that subtree in /augeas/files dirty. This commit fixes
	that by making sure we mark the error entries as clean. It also revamps
	store_error to use the lighter-weight tree_xxx functions instead of the
	aug_xxx functions.

	Fixes bug #138

2010-09-22  Raphaël Pinson  <raphink@gmail.com>

	* src/augtool.c: add -f|--file option to get commands from an input file

2010-09-22  Marc Fournier  <marc.fournier@camptocamp.com>

	Nrpe: new lens and tests.

	Odbc: new lens and tests.

2010-09-16  David Lutterkort  <lutter@redhat.com>

	When setting a tree node to the value it already has, do not modify the tree

2010-09-10  David Lutterkort  <lutter@redhat.com>

	* src/try: add an optioj to strace augtool

2010-09-10  David Lutterkort  <lutter@redhat.com>

	Properly record the new mtime of a saved file in the tree
	transform_save used to pass an incorrect file name to add_file_info (the
	name was missing the root prefix), leading to an mitme of 0 for all saved
	files. That in turn causes freshly saved files to be unnecessarily reloaded
	on the next aug_load.

	  * src/transform.c (mtime_as_string): tolerate a NULL filename, and return
	    an mtime of 0; (transform_save): pass the full file name, including the
	    root to add_file_info
	  * tests/test-load.c (testReloadDeletedMeta): the test is now
	    time-sensitive; to work around that, set the mtime of the changed tree
	    to the original mtime of the file
	  * tests/test-save.c (testMtime): verify that we record the actual mtime
	    and not just 0 in the tree after a save.

	Thanks to Laine Stump for spotting this

2010-08-28  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Fix yum tests
	  * Modify separator for list values to accept simple spaces
	  * Add all alternatives for baseurl and gpgkey
	  * Add tests to verify the correct behavior

2010-08-28  David Lutterkort  <lutter@redhat.com>

	* bootstrap: add locale module from gnulib
	Fixes bug #137

2010-08-17  David Lutterkort  <lutter@redhat.com>

	Yum: accept continuation lines for gpgkey
	Fixes bug #132

2010-08-17  Francis Giraldeau  <francis.giraldeau@gmail.com>

	* src/get.c (visit_exit): fix segfault from empty stack for L_MAYBE
	Fixes bug #136

2010-08-07  David Lutterkort  <lutter@redhat.com>

	Version 0.7.3

2010-08-07  David Lutterkort  <lutter@redhat.com>

	Fix behavior of aug_defnode
	  (1) Make sure that the definition of the variable is recorded under
	      /augeas/variables
	  (2) Do not report an error if the expression evaluates to a non-empty
	      nodeset

	  * src/augeas.c (aug_defvar): split creating metadata under
	    /augeas/variables into record_var_meta; (aug_defnode): do not return an
	    error when expr evaluates to nonempty node set; record variable
	    definition
	  * tests/test-api.c: add tests for defvar and defnode behavior

2010-08-06  David Lutterkort  <lutter@redhat.com>

	Use pathx_aug_parse rather than pathx_parse in various places
	Since pathx_aug_parse makes sure the symbol table stays updated, use
	pathx_aug_parse whereever that makes sense.

	Rename parse_user_pathx to pathx_aug_parse
	  * internal.h (pathx_aug_parse): new protoype
	  * augeas.c (pathx_aug_parse): renamed, add optional arg for a different
	    root

2010-08-06  David Lutterkort  <lutter@redhat.com>

	Fix BZ 613967 - memory corruption on reloading externally modified file
	The problem was that when we replaced the old tree for a file with the new
	one we just read from the file, the replace operation did not update
	nodesets in variables, since we did not pass the global symtab into
	tree_replace.

	  * src/internal.h (tree_replace): pass in struct augeas, so that we have
	    access to the global symtab
	  * src/augeas.c (tree_replace): make sure we create the pathx with the
	    global symtab
	  * src/transform.c (load_file): adapt to new prototype for tree_replace
	  * tests/test-load.c (testReloadExternalMod): test that we do not segfault
	    when a file was modified externally

2010-08-06  David Lutterkort  <lutter@redhat.com>

	Test root: mimick the setup of grub config files on Fedora more closely
	  * root/etc/grub.conf: symlink to root/boot/grub/grub.conf
	  * root/boot/grub/grub.conf: new file with contents of /etc/grub.conf
	  * root/boot/grub/menu.lst: symlink to grub.conf

2010-08-04  Raphael Pinson  <raphink@gmail.com>

	Sudoers: allow escaped spaces in user/group names
	Fixes bug #124

2010-07-27  David Lutterkort  <lutter@redhat.com>

	Limits: also look for files in /etc/security/limits.d
	Suggested by David Timms

2010-07-24  Tim Stoop  <tim.stoop@gmail.com>

	Mysql: lens for MySQL's *.cnf files

2010-07-24  David Lutterkort  <lutter@redhat.com>

	Sysconfig: new lens for a subdialect of shell
	Using shell files with simple variable assignments is a very popular config
	file format. The Shellvars lens doesn't serve those files perfectly well,
	since it tries to preserve details important for general shell scripts that
	are ignored by sysconfig files.

	This lens is a variation on Shellvars that changes a few important aspects
	of it:

	  * Strip quotes from values when reading a file, and restore quotes as
	    needed upon writing
	  * Pretend there's no difference between single and double quotes (this
	    assumption makes it possible to add quotes as needed solely based on
	    syntax)
	  * Do not support shell arrays or backticks; support for these could be
	    restored by somebody sufficiently motivated, though neither of them
	    should be used in a sysconfig file

	The lens doesn't autoload any files yet, though we should consider moving
	most of the files that Shellvars loads over to this lens.

2010-07-24  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (lns_check_rec): allow 'let rec' with regular RHS
	If the user writes 'let rec l = rhs' and the RHS does not mention l, just
	mark the lens as regular and carry on.

2010-07-22  David Lutterkort  <lutter@redhat.com>

	* src/syntax.c (load_module_file): make sure we report an error

2010-07-22  David Lutterkort  <lutter@redhat.com>

	Fix segfault in glue routines; add test for the fix
	The tree_*_glue functions did not set the error struct when parsing a path;
	this caused a segfault when trying to insert before/after a non-existant
	node, since tree_insert tried to report the error into a struct error that
	was NULL.

	Fixes bug #129

2010-07-22  David Lutterkort  <lutter@redhat.com>

	* src/syntax.c (compile_test): reset errors at the end of the test
	Otherwise, we can't have tests succeed after tests failed intentionally (by
	making their result '= *')

	* src/errcode.h (reset_error): new function
	  * src/augeas.c (api_entry): use reset_error
	  * src/errcode.c (reset_error): new function, with code from api_entry
	  * src/errcode.h (reset_error): add prototype

2010-07-21  Francis Giraldeau  <francis.giraldeau@gmail.com>

	* src/put.c (split_concat): fix memory leak when split doesn't match

2010-07-20  David Lutterkort  <lutter@redhat.com>

	Use gnulib from a submodule
	This allows us to record the exact changeset from gnulib that everybody
	should be using.

2010-07-20  Frederik Wagner  <fnerdwq@googlemail.com>

	Added /etc/sysconfig/suseconfig to shellvars lens.

2010-07-09  Francis Giraldeau  <francis.giraldeau@gmail.com>

	Adding is_scan in the condition to accept an item

2010-07-01  Matthew Booth  <mbooth@redhat.com>

	Device_map: new lens for grub's device.map

2010-06-30  David Lutterkort  <lutter@redhat.com>

	Avoid unnecessary file parsing when reloading the tree
	We used to reparse every file we knew about upon aug_load. Now, we only
	reparse files if the file has changed on disk.

	We test a few scenarios to make sure aug_load retains its behavior of
	obliterating the tree and filling it with the latest from disk. This
	includes throwing away unsaved changes or trees that have been deleted.

2010-06-30  David Lutterkort  <lutter@redhat.com>

	Add utility tree_store_value to avoid unnecessary strdup's
	  * src/internal.h (tree_store_value): add prototype
	  * src/augeas.c (tree_store_value): new function; (tree_set_value): use
	    tree_store_value

	Make tree_clean available outside of augeas.c
	  * src/augeas.c (tree_clean): remove 'static'
	  * src/internal.h (tree_clean): add prototype

2010-06-30  David Lutterkort  <lutter@redhat.com>

	Add xstrtoint64 to internal.[ch]
	The implementation is directly from libvirt

	  * src/internal.h (xstrtoint64): add prototype
	  * src/internal.c (xstrtoint64): add impl

2010-06-30  David Lutterkort  <lutter@redhat.com>

	* src/test-load.c (testLoadSave): work off a writable /etc/hosts
	This addresses a FIXME that could lead to use not detecting incorrect behavior

	Move 'run' test utility to cutest.[ch]
	  * tests/cutest.h (run): add prototype
	  * tests/cutest.c (run): add impl
	  * tests/test-save.c (run): remove

2010-06-30  David Lutterkort  <lutter@redhat.com>

	Redefine all variables upon load
	This is a slight change in behavior: before, we used to just discard the
	contents of all variables upon load. Now, we redefine variables by
	evaluating the expression with which they were defined initially again.

	The change in behavior is backwards compatible, since at worst, users will
	redefine variables themselves after an aug_load

2010-06-30  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c (aug_init): create /augeas/variables on startup

	* src/augeas.c (aug_defvar): use constants to create /augeas/variables

2010-06-23  David Lutterkort  <lutter@redhat.com>

	Version 0.7.2

	* augeas.spec.in: fix ownership of /usr/share/augeas
	fixes BZ 569393

2010-06-17  David Lutterkort  <lutter@redhat.com>

	Test behavior of aug_setm
	  * src/augeas.c (aug_setm): return number of modified nodes
	  * tests/test-api.c (testSetM): compliance tests for aug_setm

	* src/augeas.c (aug_setm): do not segfault when sub is NULL

2010-06-17  Frederik Wagner  <fnerdwq@gmail.com>

	Tests for new aug_setm function
	Test through augtool calls.

	Exposed aug_setm to augtool.

2010-06-17  David Lutterkort  <lutter@redhat.com>

	Add aug_setm to API
	  * src/augeas.h (aug_setm): new public API call
	  * src/augeas.c (aug_setm): implement setting multiple nodes
	  * src/augeas_sym.version: export symbol aug_setm

2010-05-24  Frederik Wagner  <fnerdwq@googlemail.com>

	Shellvars: added SuSE sysconfig puppet files
	For SuSE systems, added /etc/sysconfig/{puppet,puppetmaster} to lens.

2010-05-19  Frederik Wagner  <fnerdwq@googlemail.com>

	List handling shellvars_list lens added.
	Lens shellvars_list has been added to treat variables in specific files
	as lists of words, e.g. in /etc/sysconfig/ 'kernel' and 'bootloader'.

	* lenses/shellvars.aug: removed include for /etc/sysconfig/kernel
	* lenses/shellvars_array.aug: new lens
	* lenses/tests/test_shellvars_array.aug: test for new lens

2010-05-14  David Lutterkort  <lutter@redhat.com>

	Add modules_conf to naturaldocs Menu

	Add /etc/modules.conf from hell
	Actually, from http://www.janerob.com/rob/ts5100/modules.conf

2010-05-14  Matthew Booth  <mbooth@redhat.com>

	Modules_conf: new lens for modules.conf and conf.modules

	Modprobe: Refactor to make re-use easier

2010-05-12  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c: record expression for defvar in /augeas/variables

2010-05-08  David Lutterkort  <lutter@redhat.com>

	* Grub: handle comments within a boot stanza
	Fixes RH BZ 590067

	Adjust copyright notices
	  - copyright is from creation of file through 2010
	  - adjust copyright owner according to Red Hat's policy

2010-05-05  Raphael Pinson  <raphink@gmail.com>

	Group: add test for disabled account ('!' in password field)

2010-04-27  seph  <seph@directionless.org>

	Shellvars: process /etc/environment

2010-04-26  Nicolas Valc�rcel Scerpella  <nvalcarcel@ubuntu.com>

	Iptables: also look for /etc/iptables-save
	This is where Debian keeps iptables rules

2010-04-26  Frederik Wagner  <fnerdwq@googlemail.com>

	securetty: added handling of emtpy lines/comments
	* lenses/securetty.aug:
	        added handling of comments and empty lines
	* lenses/tests/test_securetty.aug:
	        added test for enhanced lens

2010-04-22  David Lutterkort  <lutter@redhat.com>

	Version 0.7.1

2010-04-22  Simon Josi  <josi@puzzle.ch>

	Securetty: new lens and test for /etc/securetty

2010-04-22  David Lutterkort  <lutter@redhat.com>

	Sudoers: use example file from Fedora 13
	This is causing trouble with release-0.7.0, but not this revision.

	File was reported in bug #122

2010-04-22  David Lutterkort  <lutter@redhat.com>

	tests: make most tests work on Solaris
	The test scripts are full of bashisms; removed some of them, though for
	most, just changed the shell from /bin/sh to /bin/bash; removing bashisms
	will need to be addressed.

	Tests now mostly pass (82/85) on the OpenCSW Solaris 5.10 build machine

2010-04-22  David Lutterkort  <lutter@redhat.com>

	* tests/test-save.c: use proper includes for WIFEXITED
	Without them, the build fails on FreeBSD

2010-04-21  David Lutterkort  <lutter@redhat.com>

	Debctrl (multi_line_entry): fix bad regexp
	The lens 'del /^ / " "' is not valid, since we do not allow '^' as a meta
	character. Changing that to 'del / / " "' exposed a typecheck problem in
	lns: both multi_line_entry and eol match blank lines. Fixed this by
	requiring that a multi_line_entry has to have at least one non-blank
	character.

	Debctrl: whitespace cleanup, no functional change

2010-04-21  David Lutterkort  <lutter@redhat.com>

	* src/fa.c (re_iter_as_string): escape literal '|'
	When turning a FA back to a string, a literal '|' needs to be output as '\|'

	  * tests/fatest.c (testExpandCharRanges): test escaping of literal '|'

2010-04-20  David Lutterkort  <lutter@redhat.com>

	* tests/fatest.c (print_regerror): do not use alloca

	* bootstrap: pull in isblank explicitly
	Fixes bug #111

	* src/lens.c (lns_check_rec): fix refcounting mistake on error path
	Fixes bug #120

	* src/augtool.c: report an error when 'get' fails

2010-04-20  David Lutterkort  <lutter@redhat.com>

	aug_get: return -1 when multiple nodes match
	This fixes breakage in the API contract for aug_get, introduced in commit
	e80494a6. Also adds a test to ensure we do not break API for aug_get again.

	Fixes bug #121

2010-04-17  David Lutterkort  <lutter@redhat.com>

	jmt: distinguish between successful parse and syntax error at end of input
	If a syntax error happened after the last character of the input string
	(e.g., becuase the input was incomplete), rec_process would think the parse
	was successful, and then notice that there was no parse result. That would
	lead to an incorrect error message hinting at an internal error, when it
	was really a syntax error.

	By changing the return value for jmt_visit, it's now possible to
	distinguish between internal errors, syntax errors and successful parses
	properly.

2010-04-17  David Lutterkort  <lutter@redhat.com>

	* src/get.c (visit_exit): handle L_MAYBE
	Added test to tests/modules/pass_simple_recursion.aug, lens 'maybe'

	Fixes bug #119

2010-04-17  David Lutterkort  <lutter@redhat.com>

	* src/jmt.c (build_tree): print debug output for build_nullable

2010-03-13  David Lutterkort  <lutter@redhat.com>

	* lenses/tests/test_logrotate.aug: add test for files separated by newlines
	This test the fix for bug #104, commit fe0453ce.

2010-03-12  David Lutterkort  <lutter@redhat.com>

	* lenses/group.aug (password): remove backslashes
	Backslashes in char classes are taken literally, they do not escape a
	character.

2010-03-12  root  <root@lx200.costest.lrz.de>

	Group: Added disabled password support
	* lenses/group.aug: '*' and '!' are allowed chars for disabled password
	* lenses/tests/test_group.aug: added test for lens change

2010-03-12  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (lns_check_rec): avoid use of uninitialized 'result'
	The ensures can fail, and we check whether result is NULL in the error
	path.

2010-03-06  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (lns_format_atype): format L_REC lenses

	* src/lens.c: remove asserts; better error for missed tag in switch

	Shellvars: handle a bare 'export VAR'

	Inittab: allow ':' in the process field
	Fixes part of bug #109

2010-03-06  Tim Stoop  <tim.stoop@gmail.com>

	Approx: allow keywords starting with '$'

2010-03-05  David Lutterkort  <lutter@redhat.com>

	Approx: lens and test for the approx proxy server

	Produce a better error when iteration stops prematurely during put/create
	We now try to include the name of the child node that caused us to stop in
	the error message.

2010-03-04  David Lutterkort  <lutter@redhat.com>

	* src/fa.c: allow the strange regexp syntax '(a|)'
	POSIX allows it, and so do we now

	Fixes bug #113

2010-03-03  David Lutterkort  <lutter@redhat.com>

	Passwd: parse NIS entries on Solaris
	Based on a fix by Stuart Sears

2010-02-27  David Lutterkort  <lutter@redhat.com>

	* src/fa.c: clean up error macros
	The error macros _E, _F, and _N use names reserved for system libraries;
	this leads to compile errors at least on Solaris (as reported by lanky).

	Rename _E and _F to E and F, and eliminate _N.

2010-02-27  Frederik Wagner  <wagner@lrz.de>

	Modprobe: Suse includes
	* lenses/modprobe.aug: included /etc/modprobe.conf.local

	Shellvars: Suse includes
	* lenses/shellvars.aug:
	    added include for /etc/sysconfig/network/ifcfg-

	Grub: support empty kernel parameters, Suse incl.s
	* lenses/grub.aug:
	  - added support for kernel parameters of the form "parameter="
	    w/o given value
	  - included /boot/grub/menu.lst
	  - changed default for delimiter in kw_menu_arg to " "
	* lenses/tests/test_grub.aug: changes corresponding to lens change

2010-02-27  Dominique Dumont  <domi.dumont@free.fr>

	Debctrl: new lens and test

2010-02-24  David Lutterkort  <lutter@redhat.com>

	Ntp: add 'tinker' directive
	Fixes bug #103

	Logrotate: tolerate whitespace at the end of a line
	Fixes bug #101

2010-02-24  Raphael Pinson  <raphink@gmail.com>

	Dhclient: add rfc code parsing
	Fixes bug #107

	Sudoers: allow del_negate even if no negate_node is found
	Fixes bug #106

	Logrotate: files can be separated by newlines
	Fixes bug #104

	Dput: add 'allow_dcut' parameter
	Fixes bug #105

2010-02-23  David Lutterkort  <lutter@redhat.com>

	* src/augtool.c: ignore empty lines from stdin
	We still complain about the nonsensical 'augtool ""'.

	Fixes BZ 566844 reported by Mike Burns

2010-02-23  Stuart Sears  <ssears@redhat.com>

	Sudoers (parameter_string_nobool_kw): accept "secure_path "
	Fixes BX 566134

2010-02-20  Tim Stoop  <tim.stoop@gmail.com>

	Nagisocfg: lens and test for /etc/nagios3/nagios.cfg

2010-02-13  Ivana Hutarova Varekova  <varekova@redhat.com>

	Cgrules: new lens and test
	See cgrules.conf for http://libcg.sourceforge.net/

2010-02-12  Ivana Hutarova Varekova  <varekova@redhat.com>

	Cgconfig: lens and tests for libcgroup config
	See http://libcg.sourceforge.net/

2010-02-12  Laine Stump  <laine@laine.org>

	* src/transform.c (file_info): fix memory leak

2010-02-10  David Lutterkort  <lutter@redhat.com>

	* lens.c (ambig_check): pretty print tree type errors
	Instead of dumping raw regular expressions for the tree encoding, print out
	something resembling our tree notation.

2010-02-09  David Lutterkort  <lutter@redhat.com>

	libfa: handle the syntax r{min,} properly
	  * src/fa.c (parse_repeated_regexp): set max = -1 when we see r{min,};
	    (re_iter_as_string): when max == -1, print r{min,}
	  * tests/fatext.c (testExample): add a few tests for this syntax

	* src/fa.c (parse_int): flag not parsing anything as an error

2010-02-09  David Lutterkort  <lutter@redhat.com>

	* src/jmt.c: add caller filtering
	Caller filtering is needed to weed out seemingly ambiguous parse trees (see
	Section 5.3 of Jim/Mandelbaum's paper)

	Also adds two pathological lenses and tests to
	pass_simple_recursion.aug. Those tests fail without caller filtering.

2010-02-09  David Lutterkort  <lutter@redhat.com>

	* AUTHORS: reformatted

	* tests/Makefile.am: add test for cobblermodules.aug

2010-02-09  Shannon Hughes  <shughes@redhat.com>

	Cobblermodules: lens + tests for cobbler's modules.conf

2010-02-03  David Lutterkort  <lutter@redhat.com>

	Shellvars: allow spaces after/before opening/closing parens for array
	Bug reported by Doug Warner

2010-02-02  Matthew Palmer  <matt@anchor.net.au>

	Sshd: allow optional arguments in subsystem commands

2010-01-28  David Lutterkort  <lutter@redhat.com>

	* src/augeas.c (tree_replace): don't bother marking the new parent as dirty
	We call tree_rm on it earlier, which already marks it as dirty.

	This line also triggered a SEGV when sub == NULL; this happened, for
	example, when /etc/apt/preferences was an empty file.

	Bug reported by Matt Palmer

2010-01-28  David Lutterkort  <lutter@redhat.com>

	* src/get.c (no_match_error): initialize lname
	Otherwise, gcc complains about a possibly uninitialized value with -O2

2010-01-26  David Lutterkort  <lutter@redhat.com>

	Test for using a recursive lens inside other lenses

2010-01-26  David Lutterkort  <lutter@redhat.com>

	* src/get.c: handle recursive lenses that are not L_REC
	Since any lens that uses an L_REC is itself recursive, the distinction
	whether to use get_rec or get_lens can be made in lns_get

	rec_process will also build the jmt if it does not exist yet

	Fixes ticket #100

2010-01-26  David Lutterkort  <lutter@redhat.com>

	Properly handle lenses that use L_REC lenses
	In constructs involving a recursive lens, we need to take the body of the
	recursive lens into consideration. We avoid infinite recursion by stopping
	when we see an L_REC that is marked as rec_internal, since that's the
	struct lens that points back to the top of the lens from within it.

	jmt_build now expects to be handed a properly set up recursive lens, which
	means that for an L_REC both the internal and external instances have to
	exist and be connected

	  * src/lens.c (lns_check_rec): defer building the jmt until the end
	  * src/jmt.c: when building the jmt, consider L_REC as long as it's not
	    internal

2010-01-26  David Lutterkort  <lutter@redhat.com>

	* src/jmt.c (print_grammar): recurse into L_REC if they are not rec_internal

2010-01-26  David Lutterkort  <lutter@redhat.com>

	* src/jmt.c (jmt_visit): allow for toplevel lenses that are not L_REC
	To reconstruct the parse of a lens that is not L_REC, but uses L_REC,
	e.g. l* where l is L_REC, we can not assume any longer that the root of the
	parse tree has only one child. Consequently, we need to start
	reconstruction with listing all the children of the root node.

	Split build_tree into build_children (collects a list of child nodes) and
	build_tree which creates the tree for a nonterminal.

	To start reconstruction, we now start with collecting the list of children
	of the root of the parse tree; the Earley graph does not contain an item
	for that, which makes this operation slightly special.

2010-01-26  David Lutterkort  <lutter@redhat.com>

	* src/lens.c: propagate rec_internal in the body of an L_REC

	* src/lens.c: don't short-circuit typechecking for recursive lenses explicitly
	The typecheck helpers are all smart enough to not run checks when one of
	the types is NULL, as is the case for recursive lenses.

	* src/lens.h (struct lens): explain better how we handle recursive lenses

	* src/jmt.c (build_trace): allow passing in a NULL item

	* src/lens.c (tags): add name for value primitive

	* src/get.c: replace assert's by ensure's
	assert aborts, which a library shouldn't do

	* src/errcode.h (ensure0): convenience version of ensure

	* src/get.c (find_seq): properly report OOM, do not call abort

	Remove assert_error_at
	This function was dangerous, since it does not jump, and therefore users
	will continue doing what they were doing, even if an assertion failed. Use
	BUG_ON instead.

	* src/get.c (struct state): make info a pointer

2010-01-24  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (restrict_regexp): properly report OOM

2010-01-21  David Lutterkort  <lutter@redhat.com>

	Document the basics of building from git

2010-01-16  David Lutterkort  <lutter@redhat.com>

	* src/builtin.c: builtins for printing and inspecting lenses

	Add a unit type
	The literal '()' is the only member of the unit type. Composition is now
	allowed if the first expression is of type unit, i.e. '() ; something' is
	legal.

2010-01-16  David Lutterkort  <lutter@redhat.com>

	Language: allow '_' as an identifier that is never bound
	  The expression
	    let _ = something
	  will evaluate something and then immediately forget it

	  * src/lexer.l (LID): allow leading underscore
	  * src/syntax.c (bind, bind_type): do not bind '_'

2010-01-16  David Lutterkort  <lutter@redhat.com>

	New primitive lens 'value'
	In analogy to 'label', this lens allows setting the value of a tree node to
	a fixed string

2010-01-15  David Lutterkort  <lutter@redhat.com>

	Version 0.7.0

	Json: lens and tests for generic Json files

	Tests for recursive (context free) lenses

2010-01-15  David Lutterkort  <lutter@redhat.com>

	Syntax for recursive lenses
	Add a 'let rec' construct; the syntax should be considered experimental and
	might be changed to some other form of expressing recursion.

	With recursive lenses, we can't do the bottom-up typechecking that we do
	for regular lenses; we need to consider the whole lens at once. This is
	achieved by inserting a callback to lns_check_rec when we parse 'let rec
	ident = exp'.

	  * src/builtin.c (lns_check_rec_glue): new function
	  * src/lexer.l: new token LETREC
	  * src/parser.y: add syntax rule for LETREC and desugar it into a call to
	    lns_check_rec
	  * src/syntax.h: make free_term available, constant for name
	    of let_check_rec within the interpreter
	  * src/syntax.c (free_term): now extern, not static

2010-01-15  David Lutterkort  <lutter@redhat.com>

	* src/get.c (get_rec, parse_rec): get/parse for recursive lenses

	* src/put.c: put/create for recursive lenses

	Remember the jmt in the lens and free it when it is no loner needed

	Earley parser based on Jim/Mandelbaum's transducers

	Calculate if a lens's ctype is nullable

	Add a typechecker and constructor for recursive lenses
	  * src/lens.h (lns_make_rec, lns_check_rec): new functions
	  * src/lens.c (lns_make_rec, lns_check_rec): new functions

	Suppress buildtime typechecks for L_REC; propagate recursive flag

	* src/lens.c (free_lens): free recursive lenses

	* src/lens.h: add a recursive lens combinator

2010-01-15  David Lutterkort  <lutter@redhat.com>

	A simple debug facility
	Debugging is disabled by default. When configured with --enable-debug=yes,
	Augeas will look at runtime at the environment variable AUGEAS_DEBUG, which
	should contain a colon-separated list of categories. Besides printing
	various thigs on stdout, some debug output is also left in files in the
	directory set by the environment variable AUGEAS_DEBUG_DIR, e.g., dot
	graphs of various internal data structures.

	  * configure.ac: add --enable-debug option
	  * src/internal.h (debugging, debug_file): new functions
	  * src/internal.c (debugging, debug_file): new functions

2010-01-15  David Lutterkort  <lutter@redhat.com>

	struct error: add pointer back to struct augeas

	* src/errcode.h: more usable BUG_ON and BUG_FMT

	* src/lens.c (ambig_check): report OOM from fa_ambig_example

	* src/fa.c (fa_ambig_example): getting a NULL example is not an error

	* src/syntax.c (compile): give up after the first error
	We have no error recovery to speak off; if we keep going, we most of the
	time carpet-bomb the user with error messages that are simple follow-ons to
	the first error.

	* TODO: deleted, that list is in Trac now

	* src/fa.c (fa_intersect): initialize vars that could be used on error

	* src/fa.c (fa_as_regexp): convert strings more efficiently
	Since we are building the transitive closure of the FA, cut down the size
	of the FA by first extracting strings and removing their internal states.

	* src/fa.c (fa_as_regexp): fin only accepting state, no trans fin->fin

	Indicate whether an FA uses character ranges or regexps on transitions
	  * src/fa.c (struct fa): new field trans_re; (fa_as_regexp): set trans_re;
	    (fa_dot): print regexp rather than char range if trans_re is set

2010-01-14  David Lutterkort  <lutter@redhat.com>

	Add syntax for case-insensitive regexps
	A regexp literal /regexp/i will be converted to a case-insensitive regexp.

	* src/regexp.c (regexp_minus): respect nocase flags

	* src/lens.c (str_to_fa): compile nocase fa when needed

	* src/lens.c (str_to_fa): remove FIXME's and use proper error reporting

2010-01-14  David Lutterkort  <lutter@redhat.com>

	Support for case-insensitive regexps
	Add nocase argument to make_regexp, and adjust all uses of make_regexp to
	pass that in. For concatenation and union of regexps we have to expand
	case-insensitive regexps when they are mixed with case-sensitive regexps.

	Adjust all uses of make_regexp.

2010-01-14  David Lutterkort  <lutter@redhat.com>

	Add fa_expand_nocase to libfa

	Support for case-insensitive operations in libfa
	  * src/fa.h (fa_nocase, fa_is_nocase): new functions
	  * src/fa.c (struct fa): new field nocase; (fa_is_basic): a total FA has
	    two transitions under nocase; (fa_clone): preserve nocase flag;
	    (union_in_place, concat_in_place, fa_intersect): if one operand is
	    nocase, and the other isn't, expand the nocase FA to a case-sensitive
	    one; (totalize): do not add transitions on [A-Z]; (fa_nocase,
	    fa_is_nocase): new functions; (case_expand): new function
	  * tests/fatest.c (assertExample): also test against a nocase FA;
	    (testNoCase): test concat etc. on nocase FA's

	* src/lens.c (subtree_atype): new function

2010-01-08  David Lutterkort  <lutter@redhat.com>

	Facelift for augtool
	This makes augtool somewhat friendlier, mostly because

	  - help is organized better: typing 'help' produces a list of commands and
	    a brief synopsis for each, typing 'help command' prints detailed help
	    about a command
	  - augtool now knows about path expressions, so that they do not need to
	    be enclosed in quotes if they have spaces with predicates, e.g. you can
	    now type 'get /foo[ last() ]'

2010-01-08  David Lutterkort  <lutter@redhat.com>

	Record an error if more than one lens tries to load a file
	  * src/transform.c (file_info): new function; (transform_load): detect if
	    more than one lens tries to load a file and record error in
	    /augeas/files/PATH/error

	Pull computing a path underneath /files from a filename into a function
	  * src/transform.c (file_name_path): new function; (load_file): use
	    file_name_path

2010-01-08  David Lutterkort  <lutter@redhat.com>

	Change the metadata for individual files
	Record the name of the lens used to load the file in the lens node
	underneath /augeas/files/$PATH; the location info of the lens is kept in
	lens/info

	  * src/transform.c (add_file_info): change what we keep underneath the
	    lens node
	  * tests/xpath.tests (lircd-ancestor): adapt to metadata change

2010-01-08  David Lutterkort  <lutter@redhat.com>

	* src/transform.c (add_file_info): manipulate tree directly
	Going through public functions like aug_set is silly, and causes all kinds
	of string munging.

	Produce better error message for multiple matching transforms in save
	  * src/augeas.h (aug_errcode_t): new error code AUG_EMXFM
	  * src/augeas.c (errcodes): new error string for AUG_EMXFM; (tree_save):
	    report multiple transforms as proper error
	  * tests/test-save.c (testMultipleXfm): new test

	New function transform_file_error
	  * src/transfrom.h (transform_file_error): add prototype
	  * src/transform.c (transform_file_error): new function

	New function xfm_lens_name
	  * src/transfrom.h (xfm_lens_name): add prototype
	  * src/transform.c (xfm_lens_name): new function

2010-01-08  David Lutterkort  <lutter@redhat.com>

	Tree functions to find/create a node with a path expression
	Internal counterparts to aug_get and aug_set

	  * src/internal.h (tree_find, tree_find_cr): new prototypes
	  * src/augeas.c (tree_find, tree_find_cr): new functions

2010-01-08  David Lutterkort  <lutter@redhat.com>

	* src/internal.h: make various tree management functions available

2010-01-07  David Lutterkort  <lutter@redhat.com>

	Xinetd (name): fix bad '-' in character class

2010-01-06  David Lutterkort  <lutter@redhat.com>

	Do not choke on non-existing lens during save
	  * src/transform.c (add_file_info): check that lens is non-NULL;
	    (lens_from_name): provide detailed error message when lens lookup
	    failed; (transform_validate): copy error from lens_from_name into tree
	  * tests/test-save.c (testNonExistentLens): new test

	Fixes bug #98

2010-01-06  David Lutterkort  <lutter@redhat.com>

	New error code AUG_ENOLENS
	Indicates failure to look a lens up by name from /augeas/load/*/lens

	  * src/augeas.h (aug_errcode_t): new value AUG_ENOLENS
	  * src/augeas.c (errcodes): new entry for AUG_ENOLENS

2010-01-06  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (lens_release): tolerate a NULL lens

2010-01-05  Bryan Kearney  <bkearney@localhost.localdomain>

	Cobblersettings: new lens and test

2010-01-05  David Lutterkort  <lutter@redhat.com>

	Rename read_file to xread_file

2009-12-24  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (lns_make_union, lns_make_concat): do not access free'd memory
	make_lens_binop may free one of the lenses it gets passed. We can therefore
	not reference them after a call to make_lens_binop.

	* src/lens.c (format_lens): minimalistic pretty-printing of a lens

	* src/regexp.c (print_regexp): clean the regexp with fa_restrict_alphabet

2009-12-19  David Lutterkort  <lutter@redhat.com>

	* src/builtin.c (lens_get, lens_put): propagate errors as exceptions

2009-12-19  David Lutterkort  <lutter@redhat.com>

	More convenience macros for errors
	Add BUG_ON and ERR_RET macros for reporting internal errors

	  * src/errcode.h (BUG_ON, ERR_RET, HAS_ERR): new macros
	  * src/errcode.c (bug_on): implementation for BUG_ON

2009-12-18  David Lutterkort  <lutter@redhat.com>

	Lokkit: allow '-' in arguments

	Iptables: handle both negation syntaxes
	Options can be negated either with '! --option arg' or with '--option !
	arg'. We now handle both, though they lead to slightly different trees

2009-12-15  David Lutterkort  <lutter@redhat.com>

	* doc/ftdetect/augeas.vim: fix syntax

2009-12-10  Partha Aji  <paji@redhat.com>

	Made samba aug accept entry keys with ':' in them

2009-12-10  David Lutterkort  <lutter@redhat.com>

	Shellvars: allow arrays that span multiple lines

2009-12-08  David Lutterkort  <lutter@redhat.com>

	Iptables: allow quoted strings as arguments

2009-12-01  David Lutterkort  <lutter@redhat.com>

	Version 0.6.0

	Distribute and install vim syntax files
	Fixes ticket #97

	* Makefile.maint: sign tags

	Krb5: allow v4_name_convert in libdefaults section
	Fixes part of ticket #95

	Fstab: allow # in the spec
	Fixes part of ticket #95

	Group: allow empty password field
	Fixes part of ticket #95

	* src/parser.y: properly initialize yylloc
	Fixes ticket #96

2009-11-26  David Lutterkort  <lutter@redhat.com>

	Properly check regexp literals for syntax errors
	  * src/regexp.h (regexp_check): new function
	  * src/regexp.c (regexp_compile_internal): new function to base both
	    regexp_compile and regexp_check off
	  * src/syntax.c (check_value): produce a syntax error if regexp does not
	    pass regexp_check; (check_exp): make sure we do check values

	Fixes ticket #93

2009-11-26  David Lutterkort  <lutter@redhat.com>

	* src/lexer.l: include errcode.h; fix bad use of report_error

	* src/errcode.c: include stdarg.h

2009-11-26  David Lutterkort  <lutter@redhat.com>

	Cron: variable names can contain '_' etc.
	Use Shellvars.key_re for consistency.

	Fixes ticket #94

2009-11-26  Matt Palmer  <mpalmer@hezmatt.org>

	AptPreferences: add a put test
	Make sure we handle an empty file properly, and cleanup the resulting
	hassle

2009-11-25  Matt Palmer  <mpalmer@hezmatt.org>

	Normalise records so that empty lines (which are a required part of the syntax) don't creep into the tree

	Support version pins in apt_preferences

2009-11-24  David Lutterkort  <lutter@redhat.com>

	* tests/Makefile.am (lens_tests): run postfix_access tests

2009-11-17  Partha Aji  <paji@redhat.com>

	Added a Post Fix Access lens along with the unit tests

2009-11-14  David Lutterkort  <lutter@redhat.com>

	* src/lens.c (ambig_check): distinguish error between concat and iteration

	* src/regexp.c (regexp_escape): treat NULL regexps as the empty regexp

	* src/regexp.c (regexp_escape): fix stripping of enclosing parens
	Only strip them if they belong together, and not for something like /(a)(b)/

	* src/syntax.c: spew exceptions less often
	  print_value: only print exceptions that haven't been seen
	  compile_test: only print the exception for a test when it hasn't
	                been seen

	* src/get.c: never try to process a string that doesn't match
	When a string during init_regs doesn't match at all, there's nothing useful
	we can do. Immediately return an error from lns_get.

	* src/syntax.h (exn_error): produce an exception to indicate an error
	exn_error returns a special exception that indicates that an error has
	happened (e.g., out-of-memory) that has already been reported in the
	central augeas->error instance.

2009-11-13  David Lutterkort  <lutter@redhat.com>

	* src/info.c (print_info): do not choke on NULL info

	* src/internal.h: new macros MEMCMP and MEMMOVE

	* src/lens.c (lns_make_subtype): explain type derivation

